/* Rfc822.c generated by valac 0.42.5, the Vala compiler
 * generated from Rfc822.vala, do not modify */



#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <float.h>
#include <math.h>

#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



GDateTime* feed_reader_rfc822_parseDate (const gchar* str);


/**
 * Parse a date string in RFC 822 format
 * Note that we don't use Time.strptime because it uses the current locale
 * to parse month names, but RFC 822 specifically requires months to be
 * written in English.
 * See: https://www.w3.org/Protocols/rfc822/#z28
 * And: https://groups.yahoo.com/neo/groups/rss-public/conversations/topics/536
 * */
GDateTime*
feed_reader_rfc822_parseDate (const gchar* str)
{
	GDateTime* result = NULL;
	GRegex* re = NULL;
	GMatchInfo* info = NULL;
	GRegex* _tmp6_;
	GMatchInfo* _tmp7_ = NULL;
	gboolean _tmp8_;
	gchar* dayStr = NULL;
	GMatchInfo* _tmp9_;
	gchar* _tmp10_;
	gint day = 0;
	const gchar* _tmp11_;
	gchar* monthStr = NULL;
	GMatchInfo* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gint month = 0;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	GQuark _tmp20_ = 0U;
#line 50 "../src/Rfc822.vala"
	static GQuark _tmp19_label0 = 0;
#line 50 "../src/Rfc822.vala"
	static GQuark _tmp19_label1 = 0;
#line 50 "../src/Rfc822.vala"
	static GQuark _tmp19_label2 = 0;
#line 50 "../src/Rfc822.vala"
	static GQuark _tmp19_label3 = 0;
#line 50 "../src/Rfc822.vala"
	static GQuark _tmp19_label4 = 0;
#line 50 "../src/Rfc822.vala"
	static GQuark _tmp19_label5 = 0;
#line 50 "../src/Rfc822.vala"
	static GQuark _tmp19_label6 = 0;
#line 50 "../src/Rfc822.vala"
	static GQuark _tmp19_label7 = 0;
#line 50 "../src/Rfc822.vala"
	static GQuark _tmp19_label8 = 0;
#line 50 "../src/Rfc822.vala"
	static GQuark _tmp19_label9 = 0;
#line 50 "../src/Rfc822.vala"
	static GQuark _tmp19_label10 = 0;
#line 50 "../src/Rfc822.vala"
	static GQuark _tmp19_label11 = 0;
#line 86 "Rfc822.c"
	gchar* yearStr = NULL;
	GMatchInfo* _tmp21_;
	gchar* _tmp22_;
	gint year = 0;
	const gchar* _tmp23_;
	gboolean _tmp24_ = FALSE;
	gint _tmp25_;
	gchar* hourStr = NULL;
	GMatchInfo* _tmp32_;
	gchar* _tmp33_;
	gint hour = 0;
	const gchar* _tmp34_;
	gchar* minuteStr = NULL;
	GMatchInfo* _tmp35_;
	gchar* _tmp36_;
	gint minute = 0;
	const gchar* _tmp37_;
	gchar* secondStr = NULL;
	GMatchInfo* _tmp38_;
	gchar* _tmp39_;
	gint _tmp40_ = 0;
	gboolean _tmp41_ = FALSE;
	const gchar* _tmp42_;
	gint second = 0;
	gchar* zoneStr = NULL;
	GMatchInfo* _tmp45_;
	gchar* _tmp46_;
	GTimeZone* zone = NULL;
	const gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	GQuark _tmp51_ = 0U;
#line 110 "../src/Rfc822.vala"
	static GQuark _tmp50_label0 = 0;
#line 110 "../src/Rfc822.vala"
	static GQuark _tmp50_label1 = 0;
#line 110 "../src/Rfc822.vala"
	static GQuark _tmp50_label2 = 0;
#line 110 "../src/Rfc822.vala"
	static GQuark _tmp50_label3 = 0;
#line 110 "../src/Rfc822.vala"
	static GQuark _tmp50_label4 = 0;
#line 110 "../src/Rfc822.vala"
	static GQuark _tmp50_label5 = 0;
#line 110 "../src/Rfc822.vala"
	static GQuark _tmp50_label6 = 0;
#line 110 "../src/Rfc822.vala"
	static GQuark _tmp50_label7 = 0;
#line 110 "../src/Rfc822.vala"
	static GQuark _tmp50_label8 = 0;
#line 110 "../src/Rfc822.vala"
	static GQuark _tmp50_label9 = 0;
#line 110 "../src/Rfc822.vala"
	static GQuark _tmp50_label10 = 0;
#line 141 "Rfc822.c"
	GTimeZone* _tmp60_;
	gint _tmp61_;
	gint _tmp62_;
	gint _tmp63_;
	gint _tmp64_;
	gint _tmp65_;
	gint _tmp66_;
	GDateTime* _tmp67_;
	GError * _inner_error_ = NULL;
#line 13 "../src/Rfc822.vala"
	if (str == NULL) {
#line 14 "../src/Rfc822.vala"
		result = NULL;
#line 14 "../src/Rfc822.vala"
		return result;
#line 157 "Rfc822.c"
	}
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
#line 18 "../src/Rfc822.vala"
		_tmp1_ = g_regex_new ("\n" \
"\t\t\t\t# We don't care about the day of the week\n" \
"\t\t\t\t\\s*(?:(?:Mon|Tue|Wed|Thu|Fri|Sat|Sun),\\s*)?\n" \
"\t\t\t\t(?<day>\\d{1,2})\\s+\n" \
"\t\t\t\t(?<month>Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\\s+\n" \
"\t\t\t\t# The standard specifies 2-digit years but 4 digit years are\n" \
"\t\t\t\t# recommended now.\n" \
"\t\t\t\t# This pattern will also accept 3-digit years, so we'll have t" \
"o\n" \
"\t\t\t\t# check for that separately\n" \
"\t\t\t\t(?<year>\\d{2,4})\\s+\n" \
"\t\t\t\t(?<hour>\\d{2})\n" \
"\t\t\t\t:(?<minute>\\d{2})\n" \
"\t\t\t\t(?::(?<second>\\d{2}))?\\s+\n" \
"\t\t\t\t(?<zone>UT|GMT|EST|EDT|MST|MDT|PST|PDT|[A-Z]|(?:[+-]\\d{4}))\n" \
"\t\t\t\t", G_REGEX_CASELESS | G_REGEX_EXTENDED, G_REGEX_MATCH_ANCHORED, &_inner_error_);
#line 18 "../src/Rfc822.vala"
		_tmp0_ = _tmp1_;
#line 18 "../src/Rfc822.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 18 "../src/Rfc822.vala"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 171 "Rfc822.c"
				goto __catch34_g_regex_error;
			}
#line 18 "../src/Rfc822.vala"
			_g_regex_unref0 (re);
#line 18 "../src/Rfc822.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 18 "../src/Rfc822.vala"
			g_clear_error (&_inner_error_);
#line 18 "../src/Rfc822.vala"
			return NULL;
#line 182 "Rfc822.c"
		}
#line 18 "../src/Rfc822.vala"
		_tmp2_ = _tmp0_;
#line 18 "../src/Rfc822.vala"
		_tmp0_ = NULL;
#line 18 "../src/Rfc822.vala"
		_g_regex_unref0 (re);
#line 18 "../src/Rfc822.vala"
		re = _tmp2_;
#line 17 "../src/Rfc822.vala"
		_g_regex_unref0 (_tmp0_);
#line 194 "Rfc822.c"
	}
	goto __finally34;
	__catch34_g_regex_error:
	{
		GError* e = NULL;
		FILE* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 17 "../src/Rfc822.vala"
		e = _inner_error_;
#line 17 "../src/Rfc822.vala"
		_inner_error_ = NULL;
#line 36 "../src/Rfc822.vala"
		_tmp3_ = stderr;
#line 36 "../src/Rfc822.vala"
		_tmp4_ = e;
#line 36 "../src/Rfc822.vala"
		_tmp5_ = _tmp4_->message;
#line 36 "../src/Rfc822.vala"
		fprintf (_tmp3_, "RFC822 regex failed to parse: %s\n", _tmp5_);
#line 37 "../src/Rfc822.vala"
		_vala_assert (FALSE, "false");
#line 38 "../src/Rfc822.vala"
		result = NULL;
#line 38 "../src/Rfc822.vala"
		_g_error_free0 (e);
#line 38 "../src/Rfc822.vala"
		_g_regex_unref0 (re);
#line 38 "../src/Rfc822.vala"
		return result;
#line 225 "Rfc822.c"
	}
	__finally34:
#line 17 "../src/Rfc822.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 17 "../src/Rfc822.vala"
		_g_regex_unref0 (re);
#line 17 "../src/Rfc822.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 17 "../src/Rfc822.vala"
		g_clear_error (&_inner_error_);
#line 17 "../src/Rfc822.vala"
		return NULL;
#line 238 "Rfc822.c"
	}
#line 42 "../src/Rfc822.vala"
	_tmp6_ = re;
#line 42 "../src/Rfc822.vala"
	_tmp8_ = g_regex_match (_tmp6_, str, 0, &_tmp7_);
#line 42 "../src/Rfc822.vala"
	_g_match_info_unref0 (info);
#line 42 "../src/Rfc822.vala"
	info = _tmp7_;
#line 42 "../src/Rfc822.vala"
	if (!_tmp8_) {
#line 43 "../src/Rfc822.vala"
		result = NULL;
#line 43 "../src/Rfc822.vala"
		_g_match_info_unref0 (info);
#line 43 "../src/Rfc822.vala"
		_g_regex_unref0 (re);
#line 43 "../src/Rfc822.vala"
		return result;
#line 258 "Rfc822.c"
	}
#line 45 "../src/Rfc822.vala"
	_tmp9_ = info;
#line 45 "../src/Rfc822.vala"
	_tmp10_ = g_match_info_fetch_named (_tmp9_, "day");
#line 45 "../src/Rfc822.vala"
	dayStr = _tmp10_;
#line 46 "../src/Rfc822.vala"
	_tmp11_ = dayStr;
#line 46 "../src/Rfc822.vala"
	day = atoi (_tmp11_);
#line 48 "../src/Rfc822.vala"
	_tmp12_ = info;
#line 48 "../src/Rfc822.vala"
	_tmp13_ = g_match_info_fetch_named (_tmp12_, "month");
#line 48 "../src/Rfc822.vala"
	_tmp14_ = _tmp13_;
#line 48 "../src/Rfc822.vala"
	_tmp15_ = g_ascii_strdown (_tmp14_, (gssize) -1);
#line 48 "../src/Rfc822.vala"
	_tmp16_ = _tmp15_;
#line 48 "../src/Rfc822.vala"
	_g_free0 (_tmp14_);
#line 48 "../src/Rfc822.vala"
	monthStr = _tmp16_;
#line 50 "../src/Rfc822.vala"
	_tmp17_ = monthStr;
#line 50 "../src/Rfc822.vala"
	_tmp18_ = _tmp17_;
#line 50 "../src/Rfc822.vala"
	_tmp20_ = (NULL == _tmp18_) ? 0 : g_quark_from_string (_tmp18_);
#line 50 "../src/Rfc822.vala"
	if (_tmp20_ == ((0 != _tmp19_label0) ? _tmp19_label0 : (_tmp19_label0 = g_quark_from_static_string ("jan")))) {
#line 50 "../src/Rfc822.vala"
		switch (0) {
#line 294 "Rfc822.c"
			default:
			{
#line 52 "../src/Rfc822.vala"
				month = 1;
#line 53 "../src/Rfc822.vala"
				break;
#line 301 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label1) ? _tmp19_label1 : (_tmp19_label1 = g_quark_from_static_string ("feb")))) {
#line 50 "../src/Rfc822.vala"
		switch (0) {
#line 307 "Rfc822.c"
			default:
			{
#line 55 "../src/Rfc822.vala"
				month = 2;
#line 56 "../src/Rfc822.vala"
				break;
#line 314 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label2) ? _tmp19_label2 : (_tmp19_label2 = g_quark_from_static_string ("mar")))) {
#line 50 "../src/Rfc822.vala"
		switch (0) {
#line 320 "Rfc822.c"
			default:
			{
#line 58 "../src/Rfc822.vala"
				month = 3;
#line 59 "../src/Rfc822.vala"
				break;
#line 327 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label3) ? _tmp19_label3 : (_tmp19_label3 = g_quark_from_static_string ("apr")))) {
#line 50 "../src/Rfc822.vala"
		switch (0) {
#line 333 "Rfc822.c"
			default:
			{
#line 61 "../src/Rfc822.vala"
				month = 4;
#line 62 "../src/Rfc822.vala"
				break;
#line 340 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label4) ? _tmp19_label4 : (_tmp19_label4 = g_quark_from_static_string ("may")))) {
#line 50 "../src/Rfc822.vala"
		switch (0) {
#line 346 "Rfc822.c"
			default:
			{
#line 64 "../src/Rfc822.vala"
				month = 5;
#line 65 "../src/Rfc822.vala"
				break;
#line 353 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label5) ? _tmp19_label5 : (_tmp19_label5 = g_quark_from_static_string ("jun")))) {
#line 50 "../src/Rfc822.vala"
		switch (0) {
#line 359 "Rfc822.c"
			default:
			{
#line 67 "../src/Rfc822.vala"
				month = 6;
#line 68 "../src/Rfc822.vala"
				break;
#line 366 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label6) ? _tmp19_label6 : (_tmp19_label6 = g_quark_from_static_string ("jul")))) {
#line 50 "../src/Rfc822.vala"
		switch (0) {
#line 372 "Rfc822.c"
			default:
			{
#line 70 "../src/Rfc822.vala"
				month = 7;
#line 71 "../src/Rfc822.vala"
				break;
#line 379 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label7) ? _tmp19_label7 : (_tmp19_label7 = g_quark_from_static_string ("aug")))) {
#line 50 "../src/Rfc822.vala"
		switch (0) {
#line 385 "Rfc822.c"
			default:
			{
#line 73 "../src/Rfc822.vala"
				month = 8;
#line 74 "../src/Rfc822.vala"
				break;
#line 392 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label8) ? _tmp19_label8 : (_tmp19_label8 = g_quark_from_static_string ("sep")))) {
#line 50 "../src/Rfc822.vala"
		switch (0) {
#line 398 "Rfc822.c"
			default:
			{
#line 76 "../src/Rfc822.vala"
				month = 9;
#line 77 "../src/Rfc822.vala"
				break;
#line 405 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label9) ? _tmp19_label9 : (_tmp19_label9 = g_quark_from_static_string ("oct")))) {
#line 50 "../src/Rfc822.vala"
		switch (0) {
#line 411 "Rfc822.c"
			default:
			{
#line 79 "../src/Rfc822.vala"
				month = 10;
#line 80 "../src/Rfc822.vala"
				break;
#line 418 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label10) ? _tmp19_label10 : (_tmp19_label10 = g_quark_from_static_string ("nov")))) {
#line 50 "../src/Rfc822.vala"
		switch (0) {
#line 424 "Rfc822.c"
			default:
			{
#line 82 "../src/Rfc822.vala"
				month = 11;
#line 83 "../src/Rfc822.vala"
				break;
#line 431 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label11) ? _tmp19_label11 : (_tmp19_label11 = g_quark_from_static_string ("dec")))) {
#line 50 "../src/Rfc822.vala"
		switch (0) {
#line 437 "Rfc822.c"
			default:
			{
#line 85 "../src/Rfc822.vala"
				month = 12;
#line 86 "../src/Rfc822.vala"
				break;
#line 444 "Rfc822.c"
			}
		}
	} else {
#line 50 "../src/Rfc822.vala"
		switch (0) {
#line 450 "Rfc822.c"
			default:
			{
#line 89 "../src/Rfc822.vala"
				_vala_assert (FALSE, "false");
#line 90 "../src/Rfc822.vala"
				result = NULL;
#line 90 "../src/Rfc822.vala"
				_g_free0 (monthStr);
#line 90 "../src/Rfc822.vala"
				_g_free0 (dayStr);
#line 90 "../src/Rfc822.vala"
				_g_match_info_unref0 (info);
#line 90 "../src/Rfc822.vala"
				_g_regex_unref0 (re);
#line 90 "../src/Rfc822.vala"
				return result;
#line 467 "Rfc822.c"
			}
		}
	}
#line 93 "../src/Rfc822.vala"
	_tmp21_ = info;
#line 93 "../src/Rfc822.vala"
	_tmp22_ = g_match_info_fetch_named (_tmp21_, "year");
#line 93 "../src/Rfc822.vala"
	yearStr = _tmp22_;
#line 94 "../src/Rfc822.vala"
	_tmp23_ = yearStr;
#line 94 "../src/Rfc822.vala"
	year = atoi (_tmp23_);
#line 96 "../src/Rfc822.vala"
	_tmp25_ = year;
#line 96 "../src/Rfc822.vala"
	if (_tmp25_ >= 0) {
#line 485 "Rfc822.c"
		gint _tmp26_;
#line 96 "../src/Rfc822.vala"
		_tmp26_ = year;
#line 96 "../src/Rfc822.vala"
		_tmp24_ = _tmp26_ <= 49;
#line 491 "Rfc822.c"
	} else {
#line 96 "../src/Rfc822.vala"
		_tmp24_ = FALSE;
#line 495 "Rfc822.c"
	}
#line 96 "../src/Rfc822.vala"
	if (_tmp24_) {
#line 499 "Rfc822.c"
		gint _tmp27_;
#line 97 "../src/Rfc822.vala"
		_tmp27_ = year;
#line 97 "../src/Rfc822.vala"
		year = _tmp27_ + 2000;
#line 505 "Rfc822.c"
	} else {
		gboolean _tmp28_ = FALSE;
		gint _tmp29_;
#line 99 "../src/Rfc822.vala"
		_tmp29_ = year;
#line 99 "../src/Rfc822.vala"
		if (_tmp29_ >= 50) {
#line 513 "Rfc822.c"
			gint _tmp30_;
#line 99 "../src/Rfc822.vala"
			_tmp30_ = year;
#line 99 "../src/Rfc822.vala"
			_tmp28_ = _tmp30_ < 100;
#line 519 "Rfc822.c"
		} else {
#line 99 "../src/Rfc822.vala"
			_tmp28_ = FALSE;
#line 523 "Rfc822.c"
		}
#line 99 "../src/Rfc822.vala"
		if (_tmp28_) {
#line 527 "Rfc822.c"
			gint _tmp31_;
#line 100 "../src/Rfc822.vala"
			_tmp31_ = year;
#line 100 "../src/Rfc822.vala"
			year = _tmp31_ + 1900;
#line 533 "Rfc822.c"
		}
	}
#line 101 "../src/Rfc822.vala"
	_tmp32_ = info;
#line 101 "../src/Rfc822.vala"
	_tmp33_ = g_match_info_fetch_named (_tmp32_, "hour");
#line 101 "../src/Rfc822.vala"
	hourStr = _tmp33_;
#line 102 "../src/Rfc822.vala"
	_tmp34_ = hourStr;
#line 102 "../src/Rfc822.vala"
	hour = atoi (_tmp34_);
#line 103 "../src/Rfc822.vala"
	_tmp35_ = info;
#line 103 "../src/Rfc822.vala"
	_tmp36_ = g_match_info_fetch_named (_tmp35_, "minute");
#line 103 "../src/Rfc822.vala"
	minuteStr = _tmp36_;
#line 104 "../src/Rfc822.vala"
	_tmp37_ = minuteStr;
#line 104 "../src/Rfc822.vala"
	minute = atoi (_tmp37_);
#line 105 "../src/Rfc822.vala"
	_tmp38_ = info;
#line 105 "../src/Rfc822.vala"
	_tmp39_ = g_match_info_fetch_named (_tmp38_, "second");
#line 105 "../src/Rfc822.vala"
	secondStr = _tmp39_;
#line 106 "../src/Rfc822.vala"
	_tmp42_ = secondStr;
#line 106 "../src/Rfc822.vala"
	if (_tmp42_ == NULL) {
#line 106 "../src/Rfc822.vala"
		_tmp41_ = TRUE;
#line 568 "Rfc822.c"
	} else {
		const gchar* _tmp43_;
#line 106 "../src/Rfc822.vala"
		_tmp43_ = secondStr;
#line 106 "../src/Rfc822.vala"
		_tmp41_ = g_strcmp0 (_tmp43_, "") == 0;
#line 575 "Rfc822.c"
	}
#line 106 "../src/Rfc822.vala"
	if (_tmp41_) {
#line 106 "../src/Rfc822.vala"
		_tmp40_ = 0;
#line 581 "Rfc822.c"
	} else {
		const gchar* _tmp44_;
#line 106 "../src/Rfc822.vala"
		_tmp44_ = secondStr;
#line 106 "../src/Rfc822.vala"
		_tmp40_ = atoi (_tmp44_);
#line 588 "Rfc822.c"
	}
#line 106 "../src/Rfc822.vala"
	second = _tmp40_;
#line 108 "../src/Rfc822.vala"
	_tmp45_ = info;
#line 108 "../src/Rfc822.vala"
	_tmp46_ = g_match_info_fetch_named (_tmp45_, "zone");
#line 108 "../src/Rfc822.vala"
	zoneStr = _tmp46_;
#line 110 "../src/Rfc822.vala"
	_tmp47_ = zoneStr;
#line 110 "../src/Rfc822.vala"
	_tmp48_ = g_ascii_strup (_tmp47_, (gssize) -1);
#line 110 "../src/Rfc822.vala"
	_tmp49_ = _tmp48_;
#line 110 "../src/Rfc822.vala"
	_tmp51_ = (NULL == _tmp49_) ? 0 : g_quark_from_string (_tmp49_);
#line 110 "../src/Rfc822.vala"
	g_free (_tmp49_);
#line 110 "../src/Rfc822.vala"
	if (_tmp51_ == ((0 != _tmp50_label0) ? _tmp50_label0 : (_tmp50_label0 = g_quark_from_static_string ("EDT")))) {
#line 110 "../src/Rfc822.vala"
		switch (0) {
#line 612 "Rfc822.c"
			default:
			{
				GTimeZone* _tmp52_;
#line 114 "../src/Rfc822.vala"
				_tmp52_ = g_time_zone_new ("-04");
#line 114 "../src/Rfc822.vala"
				_g_time_zone_unref0 (zone);
#line 114 "../src/Rfc822.vala"
				zone = _tmp52_;
#line 115 "../src/Rfc822.vala"
				break;
#line 624 "Rfc822.c"
			}
		}
	} else if ((_tmp51_ == ((0 != _tmp50_label1) ? _tmp50_label1 : (_tmp50_label1 = g_quark_from_static_string ("CDT")))) || (_tmp51_ == ((0 != _tmp50_label2) ? _tmp50_label2 : (_tmp50_label2 = g_quark_from_static_string ("EST"))))) {
#line 110 "../src/Rfc822.vala"
		switch (0) {
#line 630 "Rfc822.c"
			default:
			{
				GTimeZone* _tmp53_;
#line 118 "../src/Rfc822.vala"
				_tmp53_ = g_time_zone_new ("-05");
#line 118 "../src/Rfc822.vala"
				_g_time_zone_unref0 (zone);
#line 118 "../src/Rfc822.vala"
				zone = _tmp53_;
#line 119 "../src/Rfc822.vala"
				break;
#line 642 "Rfc822.c"
			}
		}
	} else if ((_tmp51_ == ((0 != _tmp50_label3) ? _tmp50_label3 : (_tmp50_label3 = g_quark_from_static_string ("CST")))) || (_tmp51_ == ((0 != _tmp50_label4) ? _tmp50_label4 : (_tmp50_label4 = g_quark_from_static_string ("MDT"))))) {
#line 110 "../src/Rfc822.vala"
		switch (0) {
#line 648 "Rfc822.c"
			default:
			{
				GTimeZone* _tmp54_;
#line 122 "../src/Rfc822.vala"
				_tmp54_ = g_time_zone_new ("-06");
#line 122 "../src/Rfc822.vala"
				_g_time_zone_unref0 (zone);
#line 122 "../src/Rfc822.vala"
				zone = _tmp54_;
#line 123 "../src/Rfc822.vala"
				break;
#line 660 "Rfc822.c"
			}
		}
	} else if ((_tmp51_ == ((0 != _tmp50_label5) ? _tmp50_label5 : (_tmp50_label5 = g_quark_from_static_string ("MST")))) || (_tmp51_ == ((0 != _tmp50_label6) ? _tmp50_label6 : (_tmp50_label6 = g_quark_from_static_string ("PDT"))))) {
#line 110 "../src/Rfc822.vala"
		switch (0) {
#line 666 "Rfc822.c"
			default:
			{
				GTimeZone* _tmp55_;
#line 126 "../src/Rfc822.vala"
				_tmp55_ = g_time_zone_new ("-07");
#line 126 "../src/Rfc822.vala"
				_g_time_zone_unref0 (zone);
#line 126 "../src/Rfc822.vala"
				zone = _tmp55_;
#line 127 "../src/Rfc822.vala"
				break;
#line 678 "Rfc822.c"
			}
		}
	} else if (_tmp51_ == ((0 != _tmp50_label7) ? _tmp50_label7 : (_tmp50_label7 = g_quark_from_static_string ("PST")))) {
#line 110 "../src/Rfc822.vala"
		switch (0) {
#line 684 "Rfc822.c"
			default:
			{
				GTimeZone* _tmp56_;
#line 129 "../src/Rfc822.vala"
				_tmp56_ = g_time_zone_new ("-08");
#line 129 "../src/Rfc822.vala"
				_g_time_zone_unref0 (zone);
#line 129 "../src/Rfc822.vala"
				zone = _tmp56_;
#line 130 "../src/Rfc822.vala"
				break;
#line 696 "Rfc822.c"
			}
		}
	} else if (((_tmp51_ == ((0 != _tmp50_label8) ? _tmp50_label8 : (_tmp50_label8 = g_quark_from_static_string ("GMT")))) || (_tmp51_ == ((0 != _tmp50_label9) ? _tmp50_label9 : (_tmp50_label9 = g_quark_from_static_string ("UT"))))) || (_tmp51_ == ((0 != _tmp50_label10) ? _tmp50_label10 : (_tmp50_label10 = g_quark_from_static_string ("Z"))))) {
#line 110 "../src/Rfc822.vala"
		switch (0) {
#line 702 "Rfc822.c"
			default:
			{
				GTimeZone* _tmp57_;
#line 135 "../src/Rfc822.vala"
				_tmp57_ = g_time_zone_new_utc ();
#line 135 "../src/Rfc822.vala"
				_g_time_zone_unref0 (zone);
#line 135 "../src/Rfc822.vala"
				zone = _tmp57_;
#line 136 "../src/Rfc822.vala"
				break;
#line 714 "Rfc822.c"
			}
		}
	} else {
#line 110 "../src/Rfc822.vala"
		switch (0) {
#line 720 "Rfc822.c"
			default:
			{
				const gchar* _tmp58_;
				GTimeZone* _tmp59_;
#line 138 "../src/Rfc822.vala"
				_tmp58_ = zoneStr;
#line 138 "../src/Rfc822.vala"
				_tmp59_ = g_time_zone_new (_tmp58_);
#line 138 "../src/Rfc822.vala"
				_g_time_zone_unref0 (zone);
#line 138 "../src/Rfc822.vala"
				zone = _tmp59_;
#line 139 "../src/Rfc822.vala"
				break;
#line 735 "Rfc822.c"
			}
		}
	}
#line 142 "../src/Rfc822.vala"
	_tmp60_ = zone;
#line 142 "../src/Rfc822.vala"
	_tmp61_ = year;
#line 142 "../src/Rfc822.vala"
	_tmp62_ = month;
#line 142 "../src/Rfc822.vala"
	_tmp63_ = day;
#line 142 "../src/Rfc822.vala"
	_tmp64_ = hour;
#line 142 "../src/Rfc822.vala"
	_tmp65_ = minute;
#line 142 "../src/Rfc822.vala"
	_tmp66_ = second;
#line 142 "../src/Rfc822.vala"
	_tmp67_ = g_date_time_new (_tmp60_, _tmp61_, _tmp62_, _tmp63_, _tmp64_, _tmp65_, (gdouble) _tmp66_);
#line 142 "../src/Rfc822.vala"
	result = _tmp67_;
#line 142 "../src/Rfc822.vala"
	_g_time_zone_unref0 (zone);
#line 142 "../src/Rfc822.vala"
	_g_free0 (zoneStr);
#line 142 "../src/Rfc822.vala"
	_g_free0 (secondStr);
#line 142 "../src/Rfc822.vala"
	_g_free0 (minuteStr);
#line 142 "../src/Rfc822.vala"
	_g_free0 (hourStr);
#line 142 "../src/Rfc822.vala"
	_g_free0 (yearStr);
#line 142 "../src/Rfc822.vala"
	_g_free0 (monthStr);
#line 142 "../src/Rfc822.vala"
	_g_free0 (dayStr);
#line 142 "../src/Rfc822.vala"
	_g_match_info_unref0 (info);
#line 142 "../src/Rfc822.vala"
	_g_regex_unref0 (re);
#line 142 "../src/Rfc822.vala"
	return result;
#line 779 "Rfc822.c"
}



