/* MediaPlayer.c generated by valac 0.42.5, the Vala compiler
 * generated from MediaPlayer.vala, do not modify */

/*This file is part of FeedReader.*/
/**/
/*FeedReader is free software: you can redistribute it and/or modify*/
/*it under the terms of the GNU General Public License as published by*/
/*the Free Software Foundation, either version 3 of the License, or*/
/*(at your option) any later version.*/
/**/
/*FeedReader is distributed in the hope that it will be useful,*/
/*but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*GNU General Public License for more details.*/
/**/
/*You should have received a copy of the GNU General Public License*/
/*along with FeedReader.  If not, see <http://www.gnu.org/licenses/>.*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gst/gst.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gst/pbutils/pbutils.h>
#include <cairo.h>


#define FEED_READER_TYPE_MEDIA_PLAYER (feed_reader_media_player_get_type ())
#define FEED_READER_MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayer))
#define FEED_READER_MEDIA_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayerClass))
#define FEED_READER_IS_MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FEED_READER_TYPE_MEDIA_PLAYER))
#define FEED_READER_IS_MEDIA_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FEED_READER_TYPE_MEDIA_PLAYER))
#define FEED_READER_MEDIA_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayerClass))

typedef struct _FeedReaderMediaPlayer FeedReaderMediaPlayer;
typedef struct _FeedReaderMediaPlayerClass FeedReaderMediaPlayerClass;
typedef struct _FeedReaderMediaPlayerPrivate FeedReaderMediaPlayerPrivate;
typedef enum  {
	FEED_READER_MEDIA_TYPE_VIDEO,
	FEED_READER_MEDIA_TYPE_AUDIO
} FeedReaderMediaType;


#define FEED_READER_TYPE_MEDIA_TYPE (feed_reader_media_type_get_type ())
typedef enum  {
	FEED_READER_DISPLAY_POSITION_ALL,
	FEED_READER_DISPLAY_POSITION_POS,
	FEED_READER_DISPLAY_POSITION_LEFT
} FeedReaderDisplayPosition;


#define FEED_READER_TYPE_DISPLAY_POSITION (feed_reader_display_position_get_type ())
enum  {
	FEED_READER_MEDIA_PLAYER_0_PROPERTY,
	FEED_READER_MEDIA_PLAYER_NUM_PROPERTIES
};
static GParamSpec* feed_reader_media_player_properties[FEED_READER_MEDIA_PLAYER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block27Data Block27Data;
enum  {
	FEED_READER_MEDIA_PLAYER_LOADED_SIGNAL,
	FEED_READER_MEDIA_PLAYER_NUM_SIGNALS
};
static guint feed_reader_media_player_signals[FEED_READER_MEDIA_PLAYER_NUM_SIGNALS] = {0};

struct _FeedReaderMediaPlayer {
	GtkBox parent_instance;
	FeedReaderMediaPlayerPrivate * priv;
};

struct _FeedReaderMediaPlayerClass {
	GtkBoxClass parent_class;
};

struct _FeedReaderMediaPlayerPrivate {
	GstElement* m_player;
	GtkWidget* m_videoWidget;
	GtkStack* m_playStack;
	GtkButton* m_playButton;
	GtkSpinner* m_playSpinner;
	GtkButton* m_muteButton;
	GtkButton* m_closeButton;
	GtkScale* m_scale;
	GtkButton* m_labelButton;
	GtkLabel* m_bufferLabel;
	gint m_margin;
	GtkImage* m_playIcon;
	GtkImage* m_pauseIcon;
	GtkImage* m_muteIcon;
	GtkImage* m_noiseIcon;
	GtkImage* m_closeIcon;
	gboolean m_muted;
	gdouble m_aspectRatio;
	guint m_seek_source_id;
	FeedReaderMediaType m_type;
	gchar* m_URL;
	FeedReaderDisplayPosition m_display;
};

struct _Block27Data {
	int _ref_count_;
	FeedReaderMediaPlayer* self;
	gdouble startValue;
};


static gint FeedReaderMediaPlayer_private_offset;
static gpointer feed_reader_media_player_parent_class = NULL;

GType feed_reader_media_player_get_type (void) G_GNUC_CONST;
GType feed_reader_media_type_get_type (void) G_GNUC_CONST;
GType feed_reader_display_position_get_type (void) G_GNUC_CONST;
FeedReaderMediaPlayer* feed_reader_media_player_new (const gchar* url);
FeedReaderMediaPlayer* feed_reader_media_player_construct (GType object_type,
                                                           const gchar* url);
static void feed_reader_media_player_inspectMedia (FeedReaderMediaPlayer* self);
static void feed_reader_media_player_buildUI (FeedReaderMediaPlayer* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void feed_reader_logger_error (const gchar* message);
static void feed_reader_media_player_onAllocation (FeedReaderMediaPlayer* self,
                                            GtkAllocation* allocation);
static void _feed_reader_media_player_onAllocation_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                      GtkAllocation* allocation,
                                                                      gpointer self);
static gboolean feed_reader_media_player_busCallback (FeedReaderMediaPlayer* self,
                                               GstBus* bus,
                                               GstMessage* message);
static gboolean _feed_reader_media_player_busCallback_gst_bus_func (GstBus* bus,
                                                             GstMessage* message,
                                                             gpointer self);
static gboolean __lambda95_ (FeedReaderMediaPlayer* self);
static void feed_reader_media_player_calcTime (FeedReaderMediaPlayer* self);
static gboolean ___lambda95__gsource_func (gpointer self);
static void feed_reader_media_player_togglePause (FeedReaderMediaPlayer* self);
static void _feed_reader_media_player_togglePause_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self);
#define FEED_READER_MEDIA_BUTTON_PLAY "Play"
#define FEED_READER_MEDIA_BUTTON_MUTE "Mute"
static void feed_reader_media_player_toggleMute (FeedReaderMediaPlayer* self);
static void _feed_reader_media_player_toggleMute_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void __lambda96_ (FeedReaderMediaPlayer* self);
void feed_reader_media_player_kill (FeedReaderMediaPlayer* self);
static void ___lambda96__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
#define FEED_READER_MEDIA_BUTTON_CLOSE "Close"
static gboolean feed_reader_media_player_valueChanged (FeedReaderMediaPlayer* self,
                                                GtkScrollType scroll,
                                                gdouble new_value);
static gboolean _feed_reader_media_player_valueChanged_gtk_range_change_value (GtkRange* _sender,
                                                                        GtkScrollType scroll,
                                                                        gdouble new_value,
                                                                        gpointer self);
static void feed_reader_media_player_switchDisplay (FeedReaderMediaPlayer* self);
static void _feed_reader_media_player_switchDisplay_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
#define FEED_READER_MEDIA_BUTTON_PAUSE "Pause"
static gdouble* _double_dup (gdouble* self);
static Block27Data* block27_data_ref (Block27Data* _data27_);
static void block27_data_unref (void * _userdata_);
static gboolean ___lambda97_ (Block27Data* _data27_);
static void feed_reader_media_player_seek (FeedReaderMediaPlayer* self,
                                    gdouble new_value);
static gboolean ____lambda97__gsource_func (gpointer self);
#define FEED_READER_MEDIA_BUTTON_UNMUTE "Unmute"
static void feed_reader_media_player_finalize (GObject * obj);


static inline gpointer
feed_reader_media_player_get_instance_private (FeedReaderMediaPlayer* self)
{
	return G_STRUCT_MEMBER_P (self, FeedReaderMediaPlayer_private_offset);
}


FeedReaderMediaPlayer*
feed_reader_media_player_construct (GType object_type,
                                    const gchar* url)
{
	FeedReaderMediaPlayer * self = NULL;
	gchar* _tmp0_;
#line 42 "../src/Widgets/MediaPlayer.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 42 "../src/Widgets/MediaPlayer.vala"
	self = (FeedReaderMediaPlayer*) g_object_new (object_type, NULL);
#line 44 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_type = FEED_READER_MEDIA_TYPE_AUDIO;
#line 45 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = g_strdup (url);
#line 45 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (self->priv->m_URL);
#line 45 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_URL = _tmp0_;
#line 47 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_inspectMedia (self);
#line 48 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_buildUI (self);
#line 49 "../src/Widgets/MediaPlayer.vala"
	g_signal_emit (self, feed_reader_media_player_signals[FEED_READER_MEDIA_PLAYER_LOADED_SIGNAL], 0);
#line 42 "../src/Widgets/MediaPlayer.vala"
	return self;
#line 210 "MediaPlayer.c"
}


FeedReaderMediaPlayer*
feed_reader_media_player_new (const gchar* url)
{
#line 42 "../src/Widgets/MediaPlayer.vala"
	return feed_reader_media_player_construct (FEED_READER_TYPE_MEDIA_PLAYER, url);
#line 219 "MediaPlayer.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 59 "../src/Widgets/MediaPlayer.vala"
	return self ? g_object_ref (self) : NULL;
#line 228 "MediaPlayer.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 59 "../src/Widgets/MediaPlayer.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 237 "MediaPlayer.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 59 "../src/Widgets/MediaPlayer.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 246 "MediaPlayer.c"
}


static void
feed_reader_media_player_inspectMedia (FeedReaderMediaPlayer* self)
{
	GError * _inner_error_ = NULL;
#line 52 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 256 "MediaPlayer.c"
	{
		GstDiscoverer* discoverer = NULL;
		GstDiscoverer* _tmp0_;
		GstDiscovererInfo* info = NULL;
		GstDiscoverer* _tmp1_;
		const gchar* _tmp2_;
		GstDiscovererInfo* _tmp3_;
		GstDiscovererInfo* _tmp4_;
		GList* _tmp5_;
#line 56 "../src/Widgets/MediaPlayer.vala"
		_tmp0_ = gst_discoverer_new ((GstClockTime) (10 * GST_SECOND), &_inner_error_);
#line 56 "../src/Widgets/MediaPlayer.vala"
		discoverer = _tmp0_;
#line 56 "../src/Widgets/MediaPlayer.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 272 "MediaPlayer.c"
			goto __catch29_g_error;
		}
#line 57 "../src/Widgets/MediaPlayer.vala"
		_tmp1_ = discoverer;
#line 57 "../src/Widgets/MediaPlayer.vala"
		_tmp2_ = self->priv->m_URL;
#line 57 "../src/Widgets/MediaPlayer.vala"
		_tmp3_ = gst_discoverer_discover_uri (_tmp1_, _tmp2_, &_inner_error_);
#line 57 "../src/Widgets/MediaPlayer.vala"
		info = _tmp3_;
#line 57 "../src/Widgets/MediaPlayer.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 57 "../src/Widgets/MediaPlayer.vala"
			_g_object_unref0 (discoverer);
#line 287 "MediaPlayer.c"
			goto __catch29_g_error;
		}
#line 59 "../src/Widgets/MediaPlayer.vala"
		_tmp4_ = info;
#line 59 "../src/Widgets/MediaPlayer.vala"
		_tmp5_ = gst_discoverer_info_get_stream_list (_tmp4_);
#line 294 "MediaPlayer.c"
		{
			GList* i_collection = NULL;
			GList* i_it = NULL;
#line 59 "../src/Widgets/MediaPlayer.vala"
			i_collection = _tmp5_;
#line 59 "../src/Widgets/MediaPlayer.vala"
			for (i_it = i_collection; i_it != NULL; i_it = i_it->next) {
#line 302 "MediaPlayer.c"
				GstDiscovererStreamInfo* _tmp6_;
				GstDiscovererStreamInfo* i = NULL;
#line 59 "../src/Widgets/MediaPlayer.vala"
				_tmp6_ = _g_object_ref0 ((GstDiscovererStreamInfo*) i_it->data);
#line 59 "../src/Widgets/MediaPlayer.vala"
				i = _tmp6_;
#line 309 "MediaPlayer.c"
				{
					GstDiscovererStreamInfo* _tmp7_;
#line 61 "../src/Widgets/MediaPlayer.vala"
					_tmp7_ = i;
#line 61 "../src/Widgets/MediaPlayer.vala"
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gst_discoverer_video_info_get_type ())) {
#line 316 "MediaPlayer.c"
						GstDiscovererVideoInfo* v = NULL;
						GstDiscovererStreamInfo* _tmp8_;
						GstDiscovererVideoInfo* _tmp9_;
						GstDiscovererVideoInfo* _tmp10_;
						GstDiscovererVideoInfo* _tmp11_;
#line 63 "../src/Widgets/MediaPlayer.vala"
						_tmp8_ = i;
#line 63 "../src/Widgets/MediaPlayer.vala"
						_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gst_discoverer_video_info_get_type (), GstDiscovererVideoInfo));
#line 63 "../src/Widgets/MediaPlayer.vala"
						v = _tmp9_;
#line 64 "../src/Widgets/MediaPlayer.vala"
						_tmp10_ = v;
#line 64 "../src/Widgets/MediaPlayer.vala"
						_tmp11_ = v;
#line 64 "../src/Widgets/MediaPlayer.vala"
						self->priv->m_aspectRatio = ((gdouble) gst_discoverer_video_info_get_width (_tmp10_)) / ((gdouble) gst_discoverer_video_info_get_height (_tmp11_));
#line 65 "../src/Widgets/MediaPlayer.vala"
						self->priv->m_type = FEED_READER_MEDIA_TYPE_VIDEO;
#line 61 "../src/Widgets/MediaPlayer.vala"
						_g_object_unref0 (v);
#line 338 "MediaPlayer.c"
					}
#line 59 "../src/Widgets/MediaPlayer.vala"
					_g_object_unref0 (i);
#line 342 "MediaPlayer.c"
				}
			}
#line 59 "../src/Widgets/MediaPlayer.vala"
			(i_collection == NULL) ? NULL : (i_collection = (_g_list_free__g_object_unref0_ (i_collection), NULL));
#line 347 "MediaPlayer.c"
		}
#line 54 "../src/Widgets/MediaPlayer.vala"
		_g_object_unref0 (info);
#line 54 "../src/Widgets/MediaPlayer.vala"
		_g_object_unref0 (discoverer);
#line 353 "MediaPlayer.c"
	}
	goto __finally29;
	__catch29_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 54 "../src/Widgets/MediaPlayer.vala"
		e = _inner_error_;
#line 54 "../src/Widgets/MediaPlayer.vala"
		_inner_error_ = NULL;
#line 71 "../src/Widgets/MediaPlayer.vala"
		_tmp12_ = e;
#line 71 "../src/Widgets/MediaPlayer.vala"
		_tmp13_ = _tmp12_->message;
#line 71 "../src/Widgets/MediaPlayer.vala"
		_tmp14_ = g_strconcat ("Unable discover_uri: ", _tmp13_, NULL);
#line 71 "../src/Widgets/MediaPlayer.vala"
		_tmp15_ = _tmp14_;
#line 71 "../src/Widgets/MediaPlayer.vala"
		feed_reader_logger_error (_tmp15_);
#line 71 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp15_);
#line 54 "../src/Widgets/MediaPlayer.vala"
		_g_error_free0 (e);
#line 381 "MediaPlayer.c"
	}
	__finally29:
#line 54 "../src/Widgets/MediaPlayer.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 54 "../src/Widgets/MediaPlayer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 54 "../src/Widgets/MediaPlayer.vala"
		g_clear_error (&_inner_error_);
#line 54 "../src/Widgets/MediaPlayer.vala"
		return;
#line 392 "MediaPlayer.c"
	}
}


static void
_feed_reader_media_player_onAllocation_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                 GtkAllocation* allocation,
                                                                 gpointer self)
{
#line 82 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_onAllocation ((FeedReaderMediaPlayer*) self, allocation);
#line 404 "MediaPlayer.c"
}


static gboolean
_feed_reader_media_player_busCallback_gst_bus_func (GstBus* bus,
                                                    GstMessage* message,
                                                    gpointer self)
{
	gboolean result;
	result = feed_reader_media_player_busCallback ((FeedReaderMediaPlayer*) self, bus, message);
#line 90 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 417 "MediaPlayer.c"
}


static gboolean
__lambda95_ (FeedReaderMediaPlayer* self)
{
	gboolean result = FALSE;
	GstState state = 0;
	GstState pending = 0;
	GstElement* _tmp0_;
	GstState _tmp1_ = 0;
	GstState _tmp2_ = 0;
	GstState _tmp3_;
#line 95 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_player;
#line 95 "../src/Widgets/MediaPlayer.vala"
	gst_element_get_state (_tmp0_, &_tmp1_, &_tmp2_, (GstClockTime) 1000);
#line 95 "../src/Widgets/MediaPlayer.vala"
	state = _tmp1_;
#line 95 "../src/Widgets/MediaPlayer.vala"
	pending = _tmp2_;
#line 96 "../src/Widgets/MediaPlayer.vala"
	_tmp3_ = state;
#line 96 "../src/Widgets/MediaPlayer.vala"
	if (_tmp3_ == GST_STATE_PLAYING) {
#line 443 "MediaPlayer.c"
		gint64 pos = 0LL;
		gint64 dur = 0LL;
		GstElement* _tmp4_;
		gint64 _tmp5_ = 0LL;
		GstElement* _tmp6_;
		gint64 _tmp7_ = 0LL;
		gdouble position = 0.0;
		gint64 _tmp8_;
		gdouble duration = 0.0;
		gint64 _tmp9_;
		gdouble percent = 0.0;
		gdouble _tmp10_;
		gdouble _tmp11_;
		guint _tmp12_;
#line 100 "../src/Widgets/MediaPlayer.vala"
		_tmp4_ = self->priv->m_player;
#line 100 "../src/Widgets/MediaPlayer.vala"
		gst_element_query_position (_tmp4_, GST_FORMAT_TIME, &_tmp5_);
#line 100 "../src/Widgets/MediaPlayer.vala"
		pos = _tmp5_;
#line 101 "../src/Widgets/MediaPlayer.vala"
		_tmp6_ = self->priv->m_player;
#line 101 "../src/Widgets/MediaPlayer.vala"
		gst_element_query_duration (_tmp6_, GST_FORMAT_TIME, &_tmp7_);
#line 101 "../src/Widgets/MediaPlayer.vala"
		dur = _tmp7_;
#line 102 "../src/Widgets/MediaPlayer.vala"
		_tmp8_ = pos;
#line 102 "../src/Widgets/MediaPlayer.vala"
		position = ((gdouble) _tmp8_) / 1000000000;
#line 103 "../src/Widgets/MediaPlayer.vala"
		_tmp9_ = dur;
#line 103 "../src/Widgets/MediaPlayer.vala"
		duration = ((gdouble) _tmp9_) / 1000000000;
#line 104 "../src/Widgets/MediaPlayer.vala"
		_tmp10_ = position;
#line 104 "../src/Widgets/MediaPlayer.vala"
		_tmp11_ = duration;
#line 104 "../src/Widgets/MediaPlayer.vala"
		percent = (_tmp10_ * 100.0) / _tmp11_;
#line 105 "../src/Widgets/MediaPlayer.vala"
		_tmp12_ = self->priv->m_seek_source_id;
#line 105 "../src/Widgets/MediaPlayer.vala"
		if (_tmp12_ == ((guint) 0)) {
#line 488 "MediaPlayer.c"
			GtkScale* _tmp13_;
			gdouble _tmp14_;
#line 106 "../src/Widgets/MediaPlayer.vala"
			_tmp13_ = self->priv->m_scale;
#line 106 "../src/Widgets/MediaPlayer.vala"
			_tmp14_ = percent;
#line 106 "../src/Widgets/MediaPlayer.vala"
			gtk_range_set_value ((GtkRange*) _tmp13_, _tmp14_);
#line 497 "MediaPlayer.c"
		}
#line 107 "../src/Widgets/MediaPlayer.vala"
		feed_reader_media_player_calcTime (self);
#line 501 "MediaPlayer.c"
	}
#line 109 "../src/Widgets/MediaPlayer.vala"
	result = TRUE;
#line 109 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 507 "MediaPlayer.c"
}


static gboolean
___lambda95__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda95_ ((FeedReaderMediaPlayer*) self);
#line 92 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 518 "MediaPlayer.c"
}


static void
_feed_reader_media_player_togglePause_gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self)
{
#line 120 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_togglePause ((FeedReaderMediaPlayer*) self);
#line 528 "MediaPlayer.c"
}


static void
_feed_reader_media_player_toggleMute_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
#line 135 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_toggleMute ((FeedReaderMediaPlayer*) self);
#line 538 "MediaPlayer.c"
}


static void
__lambda96_ (FeedReaderMediaPlayer* self)
{
#line 143 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_kill (self);
#line 547 "MediaPlayer.c"
}


static void
___lambda96__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 142 "../src/Widgets/MediaPlayer.vala"
	__lambda96_ ((FeedReaderMediaPlayer*) self);
#line 557 "MediaPlayer.c"
}


static gboolean
_feed_reader_media_player_valueChanged_gtk_range_change_value (GtkRange* _sender,
                                                               GtkScrollType scroll,
                                                               gdouble new_value,
                                                               gpointer self)
{
	gboolean result;
	result = feed_reader_media_player_valueChanged ((FeedReaderMediaPlayer*) self, scroll, new_value);
#line 153 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 571 "MediaPlayer.c"
}


static void
_feed_reader_media_player_switchDisplay_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
#line 158 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_switchDisplay ((FeedReaderMediaPlayer*) self);
#line 581 "MediaPlayer.c"
}


static void
feed_reader_media_player_buildUI (FeedReaderMediaPlayer* self)
{
	GstElement* gtksink = NULL;
	GstElement* _tmp0_;
	GstElement* _tmp1_;
	GtkWidget* _tmp2_ = NULL;
	GtkWidget* _tmp3_;
	gint _tmp4_;
	GtkWidget* _tmp5_;
	gint _tmp6_;
	GtkWidget* _tmp7_;
	gint _tmp8_;
	GtkWidget* _tmp9_;
	GstElement* _tmp10_;
	GstElement* _tmp11_;
	GstElement* _tmp12_;
	GstElement* _tmp13_;
	GstElement* _tmp14_;
	const gchar* _tmp15_;
	GstBus* bus = NULL;
	GstElement* _tmp16_;
	GstBus* _tmp17_;
	GstBus* _tmp18_;
	GtkImage* _tmp19_;
	GtkImage* _tmp20_;
	GtkImage* _tmp21_;
	GtkImage* _tmp22_;
	GtkImage* _tmp23_;
	GtkButton* _tmp24_;
	GtkButton* _tmp25_;
	GtkImage* _tmp26_;
	GtkButton* _tmp27_;
	GtkButton* _tmp28_;
	GtkButton* _tmp29_;
	GtkButton* _tmp30_;
	GtkButton* _tmp31_;
	GtkSpinner* _tmp32_;
	GtkStack* _tmp33_;
	GtkStack* _tmp34_;
	GtkButton* _tmp35_;
	GtkStack* _tmp36_;
	GtkSpinner* _tmp37_;
	GtkStack* _tmp38_;
	GtkButton* _tmp39_;
	GtkButton* _tmp40_;
	GtkImage* _tmp41_;
	GtkButton* _tmp42_;
	GtkButton* _tmp43_;
	GtkButton* _tmp44_;
	GtkButton* _tmp45_;
	GtkButton* _tmp46_;
	GtkButton* _tmp47_;
	GtkButton* _tmp48_;
	GtkImage* _tmp49_;
	GtkButton* _tmp50_;
	GtkButton* _tmp51_;
	GtkButton* _tmp52_;
	GtkButton* _tmp53_;
	GtkButton* _tmp54_;
	GtkScale* _tmp55_;
	GtkScale* _tmp56_;
	GtkScale* _tmp57_;
	GtkScale* _tmp58_;
	GtkButton* _tmp59_;
	GtkButton* _tmp60_;
	GtkButton* _tmp61_;
	GtkStyleContext* _tmp62_;
	GtkButton* _tmp63_;
	GtkButton* _tmp64_;
	GtkButton* _tmp65_;
	GtkButton* _tmp66_;
	GtkBox* hBox = NULL;
	GtkBox* _tmp67_;
	GtkBox* _tmp68_;
	gint _tmp69_;
	GtkBox* _tmp70_;
	GtkStack* _tmp71_;
	GtkBox* _tmp72_;
	GtkButton* _tmp73_;
	GtkBox* _tmp74_;
	GtkScale* _tmp75_;
	GtkBox* _tmp76_;
	GtkButton* _tmp77_;
	GtkBox* _tmp78_;
	GtkButton* _tmp79_;
	GtkLabel* _tmp80_;
	GtkLabel* _tmp81_;
	GtkLabel* _tmp82_;
	GtkLabel* _tmp83_;
	GtkLabel* _tmp84_;
	GtkOverlay* bufferOverlay = NULL;
	GtkOverlay* _tmp85_;
	GtkOverlay* _tmp86_;
	GtkWidget* _tmp87_;
	GtkOverlay* _tmp88_;
	GtkLabel* _tmp89_;
	GtkStyleContext* _tmp90_;
	FeedReaderMediaType _tmp91_;
	GtkBox* _tmp93_;
#line 75 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = gst_element_factory_make ("gtksink", "sink");
#line 77 "../src/Widgets/MediaPlayer.vala"
	if (_tmp0_ != NULL) {
#line 77 "../src/Widgets/MediaPlayer.vala"
		g_object_ref_sink (_tmp0_);
#line 693 "MediaPlayer.c"
	}
#line 77 "../src/Widgets/MediaPlayer.vala"
	gtksink = _tmp0_;
#line 78 "../src/Widgets/MediaPlayer.vala"
	_tmp1_ = gtksink;
#line 78 "../src/Widgets/MediaPlayer.vala"
	g_object_get ((GObject*) _tmp1_, "widget", &_tmp2_, NULL);
#line 78 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_videoWidget);
#line 78 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_videoWidget = _tmp2_;
#line 79 "../src/Widgets/MediaPlayer.vala"
	_tmp3_ = self->priv->m_videoWidget;
#line 79 "../src/Widgets/MediaPlayer.vala"
	_tmp4_ = self->priv->m_margin;
#line 79 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_margin_start (_tmp3_, _tmp4_);
#line 80 "../src/Widgets/MediaPlayer.vala"
	_tmp5_ = self->priv->m_videoWidget;
#line 80 "../src/Widgets/MediaPlayer.vala"
	_tmp6_ = self->priv->m_margin;
#line 80 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_margin_end (_tmp5_, _tmp6_);
#line 81 "../src/Widgets/MediaPlayer.vala"
	_tmp7_ = self->priv->m_videoWidget;
#line 81 "../src/Widgets/MediaPlayer.vala"
	_tmp8_ = self->priv->m_margin;
#line 81 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_margin_top (_tmp7_, _tmp8_);
#line 82 "../src/Widgets/MediaPlayer.vala"
	_tmp9_ = self->priv->m_videoWidget;
#line 82 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object (_tmp9_, "size-allocate", (GCallback) _feed_reader_media_player_onAllocation_gtk_widget_size_allocate, self, 0);
#line 84 "../src/Widgets/MediaPlayer.vala"
	_tmp10_ = gst_element_factory_make ("playbin", "player");
#line 84 "../src/Widgets/MediaPlayer.vala"
	if (_tmp10_ != NULL) {
#line 84 "../src/Widgets/MediaPlayer.vala"
		g_object_ref_sink (_tmp10_);
#line 733 "MediaPlayer.c"
	}
#line 84 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_player);
#line 84 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_player = _tmp10_;
#line 85 "../src/Widgets/MediaPlayer.vala"
	_tmp11_ = self->priv->m_player;
#line 85 "../src/Widgets/MediaPlayer.vala"
	_tmp12_ = gtksink;
#line 85 "../src/Widgets/MediaPlayer.vala"
	g_object_set ((GObject*) _tmp11_, "video_sink", _tmp12_, NULL);
#line 86 "../src/Widgets/MediaPlayer.vala"
	_tmp13_ = self->priv->m_player;
#line 86 "../src/Widgets/MediaPlayer.vala"
	g_object_set ((GObject*) _tmp13_, "volume", 1.0, NULL);
#line 87 "../src/Widgets/MediaPlayer.vala"
	_tmp14_ = self->priv->m_player;
#line 87 "../src/Widgets/MediaPlayer.vala"
	_tmp15_ = self->priv->m_URL;
#line 87 "../src/Widgets/MediaPlayer.vala"
	g_object_set ((GObject*) _tmp14_, "uri", _tmp15_, NULL);
#line 89 "../src/Widgets/MediaPlayer.vala"
	_tmp16_ = self->priv->m_player;
#line 89 "../src/Widgets/MediaPlayer.vala"
	_tmp17_ = gst_element_get_bus (_tmp16_);
#line 89 "../src/Widgets/MediaPlayer.vala"
	bus = _tmp17_;
#line 90 "../src/Widgets/MediaPlayer.vala"
	_tmp18_ = bus;
#line 90 "../src/Widgets/MediaPlayer.vala"
	gst_bus_add_watch_full (_tmp18_, G_PRIORITY_LOW, _feed_reader_media_player_busCallback_gst_bus_func, g_object_ref (self), g_object_unref);
#line 92 "../src/Widgets/MediaPlayer.vala"
	g_timeout_add_full (G_PRIORITY_LOW, (guint) 500, ___lambda95__gsource_func, g_object_ref (self), g_object_unref);
#line 112 "../src/Widgets/MediaPlayer.vala"
	_tmp19_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-start-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 112 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp19_);
#line 112 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playIcon);
#line 112 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_playIcon = _tmp19_;
#line 113 "../src/Widgets/MediaPlayer.vala"
	_tmp20_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-pause-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 113 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp20_);
#line 113 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_pauseIcon);
#line 113 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_pauseIcon = _tmp20_;
#line 114 "../src/Widgets/MediaPlayer.vala"
	_tmp21_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-volume-muted-symbolic", (GtkIconSize) GTK_ICON_SIZE_DND);
#line 114 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp21_);
#line 114 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_muteIcon);
#line 114 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_muteIcon = _tmp21_;
#line 115 "../src/Widgets/MediaPlayer.vala"
	_tmp22_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-volume-high-symbolic", (GtkIconSize) GTK_ICON_SIZE_DND);
#line 115 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp22_);
#line 115 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_noiseIcon);
#line 115 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_noiseIcon = _tmp22_;
#line 116 "../src/Widgets/MediaPlayer.vala"
	_tmp23_ = (GtkImage*) gtk_image_new_from_icon_name ("window-close-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 116 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp23_);
#line 116 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_closeIcon);
#line 116 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_closeIcon = _tmp23_;
#line 118 "../src/Widgets/MediaPlayer.vala"
	_tmp24_ = (GtkButton*) gtk_button_new ();
#line 118 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp24_);
#line 118 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playButton);
#line 118 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_playButton = _tmp24_;
#line 119 "../src/Widgets/MediaPlayer.vala"
	_tmp25_ = self->priv->m_playButton;
#line 119 "../src/Widgets/MediaPlayer.vala"
	_tmp26_ = self->priv->m_playIcon;
#line 119 "../src/Widgets/MediaPlayer.vala"
	gtk_button_set_image (_tmp25_, (GtkWidget*) _tmp26_);
#line 120 "../src/Widgets/MediaPlayer.vala"
	_tmp27_ = self->priv->m_playButton;
#line 120 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object (_tmp27_, "clicked", (GCallback) _feed_reader_media_player_togglePause_gtk_button_clicked, self, 0);
#line 121 "../src/Widgets/MediaPlayer.vala"
	_tmp28_ = self->priv->m_playButton;
#line 121 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp28_, FEED_READER_MEDIA_BUTTON_PLAY);
#line 122 "../src/Widgets/MediaPlayer.vala"
	_tmp29_ = self->priv->m_playButton;
#line 122 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp29_, GTK_ALIGN_CENTER);
#line 123 "../src/Widgets/MediaPlayer.vala"
	_tmp30_ = self->priv->m_playButton;
#line 123 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp30_, GTK_ALIGN_CENTER);
#line 124 "../src/Widgets/MediaPlayer.vala"
	_tmp31_ = self->priv->m_playButton;
#line 124 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp31_, 48, 48);
#line 126 "../src/Widgets/MediaPlayer.vala"
	_tmp32_ = (GtkSpinner*) gtk_spinner_new ();
#line 126 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp32_);
#line 126 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playSpinner);
#line 126 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_playSpinner = _tmp32_;
#line 127 "../src/Widgets/MediaPlayer.vala"
	_tmp33_ = (GtkStack*) gtk_stack_new ();
#line 127 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp33_);
#line 127 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playStack);
#line 127 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_playStack = _tmp33_;
#line 128 "../src/Widgets/MediaPlayer.vala"
	_tmp34_ = self->priv->m_playStack;
#line 128 "../src/Widgets/MediaPlayer.vala"
	_tmp35_ = self->priv->m_playButton;
#line 128 "../src/Widgets/MediaPlayer.vala"
	gtk_stack_add_named (_tmp34_, (GtkWidget*) _tmp35_, "button");
#line 129 "../src/Widgets/MediaPlayer.vala"
	_tmp36_ = self->priv->m_playStack;
#line 129 "../src/Widgets/MediaPlayer.vala"
	_tmp37_ = self->priv->m_playSpinner;
#line 129 "../src/Widgets/MediaPlayer.vala"
	gtk_stack_add_named (_tmp36_, (GtkWidget*) _tmp37_, "spinner");
#line 130 "../src/Widgets/MediaPlayer.vala"
	_tmp38_ = self->priv->m_playStack;
#line 130 "../src/Widgets/MediaPlayer.vala"
	gtk_stack_set_visible_child_name (_tmp38_, "button");
#line 132 "../src/Widgets/MediaPlayer.vala"
	_tmp39_ = (GtkButton*) gtk_button_new ();
#line 132 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp39_);
#line 132 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_muteButton);
#line 132 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_muteButton = _tmp39_;
#line 133 "../src/Widgets/MediaPlayer.vala"
	_tmp40_ = self->priv->m_muteButton;
#line 133 "../src/Widgets/MediaPlayer.vala"
	_tmp41_ = self->priv->m_noiseIcon;
#line 133 "../src/Widgets/MediaPlayer.vala"
	gtk_button_set_image (_tmp40_, (GtkWidget*) _tmp41_);
#line 134 "../src/Widgets/MediaPlayer.vala"
	_tmp42_ = self->priv->m_muteButton;
#line 134 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp42_, FEED_READER_MEDIA_BUTTON_MUTE);
#line 135 "../src/Widgets/MediaPlayer.vala"
	_tmp43_ = self->priv->m_muteButton;
#line 135 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object (_tmp43_, "clicked", (GCallback) _feed_reader_media_player_toggleMute_gtk_button_clicked, self, 0);
#line 136 "../src/Widgets/MediaPlayer.vala"
	_tmp44_ = self->priv->m_muteButton;
#line 136 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp44_, GTK_ALIGN_CENTER);
#line 137 "../src/Widgets/MediaPlayer.vala"
	_tmp45_ = self->priv->m_muteButton;
#line 137 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp45_, GTK_ALIGN_CENTER);
#line 138 "../src/Widgets/MediaPlayer.vala"
	_tmp46_ = self->priv->m_muteButton;
#line 138 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp46_, 48, 48);
#line 140 "../src/Widgets/MediaPlayer.vala"
	_tmp47_ = (GtkButton*) gtk_button_new ();
#line 140 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp47_);
#line 140 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_closeButton);
#line 140 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_closeButton = _tmp47_;
#line 141 "../src/Widgets/MediaPlayer.vala"
	_tmp48_ = self->priv->m_closeButton;
#line 141 "../src/Widgets/MediaPlayer.vala"
	_tmp49_ = self->priv->m_closeIcon;
#line 141 "../src/Widgets/MediaPlayer.vala"
	gtk_button_set_image (_tmp48_, (GtkWidget*) _tmp49_);
#line 142 "../src/Widgets/MediaPlayer.vala"
	_tmp50_ = self->priv->m_closeButton;
#line 142 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object (_tmp50_, "clicked", (GCallback) ___lambda96__gtk_button_clicked, self, 0);
#line 145 "../src/Widgets/MediaPlayer.vala"
	_tmp51_ = self->priv->m_closeButton;
#line 145 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp51_, FEED_READER_MEDIA_BUTTON_CLOSE);
#line 146 "../src/Widgets/MediaPlayer.vala"
	_tmp52_ = self->priv->m_closeButton;
#line 146 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp52_, GTK_ALIGN_CENTER);
#line 147 "../src/Widgets/MediaPlayer.vala"
	_tmp53_ = self->priv->m_closeButton;
#line 147 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp53_, GTK_ALIGN_CENTER);
#line 148 "../src/Widgets/MediaPlayer.vala"
	_tmp54_ = self->priv->m_closeButton;
#line 148 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp54_, 48, 48);
#line 150 "../src/Widgets/MediaPlayer.vala"
	_tmp55_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, 0.0, 100.0, 5.0);
#line 150 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp55_);
#line 150 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_scale);
#line 150 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_scale = _tmp55_;
#line 151 "../src/Widgets/MediaPlayer.vala"
	_tmp56_ = self->priv->m_scale;
#line 151 "../src/Widgets/MediaPlayer.vala"
	gtk_scale_set_draw_value (_tmp56_, FALSE);
#line 152 "../src/Widgets/MediaPlayer.vala"
	_tmp57_ = self->priv->m_scale;
#line 152 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp57_, 200, 48);
#line 153 "../src/Widgets/MediaPlayer.vala"
	_tmp58_ = self->priv->m_scale;
#line 153 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object ((GtkRange*) _tmp58_, "change-value", (GCallback) _feed_reader_media_player_valueChanged_gtk_range_change_value, self, 0);
#line 155 "../src/Widgets/MediaPlayer.vala"
	_tmp59_ = (GtkButton*) gtk_button_new_with_label ("00:00");
#line 155 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp59_);
#line 155 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_labelButton);
#line 155 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_labelButton = _tmp59_;
#line 156 "../src/Widgets/MediaPlayer.vala"
	_tmp60_ = self->priv->m_labelButton;
#line 156 "../src/Widgets/MediaPlayer.vala"
	gtk_button_set_relief (_tmp60_, GTK_RELIEF_NONE);
#line 157 "../src/Widgets/MediaPlayer.vala"
	_tmp61_ = self->priv->m_labelButton;
#line 157 "../src/Widgets/MediaPlayer.vala"
	_tmp62_ = gtk_widget_get_style_context ((GtkWidget*) _tmp61_);
#line 157 "../src/Widgets/MediaPlayer.vala"
	gtk_style_context_add_class (_tmp62_, "h3");
#line 158 "../src/Widgets/MediaPlayer.vala"
	_tmp63_ = self->priv->m_labelButton;
#line 158 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object (_tmp63_, "clicked", (GCallback) _feed_reader_media_player_switchDisplay_gtk_button_clicked, self, 0);
#line 159 "../src/Widgets/MediaPlayer.vala"
	_tmp64_ = self->priv->m_labelButton;
#line 159 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp64_, GTK_ALIGN_CENTER);
#line 160 "../src/Widgets/MediaPlayer.vala"
	_tmp65_ = self->priv->m_labelButton;
#line 160 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp65_, GTK_ALIGN_CENTER);
#line 161 "../src/Widgets/MediaPlayer.vala"
	_tmp66_ = self->priv->m_labelButton;
#line 161 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp66_, 48, 48);
#line 163 "../src/Widgets/MediaPlayer.vala"
	_tmp67_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 10);
#line 163 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp67_);
#line 163 "../src/Widgets/MediaPlayer.vala"
	hBox = _tmp67_;
#line 164 "../src/Widgets/MediaPlayer.vala"
	_tmp68_ = hBox;
#line 164 "../src/Widgets/MediaPlayer.vala"
	_tmp69_ = self->priv->m_margin;
#line 164 "../src/Widgets/MediaPlayer.vala"
	g_object_set ((GtkWidget*) _tmp68_, "margin", _tmp69_, NULL);
#line 165 "../src/Widgets/MediaPlayer.vala"
	_tmp70_ = hBox;
#line 165 "../src/Widgets/MediaPlayer.vala"
	_tmp71_ = self->priv->m_playStack;
#line 165 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start (_tmp70_, (GtkWidget*) _tmp71_, FALSE, FALSE, (guint) 0);
#line 166 "../src/Widgets/MediaPlayer.vala"
	_tmp72_ = hBox;
#line 166 "../src/Widgets/MediaPlayer.vala"
	_tmp73_ = self->priv->m_muteButton;
#line 166 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start (_tmp72_, (GtkWidget*) _tmp73_, FALSE, FALSE, (guint) 0);
#line 167 "../src/Widgets/MediaPlayer.vala"
	_tmp74_ = hBox;
#line 167 "../src/Widgets/MediaPlayer.vala"
	_tmp75_ = self->priv->m_scale;
#line 167 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start (_tmp74_, (GtkWidget*) _tmp75_, TRUE, TRUE, (guint) 0);
#line 168 "../src/Widgets/MediaPlayer.vala"
	_tmp76_ = hBox;
#line 168 "../src/Widgets/MediaPlayer.vala"
	_tmp77_ = self->priv->m_labelButton;
#line 168 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start (_tmp76_, (GtkWidget*) _tmp77_, FALSE, FALSE, (guint) 0);
#line 169 "../src/Widgets/MediaPlayer.vala"
	_tmp78_ = hBox;
#line 169 "../src/Widgets/MediaPlayer.vala"
	_tmp79_ = self->priv->m_closeButton;
#line 169 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start (_tmp78_, (GtkWidget*) _tmp79_, FALSE, FALSE, (guint) 0);
#line 171 "../src/Widgets/MediaPlayer.vala"
	_tmp80_ = (GtkLabel*) gtk_label_new ("0%");
#line 171 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp80_);
#line 171 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_bufferLabel);
#line 171 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_bufferLabel = _tmp80_;
#line 172 "../src/Widgets/MediaPlayer.vala"
	_tmp81_ = self->priv->m_bufferLabel;
#line 172 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp81_, GTK_ALIGN_CENTER);
#line 173 "../src/Widgets/MediaPlayer.vala"
	_tmp82_ = self->priv->m_bufferLabel;
#line 173 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp82_, GTK_ALIGN_CENTER);
#line 174 "../src/Widgets/MediaPlayer.vala"
	_tmp83_ = self->priv->m_bufferLabel;
#line 174 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp83_, 48, 48);
#line 175 "../src/Widgets/MediaPlayer.vala"
	_tmp84_ = self->priv->m_bufferLabel;
#line 175 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp84_, TRUE);
#line 177 "../src/Widgets/MediaPlayer.vala"
	_tmp85_ = (GtkOverlay*) gtk_overlay_new ();
#line 177 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp85_);
#line 177 "../src/Widgets/MediaPlayer.vala"
	bufferOverlay = _tmp85_;
#line 178 "../src/Widgets/MediaPlayer.vala"
	_tmp86_ = bufferOverlay;
#line 178 "../src/Widgets/MediaPlayer.vala"
	_tmp87_ = self->priv->m_videoWidget;
#line 178 "../src/Widgets/MediaPlayer.vala"
	gtk_container_add ((GtkContainer*) _tmp86_, _tmp87_);
#line 179 "../src/Widgets/MediaPlayer.vala"
	_tmp88_ = bufferOverlay;
#line 179 "../src/Widgets/MediaPlayer.vala"
	_tmp89_ = self->priv->m_bufferLabel;
#line 179 "../src/Widgets/MediaPlayer.vala"
	gtk_overlay_add_overlay (_tmp88_, (GtkWidget*) _tmp89_);
#line 181 "../src/Widgets/MediaPlayer.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 182 "../src/Widgets/MediaPlayer.vala"
	_tmp90_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 182 "../src/Widgets/MediaPlayer.vala"
	gtk_style_context_add_class (_tmp90_, "osd");
#line 183 "../src/Widgets/MediaPlayer.vala"
	g_object_set ((GtkWidget*) self, "margin", 40, NULL);
#line 184 "../src/Widgets/MediaPlayer.vala"
	_tmp91_ = self->priv->m_type;
#line 184 "../src/Widgets/MediaPlayer.vala"
	if (_tmp91_ == FEED_READER_MEDIA_TYPE_VIDEO) {
#line 1091 "MediaPlayer.c"
		GtkOverlay* _tmp92_;
#line 185 "../src/Widgets/MediaPlayer.vala"
		_tmp92_ = bufferOverlay;
#line 185 "../src/Widgets/MediaPlayer.vala"
		gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp92_, TRUE, TRUE, (guint) 0);
#line 1097 "MediaPlayer.c"
	}
#line 186 "../src/Widgets/MediaPlayer.vala"
	_tmp93_ = hBox;
#line 186 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp93_, FALSE, FALSE, (guint) 0);
#line 187 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_END);
#line 188 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 75 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (bufferOverlay);
#line 75 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (hBox);
#line 75 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (bus);
#line 75 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (gtksink);
#line 1115 "MediaPlayer.c"
}


static void
feed_reader_media_player_togglePause (FeedReaderMediaPlayer* self)
{
	GstState state = 0;
	GstState pending = 0;
	GstElement* _tmp0_;
	GstState _tmp1_ = 0;
	GstState _tmp2_ = 0;
	GstState _tmp3_;
	gboolean _tmp12_;
#line 191 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_player;
#line 195 "../src/Widgets/MediaPlayer.vala"
	gst_element_get_state (_tmp0_, &_tmp1_, &_tmp2_, (GstClockTime) 1000);
#line 195 "../src/Widgets/MediaPlayer.vala"
	state = _tmp1_;
#line 195 "../src/Widgets/MediaPlayer.vala"
	pending = _tmp2_;
#line 197 "../src/Widgets/MediaPlayer.vala"
	_tmp3_ = state;
#line 197 "../src/Widgets/MediaPlayer.vala"
	switch (_tmp3_) {
#line 197 "../src/Widgets/MediaPlayer.vala"
		case GST_STATE_PLAYING:
#line 1145 "MediaPlayer.c"
		{
			GtkButton* _tmp4_;
			GtkImage* _tmp5_;
			GtkButton* _tmp6_;
			GstElement* _tmp7_;
#line 200 "../src/Widgets/MediaPlayer.vala"
			_tmp4_ = self->priv->m_playButton;
#line 200 "../src/Widgets/MediaPlayer.vala"
			_tmp5_ = self->priv->m_playIcon;
#line 200 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_image (_tmp4_, (GtkWidget*) _tmp5_);
#line 201 "../src/Widgets/MediaPlayer.vala"
			_tmp6_ = self->priv->m_playButton;
#line 201 "../src/Widgets/MediaPlayer.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, FEED_READER_MEDIA_BUTTON_PLAY);
#line 202 "../src/Widgets/MediaPlayer.vala"
			_tmp7_ = self->priv->m_player;
#line 202 "../src/Widgets/MediaPlayer.vala"
			gst_element_set_state (_tmp7_, GST_STATE_PAUSED);
#line 203 "../src/Widgets/MediaPlayer.vala"
			break;
#line 1167 "MediaPlayer.c"
		}
		default:
#line 197 "../src/Widgets/MediaPlayer.vala"
		case GST_STATE_PAUSED:
#line 197 "../src/Widgets/MediaPlayer.vala"
		case GST_STATE_READY:
#line 1174 "MediaPlayer.c"
		{
			GtkButton* _tmp8_;
			GtkImage* _tmp9_;
			GtkButton* _tmp10_;
			GstElement* _tmp11_;
#line 208 "../src/Widgets/MediaPlayer.vala"
			_tmp8_ = self->priv->m_playButton;
#line 208 "../src/Widgets/MediaPlayer.vala"
			_tmp9_ = self->priv->m_pauseIcon;
#line 208 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_image (_tmp8_, (GtkWidget*) _tmp9_);
#line 209 "../src/Widgets/MediaPlayer.vala"
			_tmp10_ = self->priv->m_playButton;
#line 209 "../src/Widgets/MediaPlayer.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp10_, FEED_READER_MEDIA_BUTTON_PAUSE);
#line 210 "../src/Widgets/MediaPlayer.vala"
			_tmp11_ = self->priv->m_player;
#line 210 "../src/Widgets/MediaPlayer.vala"
			gst_element_set_state (_tmp11_, GST_STATE_PLAYING);
#line 211 "../src/Widgets/MediaPlayer.vala"
			break;
#line 1196 "MediaPlayer.c"
		}
	}
#line 214 "../src/Widgets/MediaPlayer.vala"
	_tmp12_ = self->priv->m_muted;
#line 214 "../src/Widgets/MediaPlayer.vala"
	if (_tmp12_) {
#line 1203 "MediaPlayer.c"
		GstElement* _tmp13_;
#line 215 "../src/Widgets/MediaPlayer.vala"
		_tmp13_ = self->priv->m_player;
#line 215 "../src/Widgets/MediaPlayer.vala"
		g_object_set ((GObject*) _tmp13_, "volume", 0.0, NULL);
#line 1209 "MediaPlayer.c"
	} else {
		GstElement* _tmp14_;
#line 217 "../src/Widgets/MediaPlayer.vala"
		_tmp14_ = self->priv->m_player;
#line 217 "../src/Widgets/MediaPlayer.vala"
		g_object_set ((GObject*) _tmp14_, "volume", 1.0, NULL);
#line 1216 "MediaPlayer.c"
	}
}


static void
feed_reader_media_player_switchDisplay (FeedReaderMediaPlayer* self)
{
	FeedReaderDisplayPosition _tmp0_;
#line 220 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 222 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_display;
#line 222 "../src/Widgets/MediaPlayer.vala"
	switch (_tmp0_) {
#line 222 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_ALL:
#line 1233 "MediaPlayer.c"
		{
#line 225 "../src/Widgets/MediaPlayer.vala"
			self->priv->m_display = FEED_READER_DISPLAY_POSITION_POS;
#line 226 "../src/Widgets/MediaPlayer.vala"
			break;
#line 1239 "MediaPlayer.c"
		}
#line 222 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_POS:
#line 1243 "MediaPlayer.c"
		{
#line 229 "../src/Widgets/MediaPlayer.vala"
			self->priv->m_display = FEED_READER_DISPLAY_POSITION_LEFT;
#line 230 "../src/Widgets/MediaPlayer.vala"
			break;
#line 1249 "MediaPlayer.c"
		}
#line 222 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_LEFT:
#line 1253 "MediaPlayer.c"
		{
#line 233 "../src/Widgets/MediaPlayer.vala"
			self->priv->m_display = FEED_READER_DISPLAY_POSITION_ALL;
#line 234 "../src/Widgets/MediaPlayer.vala"
			break;
#line 1259 "MediaPlayer.c"
		}
		default:
#line 222 "../src/Widgets/MediaPlayer.vala"
		break;
#line 1264 "MediaPlayer.c"
	}
#line 236 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_calcTime (self);
#line 1268 "MediaPlayer.c"
}


static gdouble*
_double_dup (gdouble* self)
{
	gdouble* dup;
#line 250 "../src/Widgets/MediaPlayer.vala"
	dup = g_new0 (gdouble, 1);
#line 250 "../src/Widgets/MediaPlayer.vala"
	memcpy (dup, self, sizeof (gdouble));
#line 250 "../src/Widgets/MediaPlayer.vala"
	return dup;
#line 1282 "MediaPlayer.c"
}


static gpointer
__double_dup0 (gpointer self)
{
#line 250 "../src/Widgets/MediaPlayer.vala"
	return self ? _double_dup (self) : NULL;
#line 1291 "MediaPlayer.c"
}


static void
feed_reader_media_player_calcTime (FeedReaderMediaPlayer* self)
{
	gint64 pos = 0LL;
	gint64 dur = 0LL;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
	GstElement* _tmp2_;
	gint64 _tmp3_ = 0LL;
	gdouble position = 0.0;
	gint64 _tmp4_;
	gdouble duration = 0.0;
	gint64 _tmp5_;
	gdouble* sd = NULL;
	gdouble _tmp6_;
	gdouble* _tmp7_;
	gdouble* md = NULL;
	gdouble* hd = NULL;
	gdouble* _tmp8_;
	gdouble* sp = NULL;
	gdouble _tmp24_;
	gdouble* _tmp25_;
	gdouble* mp = NULL;
	gdouble* hp = NULL;
	gdouble* _tmp26_;
	gdouble* sr = NULL;
	gdouble _tmp42_;
	gdouble _tmp43_;
	gdouble _tmp44_;
	gdouble* _tmp45_;
	gdouble* mr = NULL;
	gdouble* hr = NULL;
	gdouble* _tmp46_;
	gchar* pLabel = NULL;
	gchar* _tmp62_;
	const gchar* _tmp63_ = NULL;
	gdouble* _tmp64_;
	const gchar* _tmp71_ = NULL;
	gdouble* _tmp72_;
	const gchar* _tmp79_ = NULL;
	gdouble* _tmp80_;
	const gchar* _tmp87_;
	gdouble* _tmp88_;
	gchar* _tmp89_;
	gchar* _tmp90_;
	gchar* _tmp91_;
	gchar* dLabel = NULL;
	gchar* _tmp92_;
	const gchar* _tmp93_ = NULL;
	gdouble* _tmp94_;
	const gchar* _tmp101_ = NULL;
	gdouble* _tmp102_;
	const gchar* _tmp109_ = NULL;
	gdouble* _tmp110_;
	const gchar* _tmp117_;
	gdouble* _tmp118_;
	gchar* _tmp119_;
	gchar* _tmp120_;
	gchar* _tmp121_;
	gchar* rLabel = NULL;
	gchar* _tmp122_;
	const gchar* _tmp123_ = NULL;
	gdouble* _tmp124_;
	const gchar* _tmp131_ = NULL;
	gdouble* _tmp132_;
	const gchar* _tmp139_ = NULL;
	gdouble* _tmp140_;
	const gchar* _tmp147_;
	gdouble* _tmp148_;
	gchar* _tmp149_;
	gchar* _tmp150_;
	gchar* _tmp151_;
	gint64 _tmp152_;
	FeedReaderDisplayPosition _tmp155_;
#line 239 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 243 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_player;
#line 243 "../src/Widgets/MediaPlayer.vala"
	gst_element_query_position (_tmp0_, GST_FORMAT_TIME, &_tmp1_);
#line 243 "../src/Widgets/MediaPlayer.vala"
	pos = _tmp1_;
#line 244 "../src/Widgets/MediaPlayer.vala"
	_tmp2_ = self->priv->m_player;
#line 244 "../src/Widgets/MediaPlayer.vala"
	gst_element_query_duration (_tmp2_, GST_FORMAT_TIME, &_tmp3_);
#line 244 "../src/Widgets/MediaPlayer.vala"
	dur = _tmp3_;
#line 245 "../src/Widgets/MediaPlayer.vala"
	_tmp4_ = pos;
#line 245 "../src/Widgets/MediaPlayer.vala"
	position = (gdouble) ((gint) (((gdouble) _tmp4_) / 1000000000));
#line 246 "../src/Widgets/MediaPlayer.vala"
	_tmp5_ = dur;
#line 246 "../src/Widgets/MediaPlayer.vala"
	duration = (gdouble) ((gint) (((gdouble) _tmp5_) / 1000000000));
#line 250 "../src/Widgets/MediaPlayer.vala"
	_tmp6_ = duration;
#line 250 "../src/Widgets/MediaPlayer.vala"
	_tmp7_ = __double_dup0 (&_tmp6_);
#line 250 "../src/Widgets/MediaPlayer.vala"
	sd = _tmp7_;
#line 251 "../src/Widgets/MediaPlayer.vala"
	md = NULL;
#line 252 "../src/Widgets/MediaPlayer.vala"
	hd = NULL;
#line 254 "../src/Widgets/MediaPlayer.vala"
	_tmp8_ = sd;
#line 254 "../src/Widgets/MediaPlayer.vala"
	if (((gint) (*_tmp8_)) >= 60) {
#line 1405 "MediaPlayer.c"
		gdouble* _tmp9_;
		gdouble _tmp10_;
		gdouble* _tmp11_;
		gdouble* _tmp12_;
		gdouble* _tmp13_;
		gdouble _tmp14_;
		gdouble* _tmp15_;
		gdouble* _tmp16_;
#line 256 "../src/Widgets/MediaPlayer.vala"
		_tmp9_ = sd;
#line 256 "../src/Widgets/MediaPlayer.vala"
		_tmp10_ = (gdouble) ((gint) ((*_tmp9_) / 60));
#line 256 "../src/Widgets/MediaPlayer.vala"
		_tmp11_ = __double_dup0 (&_tmp10_);
#line 256 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (md);
#line 256 "../src/Widgets/MediaPlayer.vala"
		md = _tmp11_;
#line 257 "../src/Widgets/MediaPlayer.vala"
		_tmp12_ = sd;
#line 257 "../src/Widgets/MediaPlayer.vala"
		_tmp13_ = md;
#line 257 "../src/Widgets/MediaPlayer.vala"
		_tmp14_ = (*_tmp12_) - ((*_tmp13_) * 60);
#line 257 "../src/Widgets/MediaPlayer.vala"
		_tmp15_ = __double_dup0 (&_tmp14_);
#line 257 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sd);
#line 257 "../src/Widgets/MediaPlayer.vala"
		sd = _tmp15_;
#line 259 "../src/Widgets/MediaPlayer.vala"
		_tmp16_ = md;
#line 259 "../src/Widgets/MediaPlayer.vala"
		if (((gint) (*_tmp16_)) >= 60) {
#line 1440 "MediaPlayer.c"
			gdouble* _tmp17_;
			gdouble _tmp18_;
			gdouble* _tmp19_;
			gdouble* _tmp20_;
			gdouble* _tmp21_;
			gdouble _tmp22_;
			gdouble* _tmp23_;
#line 261 "../src/Widgets/MediaPlayer.vala"
			_tmp17_ = md;
#line 261 "../src/Widgets/MediaPlayer.vala"
			_tmp18_ = (gdouble) ((gint) ((*_tmp17_) / 60));
#line 261 "../src/Widgets/MediaPlayer.vala"
			_tmp19_ = __double_dup0 (&_tmp18_);
#line 261 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (hd);
#line 261 "../src/Widgets/MediaPlayer.vala"
			hd = _tmp19_;
#line 262 "../src/Widgets/MediaPlayer.vala"
			_tmp20_ = md;
#line 262 "../src/Widgets/MediaPlayer.vala"
			_tmp21_ = hd;
#line 262 "../src/Widgets/MediaPlayer.vala"
			_tmp22_ = (*_tmp20_) - ((*_tmp21_) * 60);
#line 262 "../src/Widgets/MediaPlayer.vala"
			_tmp23_ = __double_dup0 (&_tmp22_);
#line 262 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (md);
#line 262 "../src/Widgets/MediaPlayer.vala"
			md = _tmp23_;
#line 1470 "MediaPlayer.c"
		}
	}
#line 266 "../src/Widgets/MediaPlayer.vala"
	_tmp24_ = position;
#line 266 "../src/Widgets/MediaPlayer.vala"
	_tmp25_ = __double_dup0 (&_tmp24_);
#line 266 "../src/Widgets/MediaPlayer.vala"
	sp = _tmp25_;
#line 267 "../src/Widgets/MediaPlayer.vala"
	mp = NULL;
#line 268 "../src/Widgets/MediaPlayer.vala"
	hp = NULL;
#line 270 "../src/Widgets/MediaPlayer.vala"
	_tmp26_ = sp;
#line 270 "../src/Widgets/MediaPlayer.vala"
	if (((gint) (*_tmp26_)) >= 60) {
#line 1487 "MediaPlayer.c"
		gdouble* _tmp27_;
		gdouble _tmp28_;
		gdouble* _tmp29_;
		gdouble* _tmp30_;
		gdouble* _tmp31_;
		gdouble _tmp32_;
		gdouble* _tmp33_;
		gdouble* _tmp34_;
#line 272 "../src/Widgets/MediaPlayer.vala"
		_tmp27_ = sp;
#line 272 "../src/Widgets/MediaPlayer.vala"
		_tmp28_ = (gdouble) ((gint) ((*_tmp27_) / 60));
#line 272 "../src/Widgets/MediaPlayer.vala"
		_tmp29_ = __double_dup0 (&_tmp28_);
#line 272 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (mp);
#line 272 "../src/Widgets/MediaPlayer.vala"
		mp = _tmp29_;
#line 273 "../src/Widgets/MediaPlayer.vala"
		_tmp30_ = sp;
#line 273 "../src/Widgets/MediaPlayer.vala"
		_tmp31_ = mp;
#line 273 "../src/Widgets/MediaPlayer.vala"
		_tmp32_ = (*_tmp30_) - ((*_tmp31_) * 60);
#line 273 "../src/Widgets/MediaPlayer.vala"
		_tmp33_ = __double_dup0 (&_tmp32_);
#line 273 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sp);
#line 273 "../src/Widgets/MediaPlayer.vala"
		sp = _tmp33_;
#line 275 "../src/Widgets/MediaPlayer.vala"
		_tmp34_ = mp;
#line 275 "../src/Widgets/MediaPlayer.vala"
		if (((gint) (*_tmp34_)) >= 60) {
#line 1522 "MediaPlayer.c"
			gdouble* _tmp35_;
			gdouble _tmp36_;
			gdouble* _tmp37_;
			gdouble* _tmp38_;
			gdouble* _tmp39_;
			gdouble _tmp40_;
			gdouble* _tmp41_;
#line 277 "../src/Widgets/MediaPlayer.vala"
			_tmp35_ = mp;
#line 277 "../src/Widgets/MediaPlayer.vala"
			_tmp36_ = (gdouble) ((gint) ((*_tmp35_) / 60));
#line 277 "../src/Widgets/MediaPlayer.vala"
			_tmp37_ = __double_dup0 (&_tmp36_);
#line 277 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (hp);
#line 277 "../src/Widgets/MediaPlayer.vala"
			hp = _tmp37_;
#line 278 "../src/Widgets/MediaPlayer.vala"
			_tmp38_ = mp;
#line 278 "../src/Widgets/MediaPlayer.vala"
			_tmp39_ = hp;
#line 278 "../src/Widgets/MediaPlayer.vala"
			_tmp40_ = (*_tmp38_) - ((*_tmp39_) * 60);
#line 278 "../src/Widgets/MediaPlayer.vala"
			_tmp41_ = __double_dup0 (&_tmp40_);
#line 278 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (mp);
#line 278 "../src/Widgets/MediaPlayer.vala"
			mp = _tmp41_;
#line 1552 "MediaPlayer.c"
		}
	}
#line 282 "../src/Widgets/MediaPlayer.vala"
	_tmp42_ = duration;
#line 282 "../src/Widgets/MediaPlayer.vala"
	_tmp43_ = position;
#line 282 "../src/Widgets/MediaPlayer.vala"
	_tmp44_ = _tmp42_ - _tmp43_;
#line 282 "../src/Widgets/MediaPlayer.vala"
	_tmp45_ = __double_dup0 (&_tmp44_);
#line 282 "../src/Widgets/MediaPlayer.vala"
	sr = _tmp45_;
#line 283 "../src/Widgets/MediaPlayer.vala"
	mr = NULL;
#line 284 "../src/Widgets/MediaPlayer.vala"
	hr = NULL;
#line 286 "../src/Widgets/MediaPlayer.vala"
	_tmp46_ = sr;
#line 286 "../src/Widgets/MediaPlayer.vala"
	if (((gint) (*_tmp46_)) >= 60) {
#line 1573 "MediaPlayer.c"
		gdouble* _tmp47_;
		gdouble _tmp48_;
		gdouble* _tmp49_;
		gdouble* _tmp50_;
		gdouble* _tmp51_;
		gdouble _tmp52_;
		gdouble* _tmp53_;
		gdouble* _tmp54_;
#line 288 "../src/Widgets/MediaPlayer.vala"
		_tmp47_ = sr;
#line 288 "../src/Widgets/MediaPlayer.vala"
		_tmp48_ = (gdouble) ((gint) ((*_tmp47_) / 60));
#line 288 "../src/Widgets/MediaPlayer.vala"
		_tmp49_ = __double_dup0 (&_tmp48_);
#line 288 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (mr);
#line 288 "../src/Widgets/MediaPlayer.vala"
		mr = _tmp49_;
#line 289 "../src/Widgets/MediaPlayer.vala"
		_tmp50_ = sr;
#line 289 "../src/Widgets/MediaPlayer.vala"
		_tmp51_ = mr;
#line 289 "../src/Widgets/MediaPlayer.vala"
		_tmp52_ = (*_tmp50_) - ((*_tmp51_) * 60);
#line 289 "../src/Widgets/MediaPlayer.vala"
		_tmp53_ = __double_dup0 (&_tmp52_);
#line 289 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sr);
#line 289 "../src/Widgets/MediaPlayer.vala"
		sr = _tmp53_;
#line 291 "../src/Widgets/MediaPlayer.vala"
		_tmp54_ = mr;
#line 291 "../src/Widgets/MediaPlayer.vala"
		if (((gint) (*_tmp54_)) >= 60) {
#line 1608 "MediaPlayer.c"
			gdouble* _tmp55_;
			gdouble _tmp56_;
			gdouble* _tmp57_;
			gdouble* _tmp58_;
			gdouble* _tmp59_;
			gdouble _tmp60_;
			gdouble* _tmp61_;
#line 293 "../src/Widgets/MediaPlayer.vala"
			_tmp55_ = mr;
#line 293 "../src/Widgets/MediaPlayer.vala"
			_tmp56_ = (gdouble) ((gint) ((*_tmp55_) / 60));
#line 293 "../src/Widgets/MediaPlayer.vala"
			_tmp57_ = __double_dup0 (&_tmp56_);
#line 293 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (hr);
#line 293 "../src/Widgets/MediaPlayer.vala"
			hr = _tmp57_;
#line 294 "../src/Widgets/MediaPlayer.vala"
			_tmp58_ = mr;
#line 294 "../src/Widgets/MediaPlayer.vala"
			_tmp59_ = hr;
#line 294 "../src/Widgets/MediaPlayer.vala"
			_tmp60_ = (*_tmp58_) - ((*_tmp59_) * 60);
#line 294 "../src/Widgets/MediaPlayer.vala"
			_tmp61_ = __double_dup0 (&_tmp60_);
#line 294 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (mr);
#line 294 "../src/Widgets/MediaPlayer.vala"
			mr = _tmp61_;
#line 1638 "MediaPlayer.c"
		}
	}
#line 298 "../src/Widgets/MediaPlayer.vala"
	_tmp62_ = g_strdup ("");
#line 298 "../src/Widgets/MediaPlayer.vala"
	pLabel = _tmp62_;
#line 299 "../src/Widgets/MediaPlayer.vala"
	_tmp64_ = hp;
#line 299 "../src/Widgets/MediaPlayer.vala"
	if (_tmp64_ != NULL) {
#line 1649 "MediaPlayer.c"
		const gchar* _tmp65_;
		gdouble* _tmp66_;
		gchar* _tmp67_;
		gchar* _tmp68_;
		gchar* _tmp69_;
		const gchar* _tmp70_;
#line 299 "../src/Widgets/MediaPlayer.vala"
		_tmp65_ = pLabel;
#line 299 "../src/Widgets/MediaPlayer.vala"
		_tmp66_ = hp;
#line 299 "../src/Widgets/MediaPlayer.vala"
		_tmp67_ = g_strdup_printf ("%02.0f:", *_tmp66_);
#line 299 "../src/Widgets/MediaPlayer.vala"
		_tmp68_ = _tmp67_;
#line 299 "../src/Widgets/MediaPlayer.vala"
		_tmp69_ = g_strconcat (_tmp65_, _tmp68_, NULL);
#line 299 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (pLabel);
#line 299 "../src/Widgets/MediaPlayer.vala"
		pLabel = _tmp69_;
#line 299 "../src/Widgets/MediaPlayer.vala"
		_tmp70_ = pLabel;
#line 299 "../src/Widgets/MediaPlayer.vala"
		_tmp63_ = _tmp70_;
#line 299 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp68_);
#line 1676 "MediaPlayer.c"
	} else {
#line 299 "../src/Widgets/MediaPlayer.vala"
		_tmp63_ = NULL;
#line 1680 "MediaPlayer.c"
	}
#line 300 "../src/Widgets/MediaPlayer.vala"
	_tmp72_ = mp;
#line 300 "../src/Widgets/MediaPlayer.vala"
	if (_tmp72_ != NULL) {
#line 1686 "MediaPlayer.c"
		const gchar* _tmp73_;
		gdouble* _tmp74_;
		gchar* _tmp75_;
		gchar* _tmp76_;
		gchar* _tmp77_;
		const gchar* _tmp78_;
#line 300 "../src/Widgets/MediaPlayer.vala"
		_tmp73_ = pLabel;
#line 300 "../src/Widgets/MediaPlayer.vala"
		_tmp74_ = mp;
#line 300 "../src/Widgets/MediaPlayer.vala"
		_tmp75_ = g_strdup_printf ("%02.0f", *_tmp74_);
#line 300 "../src/Widgets/MediaPlayer.vala"
		_tmp76_ = _tmp75_;
#line 300 "../src/Widgets/MediaPlayer.vala"
		_tmp77_ = g_strconcat (_tmp73_, _tmp76_, NULL);
#line 300 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (pLabel);
#line 300 "../src/Widgets/MediaPlayer.vala"
		pLabel = _tmp77_;
#line 300 "../src/Widgets/MediaPlayer.vala"
		_tmp78_ = pLabel;
#line 300 "../src/Widgets/MediaPlayer.vala"
		_tmp71_ = _tmp78_;
#line 300 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp76_);
#line 1713 "MediaPlayer.c"
	} else {
#line 300 "../src/Widgets/MediaPlayer.vala"
		_tmp71_ = NULL;
#line 1717 "MediaPlayer.c"
	}
#line 301 "../src/Widgets/MediaPlayer.vala"
	_tmp80_ = mp;
#line 301 "../src/Widgets/MediaPlayer.vala"
	if (_tmp80_ != NULL) {
#line 1723 "MediaPlayer.c"
		const gchar* _tmp81_;
		gchar* _tmp82_;
		const gchar* _tmp83_;
#line 301 "../src/Widgets/MediaPlayer.vala"
		_tmp81_ = pLabel;
#line 301 "../src/Widgets/MediaPlayer.vala"
		_tmp82_ = g_strconcat (_tmp81_, ":", NULL);
#line 301 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (pLabel);
#line 301 "../src/Widgets/MediaPlayer.vala"
		pLabel = _tmp82_;
#line 301 "../src/Widgets/MediaPlayer.vala"
		_tmp83_ = pLabel;
#line 301 "../src/Widgets/MediaPlayer.vala"
		_tmp79_ = _tmp83_;
#line 1739 "MediaPlayer.c"
	} else {
		const gchar* _tmp84_;
		gchar* _tmp85_;
		const gchar* _tmp86_;
#line 301 "../src/Widgets/MediaPlayer.vala"
		_tmp84_ = pLabel;
#line 301 "../src/Widgets/MediaPlayer.vala"
		_tmp85_ = g_strconcat (_tmp84_, "0:", NULL);
#line 301 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (pLabel);
#line 301 "../src/Widgets/MediaPlayer.vala"
		pLabel = _tmp85_;
#line 301 "../src/Widgets/MediaPlayer.vala"
		_tmp86_ = pLabel;
#line 301 "../src/Widgets/MediaPlayer.vala"
		_tmp79_ = _tmp86_;
#line 1756 "MediaPlayer.c"
	}
#line 302 "../src/Widgets/MediaPlayer.vala"
	_tmp87_ = pLabel;
#line 302 "../src/Widgets/MediaPlayer.vala"
	_tmp88_ = sp;
#line 302 "../src/Widgets/MediaPlayer.vala"
	_tmp89_ = g_strdup_printf ("%02.0f", *_tmp88_);
#line 302 "../src/Widgets/MediaPlayer.vala"
	_tmp90_ = _tmp89_;
#line 302 "../src/Widgets/MediaPlayer.vala"
	_tmp91_ = g_strconcat (_tmp87_, _tmp90_, NULL);
#line 302 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (pLabel);
#line 302 "../src/Widgets/MediaPlayer.vala"
	pLabel = _tmp91_;
#line 302 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (_tmp90_);
#line 304 "../src/Widgets/MediaPlayer.vala"
	_tmp92_ = g_strdup ("");
#line 304 "../src/Widgets/MediaPlayer.vala"
	dLabel = _tmp92_;
#line 305 "../src/Widgets/MediaPlayer.vala"
	_tmp94_ = hd;
#line 305 "../src/Widgets/MediaPlayer.vala"
	if (_tmp94_ != NULL) {
#line 1782 "MediaPlayer.c"
		const gchar* _tmp95_;
		gdouble* _tmp96_;
		gchar* _tmp97_;
		gchar* _tmp98_;
		gchar* _tmp99_;
		const gchar* _tmp100_;
#line 305 "../src/Widgets/MediaPlayer.vala"
		_tmp95_ = dLabel;
#line 305 "../src/Widgets/MediaPlayer.vala"
		_tmp96_ = hd;
#line 305 "../src/Widgets/MediaPlayer.vala"
		_tmp97_ = g_strdup_printf ("%02.0f:", *_tmp96_);
#line 305 "../src/Widgets/MediaPlayer.vala"
		_tmp98_ = _tmp97_;
#line 305 "../src/Widgets/MediaPlayer.vala"
		_tmp99_ = g_strconcat (_tmp95_, _tmp98_, NULL);
#line 305 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (dLabel);
#line 305 "../src/Widgets/MediaPlayer.vala"
		dLabel = _tmp99_;
#line 305 "../src/Widgets/MediaPlayer.vala"
		_tmp100_ = dLabel;
#line 305 "../src/Widgets/MediaPlayer.vala"
		_tmp93_ = _tmp100_;
#line 305 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp98_);
#line 1809 "MediaPlayer.c"
	} else {
#line 305 "../src/Widgets/MediaPlayer.vala"
		_tmp93_ = NULL;
#line 1813 "MediaPlayer.c"
	}
#line 306 "../src/Widgets/MediaPlayer.vala"
	_tmp102_ = md;
#line 306 "../src/Widgets/MediaPlayer.vala"
	if (_tmp102_ != NULL) {
#line 1819 "MediaPlayer.c"
		const gchar* _tmp103_;
		gdouble* _tmp104_;
		gchar* _tmp105_;
		gchar* _tmp106_;
		gchar* _tmp107_;
		const gchar* _tmp108_;
#line 306 "../src/Widgets/MediaPlayer.vala"
		_tmp103_ = dLabel;
#line 306 "../src/Widgets/MediaPlayer.vala"
		_tmp104_ = md;
#line 306 "../src/Widgets/MediaPlayer.vala"
		_tmp105_ = g_strdup_printf ("%02.0f", *_tmp104_);
#line 306 "../src/Widgets/MediaPlayer.vala"
		_tmp106_ = _tmp105_;
#line 306 "../src/Widgets/MediaPlayer.vala"
		_tmp107_ = g_strconcat (_tmp103_, _tmp106_, NULL);
#line 306 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (dLabel);
#line 306 "../src/Widgets/MediaPlayer.vala"
		dLabel = _tmp107_;
#line 306 "../src/Widgets/MediaPlayer.vala"
		_tmp108_ = dLabel;
#line 306 "../src/Widgets/MediaPlayer.vala"
		_tmp101_ = _tmp108_;
#line 306 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp106_);
#line 1846 "MediaPlayer.c"
	} else {
#line 306 "../src/Widgets/MediaPlayer.vala"
		_tmp101_ = NULL;
#line 1850 "MediaPlayer.c"
	}
#line 307 "../src/Widgets/MediaPlayer.vala"
	_tmp110_ = md;
#line 307 "../src/Widgets/MediaPlayer.vala"
	if (_tmp110_ != NULL) {
#line 1856 "MediaPlayer.c"
		const gchar* _tmp111_;
		gchar* _tmp112_;
		const gchar* _tmp113_;
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp111_ = dLabel;
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp112_ = g_strconcat (_tmp111_, ":", NULL);
#line 307 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (dLabel);
#line 307 "../src/Widgets/MediaPlayer.vala"
		dLabel = _tmp112_;
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp113_ = dLabel;
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp109_ = _tmp113_;
#line 1872 "MediaPlayer.c"
	} else {
		const gchar* _tmp114_;
		gchar* _tmp115_;
		const gchar* _tmp116_;
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp114_ = dLabel;
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp115_ = g_strconcat (_tmp114_, "0:", NULL);
#line 307 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (dLabel);
#line 307 "../src/Widgets/MediaPlayer.vala"
		dLabel = _tmp115_;
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp116_ = dLabel;
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp109_ = _tmp116_;
#line 1889 "MediaPlayer.c"
	}
#line 308 "../src/Widgets/MediaPlayer.vala"
	_tmp117_ = dLabel;
#line 308 "../src/Widgets/MediaPlayer.vala"
	_tmp118_ = sd;
#line 308 "../src/Widgets/MediaPlayer.vala"
	_tmp119_ = g_strdup_printf ("%02.0f", *_tmp118_);
#line 308 "../src/Widgets/MediaPlayer.vala"
	_tmp120_ = _tmp119_;
#line 308 "../src/Widgets/MediaPlayer.vala"
	_tmp121_ = g_strconcat (_tmp117_, _tmp120_, NULL);
#line 308 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (dLabel);
#line 308 "../src/Widgets/MediaPlayer.vala"
	dLabel = _tmp121_;
#line 308 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (_tmp120_);
#line 310 "../src/Widgets/MediaPlayer.vala"
	_tmp122_ = g_strdup ("-");
#line 310 "../src/Widgets/MediaPlayer.vala"
	rLabel = _tmp122_;
#line 311 "../src/Widgets/MediaPlayer.vala"
	_tmp124_ = hr;
#line 311 "../src/Widgets/MediaPlayer.vala"
	if (_tmp124_ != NULL) {
#line 1915 "MediaPlayer.c"
		const gchar* _tmp125_;
		gdouble* _tmp126_;
		gchar* _tmp127_;
		gchar* _tmp128_;
		gchar* _tmp129_;
		const gchar* _tmp130_;
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp125_ = rLabel;
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp126_ = hr;
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp127_ = g_strdup_printf ("%02.0f:", *_tmp126_);
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp128_ = _tmp127_;
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp129_ = g_strconcat (_tmp125_, _tmp128_, NULL);
#line 311 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (rLabel);
#line 311 "../src/Widgets/MediaPlayer.vala"
		rLabel = _tmp129_;
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp130_ = rLabel;
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp123_ = _tmp130_;
#line 311 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp128_);
#line 1942 "MediaPlayer.c"
	} else {
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp123_ = NULL;
#line 1946 "MediaPlayer.c"
	}
#line 312 "../src/Widgets/MediaPlayer.vala"
	_tmp132_ = mr;
#line 312 "../src/Widgets/MediaPlayer.vala"
	if (_tmp132_ != NULL) {
#line 1952 "MediaPlayer.c"
		const gchar* _tmp133_;
		gdouble* _tmp134_;
		gchar* _tmp135_;
		gchar* _tmp136_;
		gchar* _tmp137_;
		const gchar* _tmp138_;
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp133_ = rLabel;
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp134_ = mr;
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp135_ = g_strdup_printf ("%02.0f", *_tmp134_);
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp136_ = _tmp135_;
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp137_ = g_strconcat (_tmp133_, _tmp136_, NULL);
#line 312 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (rLabel);
#line 312 "../src/Widgets/MediaPlayer.vala"
		rLabel = _tmp137_;
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp138_ = rLabel;
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp131_ = _tmp138_;
#line 312 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp136_);
#line 1979 "MediaPlayer.c"
	} else {
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp131_ = NULL;
#line 1983 "MediaPlayer.c"
	}
#line 313 "../src/Widgets/MediaPlayer.vala"
	_tmp140_ = mr;
#line 313 "../src/Widgets/MediaPlayer.vala"
	if (_tmp140_ != NULL) {
#line 1989 "MediaPlayer.c"
		const gchar* _tmp141_;
		gchar* _tmp142_;
		const gchar* _tmp143_;
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp141_ = rLabel;
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp142_ = g_strconcat (_tmp141_, ":", NULL);
#line 313 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (rLabel);
#line 313 "../src/Widgets/MediaPlayer.vala"
		rLabel = _tmp142_;
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp143_ = rLabel;
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp139_ = _tmp143_;
#line 2005 "MediaPlayer.c"
	} else {
		const gchar* _tmp144_;
		gchar* _tmp145_;
		const gchar* _tmp146_;
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp144_ = rLabel;
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp145_ = g_strconcat (_tmp144_, "0:", NULL);
#line 313 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (rLabel);
#line 313 "../src/Widgets/MediaPlayer.vala"
		rLabel = _tmp145_;
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp146_ = rLabel;
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp139_ = _tmp146_;
#line 2022 "MediaPlayer.c"
	}
#line 314 "../src/Widgets/MediaPlayer.vala"
	_tmp147_ = rLabel;
#line 314 "../src/Widgets/MediaPlayer.vala"
	_tmp148_ = sr;
#line 314 "../src/Widgets/MediaPlayer.vala"
	_tmp149_ = g_strdup_printf ("%02.0f", *_tmp148_);
#line 314 "../src/Widgets/MediaPlayer.vala"
	_tmp150_ = _tmp149_;
#line 314 "../src/Widgets/MediaPlayer.vala"
	_tmp151_ = g_strconcat (_tmp147_, _tmp150_, NULL);
#line 314 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (rLabel);
#line 314 "../src/Widgets/MediaPlayer.vala"
	rLabel = _tmp151_;
#line 314 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (_tmp150_);
#line 316 "../src/Widgets/MediaPlayer.vala"
	_tmp152_ = dur;
#line 316 "../src/Widgets/MediaPlayer.vala"
	if (_tmp152_ == ((gint64) -1)) {
#line 2044 "MediaPlayer.c"
		GtkButton* _tmp153_;
		const gchar* _tmp154_;
#line 318 "../src/Widgets/MediaPlayer.vala"
		_tmp153_ = self->priv->m_labelButton;
#line 318 "../src/Widgets/MediaPlayer.vala"
		_tmp154_ = pLabel;
#line 318 "../src/Widgets/MediaPlayer.vala"
		gtk_button_set_label (_tmp153_, _tmp154_);
#line 319 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (rLabel);
#line 319 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (dLabel);
#line 319 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (pLabel);
#line 319 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (hr);
#line 319 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (mr);
#line 319 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sr);
#line 319 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (hp);
#line 319 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (mp);
#line 319 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sp);
#line 319 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (hd);
#line 319 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (md);
#line 319 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sd);
#line 319 "../src/Widgets/MediaPlayer.vala"
		return;
#line 2079 "MediaPlayer.c"
	}
#line 323 "../src/Widgets/MediaPlayer.vala"
	_tmp155_ = self->priv->m_display;
#line 323 "../src/Widgets/MediaPlayer.vala"
	switch (_tmp155_) {
#line 323 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_ALL:
#line 2087 "MediaPlayer.c"
		{
			GtkButton* _tmp156_;
			const gchar* _tmp157_;
			gchar* _tmp158_;
			gchar* _tmp159_;
			const gchar* _tmp160_;
			gchar* _tmp161_;
			gchar* _tmp162_;
#line 326 "../src/Widgets/MediaPlayer.vala"
			_tmp156_ = self->priv->m_labelButton;
#line 326 "../src/Widgets/MediaPlayer.vala"
			_tmp157_ = pLabel;
#line 326 "../src/Widgets/MediaPlayer.vala"
			_tmp158_ = g_strconcat (_tmp157_, " / ", NULL);
#line 326 "../src/Widgets/MediaPlayer.vala"
			_tmp159_ = _tmp158_;
#line 326 "../src/Widgets/MediaPlayer.vala"
			_tmp160_ = dLabel;
#line 326 "../src/Widgets/MediaPlayer.vala"
			_tmp161_ = g_strconcat (_tmp159_, _tmp160_, NULL);
#line 326 "../src/Widgets/MediaPlayer.vala"
			_tmp162_ = _tmp161_;
#line 326 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_label (_tmp156_, _tmp162_);
#line 326 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (_tmp162_);
#line 326 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (_tmp159_);
#line 327 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2118 "MediaPlayer.c"
		}
#line 323 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_POS:
#line 2122 "MediaPlayer.c"
		{
			GtkButton* _tmp163_;
			const gchar* _tmp164_;
#line 330 "../src/Widgets/MediaPlayer.vala"
			_tmp163_ = self->priv->m_labelButton;
#line 330 "../src/Widgets/MediaPlayer.vala"
			_tmp164_ = pLabel;
#line 330 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_label (_tmp163_, _tmp164_);
#line 331 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2134 "MediaPlayer.c"
		}
#line 323 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_LEFT:
#line 2138 "MediaPlayer.c"
		{
			GtkButton* _tmp165_;
			const gchar* _tmp166_;
#line 334 "../src/Widgets/MediaPlayer.vala"
			_tmp165_ = self->priv->m_labelButton;
#line 334 "../src/Widgets/MediaPlayer.vala"
			_tmp166_ = rLabel;
#line 334 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_label (_tmp165_, _tmp166_);
#line 335 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2150 "MediaPlayer.c"
		}
		default:
#line 323 "../src/Widgets/MediaPlayer.vala"
		break;
#line 2155 "MediaPlayer.c"
	}
#line 239 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (rLabel);
#line 239 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (dLabel);
#line 239 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (pLabel);
#line 239 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (hr);
#line 239 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (mr);
#line 239 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (sr);
#line 239 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (hp);
#line 239 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (mp);
#line 239 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (sp);
#line 239 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (hd);
#line 239 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (md);
#line 239 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (sd);
#line 2181 "MediaPlayer.c"
}


static Block27Data*
block27_data_ref (Block27Data* _data27_)
{
#line 343 "../src/Widgets/MediaPlayer.vala"
	g_atomic_int_inc (&_data27_->_ref_count_);
#line 343 "../src/Widgets/MediaPlayer.vala"
	return _data27_;
#line 2192 "MediaPlayer.c"
}


static void
block27_data_unref (void * _userdata_)
{
	Block27Data* _data27_;
	_data27_ = (Block27Data*) _userdata_;
#line 343 "../src/Widgets/MediaPlayer.vala"
	if (g_atomic_int_dec_and_test (&_data27_->_ref_count_)) {
#line 2203 "MediaPlayer.c"
		FeedReaderMediaPlayer* self;
#line 343 "../src/Widgets/MediaPlayer.vala"
		self = _data27_->self;
#line 343 "../src/Widgets/MediaPlayer.vala"
		_g_object_unref0 (self);
#line 343 "../src/Widgets/MediaPlayer.vala"
		g_slice_free (Block27Data, _data27_);
#line 2211 "MediaPlayer.c"
	}
}


static gboolean
___lambda97_ (Block27Data* _data27_)
{
	FeedReaderMediaPlayer* self;
	gboolean result = FALSE;
	GtkScale* _tmp0_;
	gdouble _tmp1_;
#line 347 "../src/Widgets/MediaPlayer.vala"
	self = _data27_->self;
#line 348 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_scale;
#line 348 "../src/Widgets/MediaPlayer.vala"
	_tmp1_ = _data27_->startValue;
#line 348 "../src/Widgets/MediaPlayer.vala"
	if (gtk_range_get_value ((GtkRange*) _tmp0_) != _tmp1_) {
#line 2231 "MediaPlayer.c"
		GtkScale* _tmp2_;
#line 350 "../src/Widgets/MediaPlayer.vala"
		_tmp2_ = self->priv->m_scale;
#line 350 "../src/Widgets/MediaPlayer.vala"
		_data27_->startValue = gtk_range_get_value ((GtkRange*) _tmp2_);
#line 351 "../src/Widgets/MediaPlayer.vala"
		result = TRUE;
#line 351 "../src/Widgets/MediaPlayer.vala"
		return result;
#line 2241 "MediaPlayer.c"
	} else {
		gdouble _tmp3_;
#line 355 "../src/Widgets/MediaPlayer.vala"
		self->priv->m_seek_source_id = (guint) 0;
#line 356 "../src/Widgets/MediaPlayer.vala"
		_tmp3_ = _data27_->startValue;
#line 356 "../src/Widgets/MediaPlayer.vala"
		feed_reader_media_player_seek (self, _tmp3_);
#line 357 "../src/Widgets/MediaPlayer.vala"
		result = FALSE;
#line 357 "../src/Widgets/MediaPlayer.vala"
		return result;
#line 2254 "MediaPlayer.c"
	}
}


static gboolean
____lambda97__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda97_ (self);
#line 347 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 2266 "MediaPlayer.c"
}


static gboolean
feed_reader_media_player_valueChanged (FeedReaderMediaPlayer* self,
                                       GtkScrollType scroll,
                                       gdouble new_value)
{
	gboolean result = FALSE;
	GtkScale* _tmp0_;
	guint _tmp1_;
#line 339 "../src/Widgets/MediaPlayer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 341 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_scale;
#line 341 "../src/Widgets/MediaPlayer.vala"
	gtk_range_set_value ((GtkRange*) _tmp0_, new_value);
#line 343 "../src/Widgets/MediaPlayer.vala"
	_tmp1_ = self->priv->m_seek_source_id;
#line 343 "../src/Widgets/MediaPlayer.vala"
	if (_tmp1_ == ((guint) 0)) {
#line 2288 "MediaPlayer.c"
		Block27Data* _data27_;
#line 343 "../src/Widgets/MediaPlayer.vala"
		_data27_ = g_slice_new0 (Block27Data);
#line 343 "../src/Widgets/MediaPlayer.vala"
		_data27_->_ref_count_ = 1;
#line 343 "../src/Widgets/MediaPlayer.vala"
		_data27_->self = g_object_ref (self);
#line 345 "../src/Widgets/MediaPlayer.vala"
		_data27_->startValue = new_value;
#line 347 "../src/Widgets/MediaPlayer.vala"
		self->priv->m_seek_source_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ____lambda97__gsource_func, block27_data_ref (_data27_), block27_data_unref);
#line 343 "../src/Widgets/MediaPlayer.vala"
		block27_data_unref (_data27_);
#line 343 "../src/Widgets/MediaPlayer.vala"
		_data27_ = NULL;
#line 2304 "MediaPlayer.c"
	}
#line 361 "../src/Widgets/MediaPlayer.vala"
	result = TRUE;
#line 361 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 2310 "MediaPlayer.c"
}


static void
feed_reader_media_player_seek (FeedReaderMediaPlayer* self,
                               gdouble new_value)
{
	gint64 dur = 0LL;
	gdouble percent = 0.0;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
	gint64 pos = 0LL;
	GstElement* _tmp2_;
	GtkButton* _tmp3_;
	GtkImage* _tmp4_;
	GstElement* _tmp5_;
#line 364 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 367 "../src/Widgets/MediaPlayer.vala"
	percent = new_value / 100.0;
#line 368 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_player;
#line 368 "../src/Widgets/MediaPlayer.vala"
	gst_element_query_duration (_tmp0_, GST_FORMAT_TIME, &_tmp1_);
#line 368 "../src/Widgets/MediaPlayer.vala"
	dur = _tmp1_;
#line 369 "../src/Widgets/MediaPlayer.vala"
	pos = (gint64) (percent * ((gdouble) dur));
#line 370 "../src/Widgets/MediaPlayer.vala"
	_tmp2_ = self->priv->m_player;
#line 370 "../src/Widgets/MediaPlayer.vala"
	gst_element_seek_simple (_tmp2_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH | GST_SEEK_FLAG_KEY_UNIT, pos);
#line 372 "../src/Widgets/MediaPlayer.vala"
	_tmp3_ = self->priv->m_playButton;
#line 372 "../src/Widgets/MediaPlayer.vala"
	_tmp4_ = self->priv->m_pauseIcon;
#line 372 "../src/Widgets/MediaPlayer.vala"
	gtk_button_set_image (_tmp3_, (GtkWidget*) _tmp4_);
#line 373 "../src/Widgets/MediaPlayer.vala"
	_tmp5_ = self->priv->m_player;
#line 373 "../src/Widgets/MediaPlayer.vala"
	gst_element_set_state (_tmp5_, GST_STATE_PLAYING);
#line 2353 "MediaPlayer.c"
}


static void
feed_reader_media_player_toggleMute (FeedReaderMediaPlayer* self)
{
	gboolean _tmp0_;
#line 376 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 378 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_muted;
#line 378 "../src/Widgets/MediaPlayer.vala"
	if (_tmp0_) {
#line 2367 "MediaPlayer.c"
		GtkButton* _tmp1_;
		GtkImage* _tmp2_;
		GtkButton* _tmp3_;
		GstElement* _tmp4_;
#line 380 "../src/Widgets/MediaPlayer.vala"
		_tmp1_ = self->priv->m_muteButton;
#line 380 "../src/Widgets/MediaPlayer.vala"
		_tmp2_ = self->priv->m_noiseIcon;
#line 380 "../src/Widgets/MediaPlayer.vala"
		gtk_button_set_image (_tmp1_, (GtkWidget*) _tmp2_);
#line 381 "../src/Widgets/MediaPlayer.vala"
		_tmp3_ = self->priv->m_muteButton;
#line 381 "../src/Widgets/MediaPlayer.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, FEED_READER_MEDIA_BUTTON_MUTE);
#line 382 "../src/Widgets/MediaPlayer.vala"
		_tmp4_ = self->priv->m_player;
#line 382 "../src/Widgets/MediaPlayer.vala"
		g_object_set ((GObject*) _tmp4_, "volume", 1.0, NULL);
#line 383 "../src/Widgets/MediaPlayer.vala"
		self->priv->m_muted = FALSE;
#line 2388 "MediaPlayer.c"
	} else {
		GtkButton* _tmp5_;
		GtkImage* _tmp6_;
		GtkButton* _tmp7_;
		GstElement* _tmp8_;
#line 387 "../src/Widgets/MediaPlayer.vala"
		_tmp5_ = self->priv->m_muteButton;
#line 387 "../src/Widgets/MediaPlayer.vala"
		_tmp6_ = self->priv->m_muteIcon;
#line 387 "../src/Widgets/MediaPlayer.vala"
		gtk_button_set_image (_tmp5_, (GtkWidget*) _tmp6_);
#line 388 "../src/Widgets/MediaPlayer.vala"
		_tmp7_ = self->priv->m_muteButton;
#line 388 "../src/Widgets/MediaPlayer.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, FEED_READER_MEDIA_BUTTON_UNMUTE);
#line 389 "../src/Widgets/MediaPlayer.vala"
		_tmp8_ = self->priv->m_player;
#line 389 "../src/Widgets/MediaPlayer.vala"
		g_object_set ((GObject*) _tmp8_, "volume", 0.0, NULL);
#line 390 "../src/Widgets/MediaPlayer.vala"
		self->priv->m_muted = TRUE;
#line 2410 "MediaPlayer.c"
	}
}


static gboolean
feed_reader_media_player_busCallback (FeedReaderMediaPlayer* self,
                                      GstBus* bus,
                                      GstMessage* message)
{
	gboolean result = FALSE;
	GstMessageType _tmp0_;
#line 394 "../src/Widgets/MediaPlayer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 394 "../src/Widgets/MediaPlayer.vala"
	g_return_val_if_fail (bus != NULL, FALSE);
#line 394 "../src/Widgets/MediaPlayer.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 396 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = message->type;
#line 396 "../src/Widgets/MediaPlayer.vala"
	switch (_tmp0_) {
#line 396 "../src/Widgets/MediaPlayer.vala"
		case GST_MESSAGE_ERROR:
#line 2434 "MediaPlayer.c"
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GError* _tmp1_ = NULL;
			gchar* _tmp2_ = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			GstElement* _tmp7_;
#line 401 "../src/Widgets/MediaPlayer.vala"
			gst_message_parse_error (message, &_tmp1_, &_tmp2_);
#line 401 "../src/Widgets/MediaPlayer.vala"
			_g_error_free0 (err);
#line 401 "../src/Widgets/MediaPlayer.vala"
			err = _tmp1_;
#line 401 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (debug);
#line 401 "../src/Widgets/MediaPlayer.vala"
			debug = _tmp2_;
#line 402 "../src/Widgets/MediaPlayer.vala"
			_tmp3_ = err;
#line 402 "../src/Widgets/MediaPlayer.vala"
			_tmp4_ = _tmp3_->message;
#line 402 "../src/Widgets/MediaPlayer.vala"
			_tmp5_ = g_strconcat ("MediaPlayer: ", _tmp4_, NULL);
#line 402 "../src/Widgets/MediaPlayer.vala"
			_tmp6_ = _tmp5_;
#line 402 "../src/Widgets/MediaPlayer.vala"
			feed_reader_logger_error (_tmp6_);
#line 402 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (_tmp6_);
#line 403 "../src/Widgets/MediaPlayer.vala"
			_tmp7_ = self->priv->m_player;
#line 403 "../src/Widgets/MediaPlayer.vala"
			gst_element_set_state (_tmp7_, GST_STATE_NULL);
#line 404 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (debug);
#line 404 "../src/Widgets/MediaPlayer.vala"
			_g_error_free0 (err);
#line 404 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2477 "MediaPlayer.c"
		}
#line 396 "../src/Widgets/MediaPlayer.vala"
		case GST_MESSAGE_EOS:
#line 2481 "MediaPlayer.c"
		{
			GstElement* _tmp8_;
			GtkButton* _tmp9_;
			GtkImage* _tmp10_;
#line 407 "../src/Widgets/MediaPlayer.vala"
			_tmp8_ = self->priv->m_player;
#line 407 "../src/Widgets/MediaPlayer.vala"
			gst_element_set_state (_tmp8_, GST_STATE_READY);
#line 408 "../src/Widgets/MediaPlayer.vala"
			_tmp9_ = self->priv->m_playButton;
#line 408 "../src/Widgets/MediaPlayer.vala"
			_tmp10_ = self->priv->m_playIcon;
#line 408 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_image (_tmp9_, (GtkWidget*) _tmp10_);
#line 409 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2498 "MediaPlayer.c"
		}
#line 396 "../src/Widgets/MediaPlayer.vala"
		case GST_MESSAGE_BUFFERING:
#line 2502 "MediaPlayer.c"
		{
			gint percent = 0;
			gint _tmp11_ = 0;
			gint _tmp12_;
#line 412 "../src/Widgets/MediaPlayer.vala"
			percent = 0;
#line 413 "../src/Widgets/MediaPlayer.vala"
			gst_message_parse_buffering (message, &_tmp11_);
#line 413 "../src/Widgets/MediaPlayer.vala"
			percent = _tmp11_;
#line 414 "../src/Widgets/MediaPlayer.vala"
			_tmp12_ = percent;
#line 414 "../src/Widgets/MediaPlayer.vala"
			if (_tmp12_ < 100) {
#line 2517 "MediaPlayer.c"
				GstElement* _tmp13_;
				FeedReaderMediaType _tmp14_;
#line 416 "../src/Widgets/MediaPlayer.vala"
				_tmp13_ = self->priv->m_player;
#line 416 "../src/Widgets/MediaPlayer.vala"
				gst_element_set_state (_tmp13_, GST_STATE_PAUSED);
#line 418 "../src/Widgets/MediaPlayer.vala"
				_tmp14_ = self->priv->m_type;
#line 418 "../src/Widgets/MediaPlayer.vala"
				if (_tmp14_ == FEED_READER_MEDIA_TYPE_VIDEO) {
#line 2528 "MediaPlayer.c"
					GtkLabel* _tmp15_;
					gint _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					GtkLabel* _tmp21_;
#line 420 "../src/Widgets/MediaPlayer.vala"
					_tmp15_ = self->priv->m_bufferLabel;
#line 420 "../src/Widgets/MediaPlayer.vala"
					_tmp16_ = percent;
#line 420 "../src/Widgets/MediaPlayer.vala"
					_tmp17_ = g_strdup_printf ("%i", _tmp16_);
#line 420 "../src/Widgets/MediaPlayer.vala"
					_tmp18_ = _tmp17_;
#line 420 "../src/Widgets/MediaPlayer.vala"
					_tmp19_ = g_strconcat (_tmp18_, "%", NULL);
#line 420 "../src/Widgets/MediaPlayer.vala"
					_tmp20_ = _tmp19_;
#line 420 "../src/Widgets/MediaPlayer.vala"
					gtk_label_set_text (_tmp15_, _tmp20_);
#line 420 "../src/Widgets/MediaPlayer.vala"
					_g_free0 (_tmp20_);
#line 420 "../src/Widgets/MediaPlayer.vala"
					_g_free0 (_tmp18_);
#line 421 "../src/Widgets/MediaPlayer.vala"
					_tmp21_ = self->priv->m_bufferLabel;
#line 421 "../src/Widgets/MediaPlayer.vala"
					gtk_widget_show ((GtkWidget*) _tmp21_);
#line 2558 "MediaPlayer.c"
				} else {
					GtkStack* _tmp22_;
					GtkSpinner* _tmp23_;
#line 425 "../src/Widgets/MediaPlayer.vala"
					_tmp22_ = self->priv->m_playStack;
#line 425 "../src/Widgets/MediaPlayer.vala"
					gtk_stack_set_visible_child_name (_tmp22_, "spinner");
#line 426 "../src/Widgets/MediaPlayer.vala"
					_tmp23_ = self->priv->m_playSpinner;
#line 426 "../src/Widgets/MediaPlayer.vala"
					gtk_spinner_start (_tmp23_);
#line 2570 "MediaPlayer.c"
				}
			} else {
				GstElement* _tmp24_;
				FeedReaderMediaType _tmp25_;
#line 431 "../src/Widgets/MediaPlayer.vala"
				_tmp24_ = self->priv->m_player;
#line 431 "../src/Widgets/MediaPlayer.vala"
				gst_element_set_state (_tmp24_, GST_STATE_PLAYING);
#line 432 "../src/Widgets/MediaPlayer.vala"
				_tmp25_ = self->priv->m_type;
#line 432 "../src/Widgets/MediaPlayer.vala"
				if (_tmp25_ == FEED_READER_MEDIA_TYPE_VIDEO) {
#line 2583 "MediaPlayer.c"
					GtkLabel* _tmp26_;
#line 433 "../src/Widgets/MediaPlayer.vala"
					_tmp26_ = self->priv->m_bufferLabel;
#line 433 "../src/Widgets/MediaPlayer.vala"
					gtk_widget_hide ((GtkWidget*) _tmp26_);
#line 2589 "MediaPlayer.c"
				} else {
					GtkStack* _tmp27_;
#line 435 "../src/Widgets/MediaPlayer.vala"
					_tmp27_ = self->priv->m_playStack;
#line 435 "../src/Widgets/MediaPlayer.vala"
					gtk_stack_set_visible_child_name (_tmp27_, "button");
#line 2596 "MediaPlayer.c"
				}
			}
#line 437 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2601 "MediaPlayer.c"
		}
#line 396 "../src/Widgets/MediaPlayer.vala"
		case GST_MESSAGE_STATE_CHANGED:
#line 2605 "MediaPlayer.c"
		{
			GstState oldstate = 0;
			GstState newstate = 0;
			GstState pending = 0;
			GstState _tmp28_ = 0;
			GstState _tmp29_ = 0;
			GstState _tmp30_ = 0;
#line 443 "../src/Widgets/MediaPlayer.vala"
			gst_message_parse_state_changed (message, &_tmp28_, &_tmp29_, &_tmp30_);
#line 443 "../src/Widgets/MediaPlayer.vala"
			oldstate = _tmp28_;
#line 443 "../src/Widgets/MediaPlayer.vala"
			newstate = _tmp29_;
#line 443 "../src/Widgets/MediaPlayer.vala"
			pending = _tmp30_;
#line 444 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2623 "MediaPlayer.c"
		}
		default:
#line 396 "../src/Widgets/MediaPlayer.vala"
		break;
#line 2628 "MediaPlayer.c"
	}
#line 446 "../src/Widgets/MediaPlayer.vala"
	result = TRUE;
#line 446 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 2634 "MediaPlayer.c"
}


static void
feed_reader_media_player_onAllocation (FeedReaderMediaPlayer* self,
                                       GtkAllocation* allocation)
{
	gdouble _tmp0_;
#line 449 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 449 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (allocation != NULL);
#line 451 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_aspectRatio;
#line 451 "../src/Widgets/MediaPlayer.vala"
	if (_tmp0_ != ((gdouble) 0)) {
#line 2651 "MediaPlayer.c"
		gdouble width = 0.0;
		GtkAllocation _tmp1_;
		gint _tmp2_;
		gint height = 0;
		gdouble _tmp3_;
		gdouble _tmp4_;
		GtkWidget* _tmp5_;
		gint _tmp6_;
#line 453 "../src/Widgets/MediaPlayer.vala"
		_tmp1_ = *allocation;
#line 453 "../src/Widgets/MediaPlayer.vala"
		_tmp2_ = _tmp1_.width;
#line 453 "../src/Widgets/MediaPlayer.vala"
		width = (gdouble) _tmp2_;
#line 454 "../src/Widgets/MediaPlayer.vala"
		_tmp3_ = width;
#line 454 "../src/Widgets/MediaPlayer.vala"
		_tmp4_ = self->priv->m_aspectRatio;
#line 454 "../src/Widgets/MediaPlayer.vala"
		height = (gint) (_tmp3_ / _tmp4_);
#line 455 "../src/Widgets/MediaPlayer.vala"
		_tmp5_ = self->priv->m_videoWidget;
#line 455 "../src/Widgets/MediaPlayer.vala"
		_tmp6_ = height;
#line 455 "../src/Widgets/MediaPlayer.vala"
		gtk_widget_set_size_request (_tmp5_, -1, _tmp6_);
#line 2678 "MediaPlayer.c"
	}
}


void
feed_reader_media_player_kill (FeedReaderMediaPlayer* self)
{
	GstElement* _tmp0_;
#line 459 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 461 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_player;
#line 461 "../src/Widgets/MediaPlayer.vala"
	gst_element_set_state (_tmp0_, GST_STATE_NULL);
#line 462 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 2695 "MediaPlayer.c"
}


static void
feed_reader_media_player_class_init (FeedReaderMediaPlayerClass * klass)
{
#line 16 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/Widgets/MediaPlayer.vala"
	g_type_class_adjust_private_offset (klass, &FeedReaderMediaPlayer_private_offset);
#line 16 "../src/Widgets/MediaPlayer.vala"
	G_OBJECT_CLASS (klass)->finalize = feed_reader_media_player_finalize;
#line 16 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_signals[FEED_READER_MEDIA_PLAYER_LOADED_SIGNAL] = g_signal_new ("loaded", FEED_READER_TYPE_MEDIA_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2710 "MediaPlayer.c"
}


static void
feed_reader_media_player_instance_init (FeedReaderMediaPlayer * self)
{
#line 16 "../src/Widgets/MediaPlayer.vala"
	self->priv = feed_reader_media_player_get_instance_private (self);
#line 28 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_margin = 20;
#line 34 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_muted = FALSE;
#line 35 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_aspectRatio = 0.0;
#line 36 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_seek_source_id = (guint) 0;
#line 39 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_display = FEED_READER_DISPLAY_POSITION_ALL;
#line 2729 "MediaPlayer.c"
}


static void
feed_reader_media_player_finalize (GObject * obj)
{
	FeedReaderMediaPlayer * self;
#line 16 "../src/Widgets/MediaPlayer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayer);
#line 18 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_player);
#line 19 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_videoWidget);
#line 20 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playStack);
#line 21 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playButton);
#line 22 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playSpinner);
#line 23 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_muteButton);
#line 24 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_closeButton);
#line 25 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_scale);
#line 26 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_labelButton);
#line 27 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_bufferLabel);
#line 29 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playIcon);
#line 30 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_pauseIcon);
#line 31 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_muteIcon);
#line 32 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_noiseIcon);
#line 33 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_closeIcon);
#line 38 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (self->priv->m_URL);
#line 16 "../src/Widgets/MediaPlayer.vala"
	G_OBJECT_CLASS (feed_reader_media_player_parent_class)->finalize (obj);
#line 2773 "MediaPlayer.c"
}


GType
feed_reader_media_player_get_type (void)
{
	static volatile gsize feed_reader_media_player_type_id__volatile = 0;
	if (g_once_init_enter (&feed_reader_media_player_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FeedReaderMediaPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) feed_reader_media_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FeedReaderMediaPlayer), 0, (GInstanceInitFunc) feed_reader_media_player_instance_init, NULL };
		GType feed_reader_media_player_type_id;
		feed_reader_media_player_type_id = g_type_register_static (gtk_box_get_type (), "FeedReaderMediaPlayer", &g_define_type_info, 0);
		FeedReaderMediaPlayer_private_offset = g_type_add_instance_private (feed_reader_media_player_type_id, sizeof (FeedReaderMediaPlayerPrivate));
		g_once_init_leave (&feed_reader_media_player_type_id__volatile, feed_reader_media_player_type_id);
	}
	return feed_reader_media_player_type_id__volatile;
}



