/* Frame.c generated by valac 0.42.5, the Vala compiler
 * generated from Frame.vala, do not modify */

/*
 * Copyright (C) 2014 PerfectCarl - https://github.com/PerfectCarl/vala-stacktrace
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define IVY_TYPE_FRAME (ivy_frame_get_type ())
#define IVY_FRAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IVY_TYPE_FRAME, IvyFrame))
#define IVY_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IVY_TYPE_FRAME, IvyFrameClass))
#define IVY_IS_FRAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IVY_TYPE_FRAME))
#define IVY_IS_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IVY_TYPE_FRAME))
#define IVY_FRAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IVY_TYPE_FRAME, IvyFrameClass))

typedef struct _IvyFrame IvyFrame;
typedef struct _IvyFrameClass IvyFrameClass;
typedef struct _IvyFramePrivate IvyFramePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _IvyParamSpecFrame IvyParamSpecFrame;

struct _IvyFrame {
	GTypeInstance parent_instance;
	volatile int ref_count;
	IvyFramePrivate * priv;
};

struct _IvyFrameClass {
	GTypeClass parent_class;
	void (*finalize) (IvyFrame *self);
};

struct _IvyFramePrivate {
	gchar* _address;
	gchar* _line;
	gchar* _line_number;
	gchar* _file_path;
	gchar* _file_short_path;
	gchar* _function;
};

struct _IvyParamSpecFrame {
	GParamSpec parent_instance;
};


static gint IvyFrame_private_offset;
static gpointer ivy_frame_parent_class = NULL;

gpointer ivy_frame_ref (gpointer instance);
void ivy_frame_unref (gpointer instance);
GParamSpec* ivy_param_spec_frame (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void ivy_value_set_frame (GValue* value,
                          gpointer v_object);
void ivy_value_take_frame (GValue* value,
                           gpointer v_object);
gpointer ivy_value_get_frame (const GValue* value);
GType ivy_frame_get_type (void) G_GNUC_CONST;
IvyFrame* ivy_frame_new (const gchar* address,
                         const gchar* line,
                         const gchar* function,
                         const gchar* file_path,
                         const gchar* file_short_path,
                         const gchar* line_number);
IvyFrame* ivy_frame_construct (GType object_type,
                               const gchar* address,
                               const gchar* line,
                               const gchar* function,
                               const gchar* file_path,
                               const gchar* file_short_path,
                               const gchar* line_number);
static void ivy_frame_set_line_number (IvyFrame* self,
                                const gchar* value);
const gchar* ivy_frame_get_address (IvyFrame* self);
static void ivy_frame_set_address (IvyFrame* self,
                            const gchar* value);
const gchar* ivy_frame_get_line (IvyFrame* self);
static void ivy_frame_set_line (IvyFrame* self,
                         const gchar* value);
const gchar* ivy_frame_get_line_number (IvyFrame* self);
const gchar* ivy_frame_get_file_path (IvyFrame* self);
static void ivy_frame_set_file_path (IvyFrame* self,
                              const gchar* value);
const gchar* ivy_frame_get_file_short_path (IvyFrame* self);
static void ivy_frame_set_file_short_path (IvyFrame* self,
                                    const gchar* value);
const gchar* ivy_frame_get_function (IvyFrame* self);
static void ivy_frame_set_function (IvyFrame* self,
                             const gchar* value);
static void ivy_frame_finalize (IvyFrame * obj);


static inline gpointer
ivy_frame_get_instance_private (IvyFrame* self)
{
	return G_STRUCT_MEMBER_P (self, IvyFrame_private_offset);
}


IvyFrame*
ivy_frame_construct (GType object_type,
                     const gchar* address,
                     const gchar* line,
                     const gchar* function,
                     const gchar* file_path,
                     const gchar* file_short_path,
                     const gchar* line_number)
{
	IvyFrame* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 90 "../libraries/libIvy/Frame.vala"
	g_return_val_if_fail (address != NULL, NULL);
#line 90 "../libraries/libIvy/Frame.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 90 "../libraries/libIvy/Frame.vala"
	g_return_val_if_fail (function != NULL, NULL);
#line 90 "../libraries/libIvy/Frame.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 90 "../libraries/libIvy/Frame.vala"
	g_return_val_if_fail (file_short_path != NULL, NULL);
#line 90 "../libraries/libIvy/Frame.vala"
	g_return_val_if_fail (line_number != NULL, NULL);
#line 90 "../libraries/libIvy/Frame.vala"
	self = (IvyFrame*) g_type_create_instance (object_type);
#line 91 "../libraries/libIvy/Frame.vala"
	_tmp0_ = g_strdup (address);
#line 91 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_address);
#line 91 "../libraries/libIvy/Frame.vala"
	self->priv->_address = _tmp0_;
#line 92 "../libraries/libIvy/Frame.vala"
	_tmp1_ = g_strdup (line);
#line 92 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_line);
#line 92 "../libraries/libIvy/Frame.vala"
	self->priv->_line = _tmp1_;
#line 94 "../libraries/libIvy/Frame.vala"
	_tmp2_ = g_strdup (file_path);
#line 94 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_file_path);
#line 94 "../libraries/libIvy/Frame.vala"
	self->priv->_file_path = _tmp2_;
#line 95 "../libraries/libIvy/Frame.vala"
	_tmp3_ = g_strdup (file_short_path);
#line 95 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_file_short_path);
#line 95 "../libraries/libIvy/Frame.vala"
	self->priv->_file_short_path = _tmp3_;
#line 96 "../libraries/libIvy/Frame.vala"
	_tmp4_ = g_strdup (function);
#line 96 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_function);
#line 96 "../libraries/libIvy/Frame.vala"
	self->priv->_function = _tmp4_;
#line 97 "../libraries/libIvy/Frame.vala"
	ivy_frame_set_line_number (self, line_number);
#line 90 "../libraries/libIvy/Frame.vala"
	return self;
#line 187 "Frame.c"
}


IvyFrame*
ivy_frame_new (const gchar* address,
               const gchar* line,
               const gchar* function,
               const gchar* file_path,
               const gchar* file_short_path,
               const gchar* line_number)
{
#line 90 "../libraries/libIvy/Frame.vala"
	return ivy_frame_construct (IVY_TYPE_FRAME, address, line, function, file_path, file_short_path, line_number);
#line 201 "Frame.c"
}


const gchar*
ivy_frame_get_address (IvyFrame* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "../libraries/libIvy/Frame.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../libraries/libIvy/Frame.vala"
	_tmp0_ = self->priv->_address;
#line 36 "../libraries/libIvy/Frame.vala"
	result = _tmp0_;
#line 36 "../libraries/libIvy/Frame.vala"
	return result;
#line 218 "Frame.c"
}


static void
ivy_frame_set_address (IvyFrame* self,
                       const gchar* value)
{
	gchar* _tmp0_;
#line 36 "../libraries/libIvy/Frame.vala"
	g_return_if_fail (self != NULL);
#line 36 "../libraries/libIvy/Frame.vala"
	_tmp0_ = g_strdup (value);
#line 36 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_address);
#line 36 "../libraries/libIvy/Frame.vala"
	self->priv->_address = _tmp0_;
#line 235 "Frame.c"
}


const gchar*
ivy_frame_get_line (IvyFrame* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 47 "../libraries/libIvy/Frame.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../libraries/libIvy/Frame.vala"
	_tmp0_ = self->priv->_line;
#line 47 "../libraries/libIvy/Frame.vala"
	result = _tmp0_;
#line 47 "../libraries/libIvy/Frame.vala"
	return result;
#line 252 "Frame.c"
}


static void
ivy_frame_set_line (IvyFrame* self,
                    const gchar* value)
{
	gchar* _tmp0_;
#line 47 "../libraries/libIvy/Frame.vala"
	g_return_if_fail (self != NULL);
#line 47 "../libraries/libIvy/Frame.vala"
	_tmp0_ = g_strdup (value);
#line 47 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_line);
#line 47 "../libraries/libIvy/Frame.vala"
	self->priv->_line = _tmp0_;
#line 269 "Frame.c"
}


const gchar*
ivy_frame_get_line_number (IvyFrame* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 56 "../libraries/libIvy/Frame.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../libraries/libIvy/Frame.vala"
	_tmp0_ = self->priv->_line_number;
#line 56 "../libraries/libIvy/Frame.vala"
	result = _tmp0_;
#line 56 "../libraries/libIvy/Frame.vala"
	return result;
#line 286 "Frame.c"
}


static void
ivy_frame_set_line_number (IvyFrame* self,
                           const gchar* value)
{
	gchar* _tmp0_;
#line 56 "../libraries/libIvy/Frame.vala"
	g_return_if_fail (self != NULL);
#line 56 "../libraries/libIvy/Frame.vala"
	_tmp0_ = g_strdup (value);
#line 56 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_line_number);
#line 56 "../libraries/libIvy/Frame.vala"
	self->priv->_line_number = _tmp0_;
#line 303 "Frame.c"
}


const gchar*
ivy_frame_get_file_path (IvyFrame* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 67 "../libraries/libIvy/Frame.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../libraries/libIvy/Frame.vala"
	_tmp0_ = self->priv->_file_path;
#line 67 "../libraries/libIvy/Frame.vala"
	result = _tmp0_;
#line 67 "../libraries/libIvy/Frame.vala"
	return result;
#line 320 "Frame.c"
}


static void
ivy_frame_set_file_path (IvyFrame* self,
                         const gchar* value)
{
	gchar* _tmp0_;
#line 67 "../libraries/libIvy/Frame.vala"
	g_return_if_fail (self != NULL);
#line 67 "../libraries/libIvy/Frame.vala"
	_tmp0_ = g_strdup (value);
#line 67 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_file_path);
#line 67 "../libraries/libIvy/Frame.vala"
	self->priv->_file_path = _tmp0_;
#line 337 "Frame.c"
}


const gchar*
ivy_frame_get_file_short_path (IvyFrame* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 76 "../libraries/libIvy/Frame.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "../libraries/libIvy/Frame.vala"
	_tmp0_ = self->priv->_file_short_path;
#line 76 "../libraries/libIvy/Frame.vala"
	result = _tmp0_;
#line 76 "../libraries/libIvy/Frame.vala"
	return result;
#line 354 "Frame.c"
}


static void
ivy_frame_set_file_short_path (IvyFrame* self,
                               const gchar* value)
{
	gchar* _tmp0_;
#line 76 "../libraries/libIvy/Frame.vala"
	g_return_if_fail (self != NULL);
#line 76 "../libraries/libIvy/Frame.vala"
	_tmp0_ = g_strdup (value);
#line 76 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_file_short_path);
#line 76 "../libraries/libIvy/Frame.vala"
	self->priv->_file_short_path = _tmp0_;
#line 371 "Frame.c"
}


const gchar*
ivy_frame_get_function (IvyFrame* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 88 "../libraries/libIvy/Frame.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 88 "../libraries/libIvy/Frame.vala"
	_tmp0_ = self->priv->_function;
#line 88 "../libraries/libIvy/Frame.vala"
	result = _tmp0_;
#line 88 "../libraries/libIvy/Frame.vala"
	return result;
#line 388 "Frame.c"
}


static void
ivy_frame_set_function (IvyFrame* self,
                        const gchar* value)
{
	gchar* _tmp0_;
#line 88 "../libraries/libIvy/Frame.vala"
	g_return_if_fail (self != NULL);
#line 88 "../libraries/libIvy/Frame.vala"
	_tmp0_ = g_strdup (value);
#line 88 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_function);
#line 88 "../libraries/libIvy/Frame.vala"
	self->priv->_function = _tmp0_;
#line 405 "Frame.c"
}


static void
ivy_value_frame_init (GValue* value)
{
#line 29 "../libraries/libIvy/Frame.vala"
	value->data[0].v_pointer = NULL;
#line 414 "Frame.c"
}


static void
ivy_value_frame_free_value (GValue* value)
{
#line 29 "../libraries/libIvy/Frame.vala"
	if (value->data[0].v_pointer) {
#line 29 "../libraries/libIvy/Frame.vala"
		ivy_frame_unref (value->data[0].v_pointer);
#line 425 "Frame.c"
	}
}


static void
ivy_value_frame_copy_value (const GValue* src_value,
                            GValue* dest_value)
{
#line 29 "../libraries/libIvy/Frame.vala"
	if (src_value->data[0].v_pointer) {
#line 29 "../libraries/libIvy/Frame.vala"
		dest_value->data[0].v_pointer = ivy_frame_ref (src_value->data[0].v_pointer);
#line 438 "Frame.c"
	} else {
#line 29 "../libraries/libIvy/Frame.vala"
		dest_value->data[0].v_pointer = NULL;
#line 442 "Frame.c"
	}
}


static gpointer
ivy_value_frame_peek_pointer (const GValue* value)
{
#line 29 "../libraries/libIvy/Frame.vala"
	return value->data[0].v_pointer;
#line 452 "Frame.c"
}


static gchar*
ivy_value_frame_collect_value (GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
#line 29 "../libraries/libIvy/Frame.vala"
	if (collect_values[0].v_pointer) {
#line 464 "Frame.c"
		IvyFrame * object;
		object = collect_values[0].v_pointer;
#line 29 "../libraries/libIvy/Frame.vala"
		if (object->parent_instance.g_class == NULL) {
#line 29 "../libraries/libIvy/Frame.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 471 "Frame.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 29 "../libraries/libIvy/Frame.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 475 "Frame.c"
		}
#line 29 "../libraries/libIvy/Frame.vala"
		value->data[0].v_pointer = ivy_frame_ref (object);
#line 479 "Frame.c"
	} else {
#line 29 "../libraries/libIvy/Frame.vala"
		value->data[0].v_pointer = NULL;
#line 483 "Frame.c"
	}
#line 29 "../libraries/libIvy/Frame.vala"
	return NULL;
#line 487 "Frame.c"
}


static gchar*
ivy_value_frame_lcopy_value (const GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
	IvyFrame ** object_p;
	object_p = collect_values[0].v_pointer;
#line 29 "../libraries/libIvy/Frame.vala"
	if (!object_p) {
#line 29 "../libraries/libIvy/Frame.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 503 "Frame.c"
	}
#line 29 "../libraries/libIvy/Frame.vala"
	if (!value->data[0].v_pointer) {
#line 29 "../libraries/libIvy/Frame.vala"
		*object_p = NULL;
#line 509 "Frame.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 29 "../libraries/libIvy/Frame.vala"
		*object_p = value->data[0].v_pointer;
#line 513 "Frame.c"
	} else {
#line 29 "../libraries/libIvy/Frame.vala"
		*object_p = ivy_frame_ref (value->data[0].v_pointer);
#line 517 "Frame.c"
	}
#line 29 "../libraries/libIvy/Frame.vala"
	return NULL;
#line 521 "Frame.c"
}


GParamSpec*
ivy_param_spec_frame (const gchar* name,
                      const gchar* nick,
                      const gchar* blurb,
                      GType object_type,
                      GParamFlags flags)
{
	IvyParamSpecFrame* spec;
#line 29 "../libraries/libIvy/Frame.vala"
	g_return_val_if_fail (g_type_is_a (object_type, IVY_TYPE_FRAME), NULL);
#line 29 "../libraries/libIvy/Frame.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 29 "../libraries/libIvy/Frame.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 29 "../libraries/libIvy/Frame.vala"
	return G_PARAM_SPEC (spec);
#line 541 "Frame.c"
}


gpointer
ivy_value_get_frame (const GValue* value)
{
#line 29 "../libraries/libIvy/Frame.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, IVY_TYPE_FRAME), NULL);
#line 29 "../libraries/libIvy/Frame.vala"
	return value->data[0].v_pointer;
#line 552 "Frame.c"
}


void
ivy_value_set_frame (GValue* value,
                     gpointer v_object)
{
	IvyFrame * old;
#line 29 "../libraries/libIvy/Frame.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, IVY_TYPE_FRAME));
#line 29 "../libraries/libIvy/Frame.vala"
	old = value->data[0].v_pointer;
#line 29 "../libraries/libIvy/Frame.vala"
	if (v_object) {
#line 29 "../libraries/libIvy/Frame.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, IVY_TYPE_FRAME));
#line 29 "../libraries/libIvy/Frame.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "../libraries/libIvy/Frame.vala"
		value->data[0].v_pointer = v_object;
#line 29 "../libraries/libIvy/Frame.vala"
		ivy_frame_ref (value->data[0].v_pointer);
#line 575 "Frame.c"
	} else {
#line 29 "../libraries/libIvy/Frame.vala"
		value->data[0].v_pointer = NULL;
#line 579 "Frame.c"
	}
#line 29 "../libraries/libIvy/Frame.vala"
	if (old) {
#line 29 "../libraries/libIvy/Frame.vala"
		ivy_frame_unref (old);
#line 585 "Frame.c"
	}
}


void
ivy_value_take_frame (GValue* value,
                      gpointer v_object)
{
	IvyFrame * old;
#line 29 "../libraries/libIvy/Frame.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, IVY_TYPE_FRAME));
#line 29 "../libraries/libIvy/Frame.vala"
	old = value->data[0].v_pointer;
#line 29 "../libraries/libIvy/Frame.vala"
	if (v_object) {
#line 29 "../libraries/libIvy/Frame.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, IVY_TYPE_FRAME));
#line 29 "../libraries/libIvy/Frame.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "../libraries/libIvy/Frame.vala"
		value->data[0].v_pointer = v_object;
#line 607 "Frame.c"
	} else {
#line 29 "../libraries/libIvy/Frame.vala"
		value->data[0].v_pointer = NULL;
#line 611 "Frame.c"
	}
#line 29 "../libraries/libIvy/Frame.vala"
	if (old) {
#line 29 "../libraries/libIvy/Frame.vala"
		ivy_frame_unref (old);
#line 617 "Frame.c"
	}
}


static void
ivy_frame_class_init (IvyFrameClass * klass)
{
#line 29 "../libraries/libIvy/Frame.vala"
	ivy_frame_parent_class = g_type_class_peek_parent (klass);
#line 29 "../libraries/libIvy/Frame.vala"
	((IvyFrameClass *) klass)->finalize = ivy_frame_finalize;
#line 29 "../libraries/libIvy/Frame.vala"
	g_type_class_adjust_private_offset (klass, &IvyFrame_private_offset);
#line 631 "Frame.c"
}


static void
ivy_frame_instance_init (IvyFrame * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 29 "../libraries/libIvy/Frame.vala"
	self->priv = ivy_frame_get_instance_private (self);
#line 36 "../libraries/libIvy/Frame.vala"
	_tmp0_ = g_strdup ("");
#line 36 "../libraries/libIvy/Frame.vala"
	self->priv->_address = _tmp0_;
#line 47 "../libraries/libIvy/Frame.vala"
	_tmp1_ = g_strdup ("");
#line 47 "../libraries/libIvy/Frame.vala"
	self->priv->_line = _tmp1_;
#line 56 "../libraries/libIvy/Frame.vala"
	_tmp2_ = g_strdup ("");
#line 56 "../libraries/libIvy/Frame.vala"
	self->priv->_line_number = _tmp2_;
#line 67 "../libraries/libIvy/Frame.vala"
	_tmp3_ = g_strdup ("");
#line 67 "../libraries/libIvy/Frame.vala"
	self->priv->_file_path = _tmp3_;
#line 76 "../libraries/libIvy/Frame.vala"
	_tmp4_ = g_strdup ("");
#line 76 "../libraries/libIvy/Frame.vala"
	self->priv->_file_short_path = _tmp4_;
#line 88 "../libraries/libIvy/Frame.vala"
	_tmp5_ = g_strdup ("");
#line 88 "../libraries/libIvy/Frame.vala"
	self->priv->_function = _tmp5_;
#line 29 "../libraries/libIvy/Frame.vala"
	self->ref_count = 1;
#line 672 "Frame.c"
}


static void
ivy_frame_finalize (IvyFrame * obj)
{
	IvyFrame * self;
#line 29 "../libraries/libIvy/Frame.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, IVY_TYPE_FRAME, IvyFrame);
#line 29 "../libraries/libIvy/Frame.vala"
	g_signal_handlers_destroy (self);
#line 36 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_address);
#line 47 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_line);
#line 56 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_line_number);
#line 67 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_file_path);
#line 76 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_file_short_path);
#line 88 "../libraries/libIvy/Frame.vala"
	_g_free0 (self->priv->_function);
#line 696 "Frame.c"
}


/**
 * A part of a stacktrace
 *
 * This class represent on instance of a frame, ie a particular location
 * in a binary (application or library) on the system called by the application
 *
 * ''Note:'' frames from system libraries without code information available are
 * not displayed by default. See {@link Stacktrace.hide_installed_libraries} for how to
 * display them.
 **/
GType
ivy_frame_get_type (void)
{
	static volatile gsize ivy_frame_type_id__volatile = 0;
	if (g_once_init_enter (&ivy_frame_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { ivy_value_frame_init, ivy_value_frame_free_value, ivy_value_frame_copy_value, ivy_value_frame_peek_pointer, "p", ivy_value_frame_collect_value, "p", ivy_value_frame_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (IvyFrameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ivy_frame_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IvyFrame), 0, (GInstanceInitFunc) ivy_frame_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType ivy_frame_type_id;
		ivy_frame_type_id = g_type_register_fundamental (g_type_fundamental_next (), "IvyFrame", &g_define_type_info, &g_define_type_fundamental_info, 0);
		IvyFrame_private_offset = g_type_add_instance_private (ivy_frame_type_id, sizeof (IvyFramePrivate));
		g_once_init_leave (&ivy_frame_type_id__volatile, ivy_frame_type_id);
	}
	return ivy_frame_type_id__volatile;
}


gpointer
ivy_frame_ref (gpointer instance)
{
	IvyFrame * self;
	self = instance;
#line 29 "../libraries/libIvy/Frame.vala"
	g_atomic_int_inc (&self->ref_count);
#line 29 "../libraries/libIvy/Frame.vala"
	return instance;
#line 736 "Frame.c"
}


void
ivy_frame_unref (gpointer instance)
{
	IvyFrame * self;
	self = instance;
#line 29 "../libraries/libIvy/Frame.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 29 "../libraries/libIvy/Frame.vala"
		IVY_FRAME_GET_CLASS (self)->finalize (self);
#line 29 "../libraries/libIvy/Frame.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 751 "Frame.c"
	}
}



