/* feedbinAPI.c generated by valac 0.42.5, the Vala compiler
 * generated from feedbinAPI.vala, do not modify */

/*This file is part of FeedReader.*/
/**/
/*FeedReader is free software: you can redistribute it and/or modify*/
/*it under the terms of the GNU General Public License as published by*/
/*the Free Software Foundation, either version 3 of the License, or*/
/*(at your option) any later version.*/
/**/
/*FeedReader is distributed in the hope that it will be useful,*/
/*but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*GNU General Public License for more details.*/
/**/
/*You should have received a copy of the GNU General Public License*/
/*along with FeedReader.  If not, see <http://www.gnu.org/licenses/>.*/
/* TODO: Make a general-purpose HttpClient module with these errors*/


#include <glib.h>
#include <glib-object.h>
#include <libsoup/soup.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include <gee.h>


#define TYPE_FEEDBIN_API (feedbin_api_get_type ())
#define FEEDBIN_API(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FEEDBIN_API, FeedbinAPI))
#define FEEDBIN_API_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FEEDBIN_API, FeedbinAPIClass))
#define IS_FEEDBIN_API(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FEEDBIN_API))
#define IS_FEEDBIN_API_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FEEDBIN_API))
#define FEEDBIN_API_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FEEDBIN_API, FeedbinAPIClass))

typedef struct _FeedbinAPI FeedbinAPI;
typedef struct _FeedbinAPIClass FeedbinAPIClass;
typedef struct _FeedbinAPIPrivate FeedbinAPIPrivate;
enum  {
	FEEDBIN_API_0_PROPERTY,
	FEEDBIN_API_USERNAME_PROPERTY,
	FEEDBIN_API_PASSWORD_PROPERTY,
	FEEDBIN_API_NUM_PROPERTIES
};
static GParamSpec* feedbin_api_properties[FEEDBIN_API_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define __vala_SoupBuffer_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupBuffer_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

#define FEEDBIN_API_TYPE_SUBSCRIPTION (feedbin_api_subscription_get_type ())
typedef struct _FeedbinAPISubscription FeedbinAPISubscription;
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))

#define FEEDBIN_API_TYPE_TAGGING (feedbin_api_tagging_get_type ())
typedef struct _FeedbinAPITagging FeedbinAPITagging;

#define FEEDBIN_API_TYPE_ENTRY (feedbin_api_entry_get_type ())
typedef struct _FeedbinAPIEntry FeedbinAPIEntry;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	FEEDBIN_ERROR_INVALID_FORMAT,
	FEEDBIN_ERROR_MULTIPLE_CHOICES,
	FEEDBIN_ERROR_NO_CONNECTION,
	FEEDBIN_ERROR_NOT_AUTHORIZED,
	FEEDBIN_ERROR_NOT_FOUND,
	FEEDBIN_ERROR_UNKNOWN_ERROR
} FeedbinError;
#define FEEDBIN_ERROR feedbin_error_quark ()
struct _FeedbinAPI {
	GObject parent_instance;
	FeedbinAPIPrivate * priv;
};

struct _FeedbinAPIClass {
	GObjectClass parent_class;
};

struct _FeedbinAPIPrivate {
	SoupSession* m_session;
	gchar* m_base_uri;
	gchar* _username;
	gchar* _password;
};

struct _FeedbinAPISubscription {
	gint64 id;
	GDateTime* created_at;
	gint64 feed_id;
	gchar* title;
	gchar* feed_url;
	gchar* site_url;
};

struct _FeedbinAPITagging {
	gint64 id;
	gint64 feed_id;
	gchar* name;
};

struct _FeedbinAPIEntry {
	gint64 id;
	gint64 feed_id;
	gchar* title;
	gchar* url;
	gchar* author;
	gchar* content;
	gchar* summary;
	GDateTime* published;
	GDateTime* created_at;
};


static gint FeedbinAPI_private_offset;
static gpointer feedbin_api_parent_class = NULL;

GQuark feedbin_error_quark (void);
GType feedbin_api_get_type (void) G_GNUC_CONST;
static void feedbin_api_authenticate (FeedbinAPI* self,
                               SoupMessage* msg,
                               SoupAuth* auth,
                               gboolean retrying);
static void _feedbin_api_authenticate_soup_session_authenticate (SoupSession* _sender,
                                                          SoupMessage* msg,
                                                          SoupAuth* auth,
                                                          gboolean retrying,
                                                          gpointer self);
#define FEEDBIN_API_BASE_URI_FORMAT "%s/v2/"
FeedbinAPI* feedbin_api_new (const gchar* username,
                             const gchar* password,
                             const gchar* user_agent,
                             const gchar* host);
FeedbinAPI* feedbin_api_construct (GType object_type,
                                   const gchar* username,
                                   const gchar* password,
                                   const gchar* user_agent,
                                   const gchar* host);
void feedbin_api_set_username (FeedbinAPI* self,
                               const gchar* value);
void feedbin_api_set_password (FeedbinAPI* self,
                               const gchar* value);
const gchar* feedbin_api_get_username (FeedbinAPI* self);
const gchar* feedbin_api_get_password (FeedbinAPI* self);
static SoupMessage* feedbin_api_request (FeedbinAPI* self,
                                  const gchar* method,
                                  const gchar* last_part,
                                  const gchar* input,
                                  GError** error);
static guint8* _vala_array_dup1 (guint8* self,
                          int length);
static GDateTime* feedbin_api_string_to_datetime (const gchar* s,
                                           GError** error);
static GDateTime* feedbin_api_get_datetime_member (JsonObject* obj,
                                            const gchar* name,
                                            GError** error);
static SoupMessage* feedbin_api_post_request (FeedbinAPI* self,
                                       const gchar* path,
                                       const gchar* input,
                                       GError** error);
static SoupMessage* feedbin_api_delete_request (FeedbinAPI* self,
                                         const gchar* path,
                                         GError** error);
static SoupMessage* feedbin_api_get_request (FeedbinAPI* self,
                                      const gchar* path,
                                      GError** error);
static JsonNode* feedbin_api_parse_json (SoupMessage* response,
                                  GError** error);
static void _vala_SoupBuffer_free (SoupBuffer* self);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static JsonNode* feedbin_api_get_json (FeedbinAPI* self,
                                const gchar* path,
                                GError** error);
static void _vala_JsonNode_free (JsonNode* self);
static SoupMessage* feedbin_api_post_json_object (FeedbinAPI* self,
                                           const gchar* path,
                                           JsonObject* obj,
                                           GError** error);
gboolean feedbin_api_login (FeedbinAPI* self,
                            GError** error);
GType feedbin_api_subscription_get_type (void) G_GNUC_CONST;
FeedbinAPISubscription* feedbin_api_subscription_dup (const FeedbinAPISubscription* self);
void feedbin_api_subscription_free (FeedbinAPISubscription* self);
void feedbin_api_subscription_copy (const FeedbinAPISubscription* self,
                                    FeedbinAPISubscription* dest);
void feedbin_api_subscription_destroy (FeedbinAPISubscription* self);
void feedbin_api_get_subscription (FeedbinAPI* self,
                                   gint64 subscription_id,
                                   FeedbinAPISubscription* result,
                                   GError** error);
void feedbin_api_subscription_init_from_json (FeedbinAPISubscription *self,
                                              JsonObject* object,
                                              GError** error);
GeeList* feedbin_api_get_subscriptions (FeedbinAPI* self,
                                        GError** error);
void feedbin_api_delete_subscription (FeedbinAPI* self,
                                      gint64 subscription_id,
                                      GError** error);
FeedbinAPISubscription* feedbin_api_add_subscription (FeedbinAPI* self,
                                                      const gchar* url,
                                                      GError** error);
void feedbin_api_rename_subscription (FeedbinAPI* self,
                                      gint64 subscription_id,
                                      const gchar* title,
                                      GError** error);
void feedbin_api_add_tagging (FeedbinAPI* self,
                              gint64 feed_id,
                              const gchar* tag_name,
                              GError** error);
void feedbin_api_delete_tagging (FeedbinAPI* self,
                                 gint64 tagging_id,
                                 GError** error);
GType feedbin_api_tagging_get_type (void) G_GNUC_CONST;
FeedbinAPITagging* feedbin_api_tagging_dup (const FeedbinAPITagging* self);
void feedbin_api_tagging_free (FeedbinAPITagging* self);
void feedbin_api_tagging_copy (const FeedbinAPITagging* self,
                               FeedbinAPITagging* dest);
void feedbin_api_tagging_destroy (FeedbinAPITagging* self);
GeeList* feedbin_api_get_taggings (FeedbinAPI* self,
                                   GError** error);
void feedbin_api_tagging_init_from_json (FeedbinAPITagging *self,
                                         JsonObject* object);
GType feedbin_api_entry_get_type (void) G_GNUC_CONST;
FeedbinAPIEntry* feedbin_api_entry_dup (const FeedbinAPIEntry* self);
void feedbin_api_entry_free (FeedbinAPIEntry* self);
void feedbin_api_entry_copy (const FeedbinAPIEntry* self,
                             FeedbinAPIEntry* dest);
void feedbin_api_entry_destroy (FeedbinAPIEntry* self);
GeeList* feedbin_api_get_entries (FeedbinAPI* self,
                                  gint page,
                                  gboolean only_starred,
                                  GDateTime* since,
                                  gint64* feed_id,
                                  GError** error);
void feedbin_api_entry_init_from_json (FeedbinAPIEntry *self,
                                       JsonObject* object,
                                       GError** error);
static GeeSet* feedbin_api_get_x_entries (FeedbinAPI* self,
                                   const gchar* path,
                                   GError** error);
static guint __lambda4_ (FeedbinAPI* self,
                  gint64* n);
static guint ___lambda4__gee_hash_data_func (gconstpointer v,
                                      gpointer self);
static gboolean __lambda5_ (FeedbinAPI* self,
                     gint64* a,
                     gint64* b);
static gboolean ___lambda5__gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
static gint64* _int64_dup (gint64* self);
GeeSet* feedbin_api_get_unread_entries (FeedbinAPI* self,
                                        GError** error);
GeeSet* feedbin_api_get_starred_entries (FeedbinAPI* self,
                                         GError** error);
static void feedbin_api_set_entries_status (FeedbinAPI* self,
                                     const gchar* type,
                                     GeeCollection* entry_ids,
                                     gboolean create,
                                     GError** error);
void feedbin_api_set_entries_read (FeedbinAPI* self,
                                   GeeCollection* entry_ids,
                                   gboolean read,
                                   GError** error);
void feedbin_api_set_entries_starred (FeedbinAPI* self,
                                      GeeCollection* entry_ids,
                                      gboolean starred,
                                      GError** error);
GeeMap* feedbin_api_get_favicons (FeedbinAPI* self,
                                  GError** error);
static void feedbin_api_finalize (GObject * obj);
static void _vala_feedbin_api_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_feedbin_api_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);


GQuark
feedbin_error_quark (void)
{
	return g_quark_from_static_string ("feedbin-error-quark");
}


static inline gpointer
feedbin_api_get_instance_private (FeedbinAPI* self)
{
	return G_STRUCT_MEMBER_P (self, FeedbinAPI_private_offset);
}


static void
_feedbin_api_authenticate_soup_session_authenticate (SoupSession* _sender,
                                                     SoupMessage* msg,
                                                     SoupAuth* auth,
                                                     gboolean retrying,
                                                     gpointer self)
{
#line 49 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_authenticate ((FeedbinAPI*) self, msg, auth, retrying);
#line 314 "feedbinAPI.c"
}


FeedbinAPI*
feedbin_api_construct (GType object_type,
                       const gchar* username,
                       const gchar* password,
                       const gchar* user_agent,
                       const gchar* host)
{
	FeedbinAPI * self = NULL;
	gchar* _tmp0_;
	SoupSession* _tmp1_;
	SoupSession* _tmp3_;
#line 34 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (username != NULL, NULL);
#line 34 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (password != NULL, NULL);
#line 34 "../plugins/backend/feedbin/feedbinAPI.vala"
	self = (FeedbinAPI*) g_object_new (object_type, NULL);
#line 36 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_set_username (self, username);
#line 37 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_set_password (self, password);
#line 38 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_strdup_printf (FEEDBIN_API_BASE_URI_FORMAT, host);
#line 38 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (self->priv->m_base_uri);
#line 38 "../plugins/backend/feedbin/feedbinAPI.vala"
	self->priv->m_base_uri = _tmp0_;
#line 39 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = soup_session_new ();
#line 39 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (self->priv->m_session);
#line 39 "../plugins/backend/feedbin/feedbinAPI.vala"
	self->priv->m_session = _tmp1_;
#line 41 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (user_agent != NULL) {
#line 353 "feedbinAPI.c"
		SoupSession* _tmp2_;
#line 42 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp2_ = self->priv->m_session;
#line 42 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_object_set (_tmp2_, "user-agent", user_agent, NULL);
#line 359 "feedbinAPI.c"
	}
#line 44 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = self->priv->m_session;
#line 44 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_signal_connect_object (_tmp3_, "authenticate", (GCallback) _feedbin_api_authenticate_soup_session_authenticate, self, 0);
#line 34 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self;
#line 367 "feedbinAPI.c"
}


FeedbinAPI*
feedbin_api_new (const gchar* username,
                 const gchar* password,
                 const gchar* user_agent,
                 const gchar* host)
{
#line 34 "../plugins/backend/feedbin/feedbinAPI.vala"
	return feedbin_api_construct (TYPE_FEEDBIN_API, username, password, user_agent, host);
#line 379 "feedbinAPI.c"
}


static void
feedbin_api_authenticate (FeedbinAPI* self,
                          SoupMessage* msg,
                          SoupAuth* auth,
                          gboolean retrying)
{
#line 52 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 52 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (msg != NULL);
#line 52 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (auth != NULL);
#line 54 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (!retrying) {
#line 397 "feedbinAPI.c"
		const gchar* _tmp0_;
		const gchar* _tmp1_;
#line 55 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = self->priv->_username;
#line 55 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp1_ = self->priv->_password;
#line 55 "../plugins/backend/feedbin/feedbinAPI.vala"
		soup_auth_authenticate (auth, _tmp0_, _tmp1_);
#line 406 "feedbinAPI.c"
	}
}


static guint8*
string_get_data (const gchar* self,
                 int* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1499 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1499 "glib-2.0.vapi"
	res_length1 = -1;
#line 1499 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1500 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1500 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1500 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1501 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1501 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1501 "glib-2.0.vapi"
	_tmp3_ = _tmp2_;
#line 1501 "glib-2.0.vapi"
	_tmp3__length1 = _tmp2__length1;
#line 1501 "glib-2.0.vapi"
	if (result_length1) {
#line 1501 "glib-2.0.vapi"
		*result_length1 = _tmp3__length1;
#line 451 "feedbinAPI.c"
	}
#line 1501 "glib-2.0.vapi"
	result = _tmp3_;
#line 1501 "glib-2.0.vapi"
	return result;
#line 457 "feedbinAPI.c"
}


static guint8*
_vala_array_dup1 (guint8* self,
                  int length)
{
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 467 "feedbinAPI.c"
}


static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1513 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	result = self;
#line 1514 "glib-2.0.vapi"
	return result;
#line 481 "feedbinAPI.c"
}


static SoupMessage*
feedbin_api_request (FeedbinAPI* self,
                     const gchar* method,
                     const gchar* last_part,
                     const gchar* input,
                     GError** error)
{
	SoupMessage* result = NULL;
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	SoupMessage* message = NULL;
	const gchar* _tmp2_;
	SoupMessage* _tmp3_;
	SoupSession* _tmp11_;
	SoupMessage* _tmp12_;
	guint status = 0U;
	SoupMessage* _tmp13_;
	guint _tmp14_;
	guint _tmp15_;
	gboolean _tmp16_ = FALSE;
	guint _tmp17_;
	SoupMessage* _tmp55_;
	guint _tmp56_;
	guint _tmp57_;
	SoupMessage* _tmp58_;
	guint _tmp59_;
	guint _tmp60_;
	SoupMessage* _tmp61_;
	guint _tmp62_;
	guint _tmp63_;
	SoupMessage* _tmp64_;
	guint _tmp65_;
	guint _tmp66_;
	GError * _inner_error_ = NULL;
#line 58 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (method != NULL, NULL);
#line 58 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (last_part != NULL, NULL);
#line 58 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_val_if_fail (((g_strcmp0 (method, "DELETE") == 0) || (g_strcmp0 (method, "GET") == 0)) || (g_strcmp0 (method, "POST") == 0), "method == \"DELETE\" || method == \"GET\" || method == \"POST\"", NULL);
#line 58 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_val_if_fail ((input == NULL) || (g_strcmp0 (method, "GET") != 0), "input == null || method != \"GET\"", NULL);
#line 64 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = self->priv->m_base_uri;
#line 64 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strconcat (_tmp0_, last_part, NULL);
#line 64 "../plugins/backend/feedbin/feedbinAPI.vala"
	path = _tmp1_;
#line 65 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = path;
#line 65 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = soup_message_new (method, _tmp2_);
#line 65 "../plugins/backend/feedbin/feedbinAPI.vala"
	message = _tmp3_;
#line 67 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (g_strcmp0 (method, "POST") == 0) {
#line 544 "feedbinAPI.c"
		SoupMessage* _tmp4_;
		SoupMessageHeaders* _tmp5_;
#line 68 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp4_ = message;
#line 68 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp5_ = _tmp4_->request_headers;
#line 68 "../plugins/backend/feedbin/feedbinAPI.vala"
		soup_message_headers_append (_tmp5_, "Content-Type", "application/json; charset=utf-8");
#line 553 "feedbinAPI.c"
	}
#line 70 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (input != NULL) {
#line 557 "feedbinAPI.c"
		SoupMessage* _tmp6_;
		SoupMessageBody* _tmp7_;
		guint8* _tmp8_;
		gint _tmp8__length1;
		guint8* _tmp9_;
		gint _tmp9__length1;
		guint8* _tmp10_;
		gint _tmp10__length1;
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp6_ = message;
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp7_ = _tmp6_->request_body;
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp8_ = string_get_data (input, &_tmp8__length1);
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp9_ = _tmp8_;
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp9__length1 = _tmp8__length1;
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp10_ = (_tmp9_ != NULL) ? _vala_array_dup1 (_tmp9_, _tmp9__length1) : ((gpointer) _tmp9_);
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp10__length1 = _tmp9__length1;
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
		soup_message_body_append_take (_tmp7_, _tmp10_, (gsize) _tmp10__length1);
#line 582 "feedbinAPI.c"
	}
#line 73 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp11_ = self->priv->m_session;
#line 73 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp12_ = message;
#line 73 "../plugins/backend/feedbin/feedbinAPI.vala"
	soup_session_send_message (_tmp11_, _tmp12_);
#line 74 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp13_ = message;
#line 74 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_get (_tmp13_, "status-code", &_tmp14_, NULL);
#line 74 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp15_ = _tmp14_;
#line 74 "../plugins/backend/feedbin/feedbinAPI.vala"
	status = _tmp15_;
#line 75 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp17_ = status;
#line 75 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_tmp17_ < ((guint) 200)) {
#line 75 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp16_ = TRUE;
#line 604 "feedbinAPI.c"
	} else {
		guint _tmp18_;
#line 75 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp18_ = status;
#line 75 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp16_ = _tmp18_ >= ((guint) 400);
#line 611 "feedbinAPI.c"
	}
#line 75 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_tmp16_) {
#line 615 "feedbinAPI.c"
		guint _tmp19_;
		gchar* phrase = NULL;
		guint _tmp40_;
		const gchar* _tmp41_;
		gchar* _tmp42_;
		guint _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		const gchar* _tmp46_;
		const gchar* _tmp47_;
		const gchar* _tmp48_;
		const gchar* _tmp49_;
		const gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
		GError* _tmp53_;
		GError* _tmp54_;
#line 77 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp19_ = status;
#line 77 "../plugins/backend/feedbin/feedbinAPI.vala"
		switch (_tmp19_) {
#line 77 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_CANT_RESOLVE:
#line 77 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_CANT_RESOLVE_PROXY:
#line 77 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_CANT_CONNECT:
#line 77 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_CANT_CONNECT_PROXY:
#line 645 "feedbinAPI.c"
			{
				const gchar* _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
				GError* _tmp24_;
				GError* _tmp25_;
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp20_ = self->priv->m_base_uri;
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp21_ = string_to_string (_tmp20_);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp22_ = g_strconcat ("Connection to ", _tmp21_, " failed", NULL);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp23_ = _tmp22_;
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp24_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_NO_CONNECTION, _tmp23_);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp25_ = _tmp24_;
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_g_free0 (_tmp23_);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_inner_error_ = _tmp25_;
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_propagate_error (error, _inner_error_);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 679 "feedbinAPI.c"
				} else {
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_clear_error (&_inner_error_);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 691 "feedbinAPI.c"
				}
			}
#line 77 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_UNAUTHORIZED:
#line 696 "feedbinAPI.c"
			{
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				const gchar* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				GError* _tmp31_;
				GError* _tmp32_;
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp26_ = string_to_string (method);
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp27_ = path;
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp28_ = string_to_string (_tmp27_);
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp29_ = g_strconcat ("Not authorized to ", _tmp26_, " ", _tmp28_, NULL);
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp30_ = _tmp29_;
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp31_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_AUTHORIZED, _tmp30_);
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp32_ = _tmp31_;
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
				_g_free0 (_tmp30_);
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
				_inner_error_ = _tmp32_;
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_propagate_error (error, _inner_error_);
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 733 "feedbinAPI.c"
				} else {
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_clear_error (&_inner_error_);
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 745 "feedbinAPI.c"
				}
			}
#line 77 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_NOT_FOUND:
#line 750 "feedbinAPI.c"
			{
				const gchar* _tmp33_;
				const gchar* _tmp34_;
				const gchar* _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				GError* _tmp38_;
				GError* _tmp39_;
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp33_ = string_to_string (method);
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp34_ = path;
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp35_ = string_to_string (_tmp34_);
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp36_ = g_strconcat (_tmp33_, " ", _tmp35_, " not found", NULL);
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp37_ = _tmp36_;
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp38_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND, _tmp37_);
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp39_ = _tmp38_;
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
				_g_free0 (_tmp37_);
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
				_inner_error_ = _tmp39_;
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_propagate_error (error, _inner_error_);
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 787 "feedbinAPI.c"
				} else {
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_clear_error (&_inner_error_);
#line 87 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 799 "feedbinAPI.c"
				}
			}
			default:
#line 77 "../plugins/backend/feedbin/feedbinAPI.vala"
			break;
#line 805 "feedbinAPI.c"
		}
#line 89 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp40_ = status;
#line 89 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp41_ = soup_status_get_phrase (_tmp40_);
#line 89 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp42_ = g_strdup (_tmp41_);
#line 89 "../plugins/backend/feedbin/feedbinAPI.vala"
		phrase = _tmp42_;
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp43_ = status;
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp44_ = g_strdup_printf ("%u", _tmp43_);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp45_ = _tmp44_;
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp46_ = phrase;
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp47_ = string_to_string (_tmp46_);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp48_ = string_to_string (method);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp49_ = path;
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp50_ = string_to_string (_tmp49_);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp51_ = g_strconcat ("Unexpected status ", _tmp45_, " (", _tmp47_, ") for ", _tmp48_, " ", _tmp50_, NULL);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp52_ = _tmp51_;
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp53_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_UNKNOWN_ERROR, _tmp52_);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp54_ = _tmp53_;
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp52_);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp45_);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = _tmp54_;
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (phrase);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (message);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 857 "feedbinAPI.c"
		} else {
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (phrase);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (message);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 90 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 871 "feedbinAPI.c"
		}
#line 75 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (phrase);
#line 875 "feedbinAPI.c"
	}
#line 92 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = message;
#line 92 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (path);
#line 92 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp55_ = result;
#line 92 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_get (_tmp55_, "status-code", &_tmp56_, NULL);
#line 92 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp57_ = _tmp56_;
#line 92 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_warn_if_fail (_tmp57_ >= ((guint) 200), "result.status_code >= 200");
#line 92 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp58_ = result;
#line 92 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_get (_tmp58_, "status-code", &_tmp59_, NULL);
#line 92 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp60_ = _tmp59_;
#line 92 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_warn_if_fail (_tmp60_ < ((guint) 400), "result.status_code < 400");
#line 92 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 899 "feedbinAPI.c"
}


static GDateTime*
feedbin_api_string_to_datetime (const gchar* s,
                                GError** error)
{
	GDateTime* result = NULL;
	GTimeVal time = {0};
	GTimeVal _tmp5_;
	GDateTime* _tmp6_;
	GError * _inner_error_ = NULL;
#line 96 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_get_current_time (&time);
#line 99 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (!g_time_val_from_iso8601 (s, &time)) {
#line 918 "feedbinAPI.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = string_to_string (s);
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp1_ = g_strconcat ("Expected date but got ", _tmp0_, NULL);
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp2_ = _tmp1_;
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp3_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_INVALID_FORMAT, _tmp2_);
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp4_ = _tmp3_;
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp2_);
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = _tmp4_;
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 944 "feedbinAPI.c"
		} else {
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 952 "feedbinAPI.c"
		}
	}
#line 101 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = time;
#line 101 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = g_date_time_new_from_timeval_utc (&_tmp5_);
#line 101 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp6_;
#line 101 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 963 "feedbinAPI.c"
}


static GDateTime*
feedbin_api_get_datetime_member (JsonObject* obj,
                                 const gchar* name,
                                 GError** error)
{
	GDateTime* result = NULL;
	gchar* s = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GDateTime* _tmp2_ = NULL;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GError * _inner_error_ = NULL;
#line 105 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (obj != NULL, NULL);
#line 105 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 105 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_val_if_fail (g_strcmp0 (name, "") != 0, "name != \"\"", NULL);
#line 108 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_get_string_member (obj, name);
#line 108 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 108 "../plugins/backend/feedbin/feedbinAPI.vala"
	s = _tmp1_;
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = feedbin_api_string_to_datetime (s, &_inner_error_);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp3_;
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (s);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1006 "feedbinAPI.c"
		} else {
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (s);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1016 "feedbinAPI.c"
		}
	}
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = _tmp2_;
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = NULL;
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp4_;
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 (_tmp2_);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (s);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1031 "feedbinAPI.c"
}


static SoupMessage*
feedbin_api_post_request (FeedbinAPI* self,
                          const gchar* path,
                          const gchar* input,
                          GError** error)
{
	SoupMessage* result = NULL;
	SoupMessage* _tmp0_ = NULL;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	GError * _inner_error_ = NULL;
#line 112 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 112 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 112 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 112 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_val_if_fail (g_strcmp0 (input, "") != 0, "input != \"\"", NULL);
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_request (self, "POST", path, input, &_inner_error_);
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1066 "feedbinAPI.c"
		} else {
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1074 "feedbinAPI.c"
		}
	}
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp2_;
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp0_);
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1087 "feedbinAPI.c"
}


static SoupMessage*
feedbin_api_delete_request (FeedbinAPI* self,
                            const gchar* path,
                            GError** error)
{
	SoupMessage* result = NULL;
	SoupMessage* _tmp0_ = NULL;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	GError * _inner_error_ = NULL;
#line 118 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 118 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 120 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_request (self, "DELETE", path, NULL, &_inner_error_);
#line 120 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 120 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 120 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 120 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 120 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1117 "feedbinAPI.c"
		} else {
#line 120 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 120 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 120 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1125 "feedbinAPI.c"
		}
	}
#line 120 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 120 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 120 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp2_;
#line 120 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp0_);
#line 120 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1138 "feedbinAPI.c"
}


static SoupMessage*
feedbin_api_get_request (FeedbinAPI* self,
                         const gchar* path,
                         GError** error)
{
	SoupMessage* result = NULL;
	SoupMessage* _tmp0_ = NULL;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	GError * _inner_error_ = NULL;
#line 123 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 123 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_request (self, "GET", path, NULL, &_inner_error_);
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1168 "feedbinAPI.c"
		} else {
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1176 "feedbinAPI.c"
		}
	}
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp2_;
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp0_);
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1189 "feedbinAPI.c"
}


static void
_vala_SoupBuffer_free (SoupBuffer* self)
{
#line 132 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_boxed_free (soup_buffer_get_type (), self);
#line 1198 "feedbinAPI.c"
}


static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 1207 "feedbinAPI.c"
}


static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 1216 "feedbinAPI.c"
}


static JsonNode*
feedbin_api_parse_json (SoupMessage* response,
                        GError** error)
{
	JsonNode* result = NULL;
	gchar* method = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* uri = NULL;
	SoupURI* _tmp2_;
	SoupURI* _tmp3_;
	gchar* _tmp4_;
	gchar* content = NULL;
	SoupMessageBody* _tmp5_;
	SoupBuffer* _tmp6_;
	SoupBuffer* _tmp7_;
	guint8* _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	JsonParser* parser = NULL;
	JsonParser* _tmp20_;
	JsonParser* _tmp37_;
	JsonNode* _tmp38_;
	JsonNode* _tmp39_;
	GError * _inner_error_ = NULL;
#line 128 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (response != NULL, NULL);
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_get (response, "method", &_tmp0_, NULL);
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _tmp0_;
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
	method = _tmp1_;
#line 131 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = soup_message_get_uri (response);
#line 131 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp2_;
#line 131 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = soup_uri_to_string (_tmp3_, FALSE);
#line 131 "../plugins/backend/feedbin/feedbinAPI.vala"
	uri = _tmp4_;
#line 132 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = response->response_body;
#line 132 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = soup_message_body_flatten (_tmp5_);
#line 132 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = _tmp6_;
#line 132 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = _tmp7_->data;
#line 132 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8__length1 = (gint) _tmp7_->length;
#line 132 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = g_strdup ((const gchar*) _tmp8_);
#line 132 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp10_ = _tmp9_;
#line 132 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_SoupBuffer_free0 (_tmp7_);
#line 132 "../plugins/backend/feedbin/feedbinAPI.vala"
	content = _tmp10_;
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp11_ = content;
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_tmp11_ == NULL) {
#line 1285 "feedbinAPI.c"
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GError* _tmp18_;
		GError* _tmp19_;
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp12_ = method;
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp13_ = string_to_string (_tmp12_);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp14_ = uri;
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp15_ = string_to_string (_tmp14_);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp16_ = g_strconcat (_tmp13_, " ", _tmp15_, " returned no content but expected JSON", NULL);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp17_ = _tmp16_;
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp18_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_INVALID_FORMAT, _tmp17_);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp19_ = _tmp18_;
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp17_);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = _tmp19_;
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (content);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (uri);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (method);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1326 "feedbinAPI.c"
		} else {
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (content);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (uri);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (method);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1340 "feedbinAPI.c"
		}
	}
#line 138 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp20_ = json_parser_new ();
#line 138 "../plugins/backend/feedbin/feedbinAPI.vala"
	parser = _tmp20_;
#line 1347 "feedbinAPI.c"
	{
		JsonParser* _tmp21_;
		const gchar* _tmp22_;
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp21_ = parser;
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp22_ = content;
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
		json_parser_load_from_data (_tmp21_, _tmp22_, (gssize) -1, &_inner_error_);
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1359 "feedbinAPI.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		GError* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		GError* _tmp35_;
		GError* _tmp36_;
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		e = _inner_error_;
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = NULL;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp23_ = method;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp24_ = string_to_string (_tmp23_);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp25_ = uri;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp26_ = string_to_string (_tmp25_);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp27_ = g_strconcat (_tmp24_, " ", _tmp26_, " returned invalid JSON: ", NULL);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp28_ = _tmp27_;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp29_ = e;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp30_ = _tmp29_->message;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp31_ = g_strconcat (_tmp28_, _tmp30_, NULL);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp32_ = _tmp31_;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp33_ = g_strconcat (_tmp32_, "\nContent is: $content", NULL);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp34_ = _tmp33_;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp35_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_INVALID_FORMAT, _tmp34_);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp36_ = _tmp35_;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp34_);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp32_);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp28_);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = _tmp36_;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_error_free0 (e);
#line 1423 "feedbinAPI.c"
		goto __finally0;
	}
	__finally0:
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (parser);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (content);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (uri);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (method);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1443 "feedbinAPI.c"
		} else {
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (parser);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (content);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (uri);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (method);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1459 "feedbinAPI.c"
		}
	}
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp37_ = parser;
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp38_ = json_parser_get_root (_tmp37_);
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp39_ = __vala_JsonNode_copy0 (_tmp38_);
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp39_;
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (parser);
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (content);
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (uri);
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (method);
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1480 "feedbinAPI.c"
}


static void
_vala_JsonNode_free (JsonNode* self)
{
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_boxed_free (json_node_get_type (), self);
#line 1489 "feedbinAPI.c"
}


static JsonNode*
feedbin_api_get_json (FeedbinAPI* self,
                      const gchar* path,
                      GError** error)
{
	JsonNode* result = NULL;
	SoupMessage* response = NULL;
	SoupMessage* _tmp0_;
	JsonNode* _tmp1_ = NULL;
	SoupMessage* _tmp2_;
	JsonNode* _tmp3_;
	JsonNode* _tmp4_;
	GError * _inner_error_ = NULL;
#line 150 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 150 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_val_if_fail (g_strcmp0 (path, "") != 0, "path != \"\"", NULL);
#line 153 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = feedbin_api_get_request (self, path, &_inner_error_);
#line 153 "../plugins/backend/feedbin/feedbinAPI.vala"
	response = _tmp0_;
#line 153 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 153 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 153 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 153 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1524 "feedbinAPI.c"
		} else {
#line 153 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 153 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 153 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1532 "feedbinAPI.c"
		}
	}
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = response;
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = feedbin_api_parse_json (_tmp2_, &_inner_error_);
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _tmp3_;
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (response);
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1551 "feedbinAPI.c"
		} else {
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (response);
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1561 "feedbinAPI.c"
		}
	}
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = _tmp1_;
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = NULL;
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp4_;
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (_tmp1_);
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (response);
#line 154 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1576 "feedbinAPI.c"
}


static SoupMessage*
feedbin_api_post_json_object (FeedbinAPI* self,
                              const gchar* path,
                              JsonObject* obj,
                              GError** error)
{
	SoupMessage* result = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp0_;
	JsonGenerator* gen = NULL;
	JsonGenerator* _tmp1_;
	gchar* data = NULL;
	gchar* _tmp2_;
	SoupMessage* _tmp3_ = NULL;
	SoupMessage* _tmp4_;
	SoupMessage* _tmp5_;
	GError * _inner_error_ = NULL;
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (obj != NULL, NULL);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_node_new (JSON_NODE_OBJECT);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
	root = _tmp0_;
#line 160 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_node_set_object (root, obj);
#line 162 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = json_generator_new ();
#line 162 "../plugins/backend/feedbin/feedbinAPI.vala"
	gen = _tmp1_;
#line 163 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_generator_set_root (gen, root);
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = json_generator_to_data (gen, NULL);
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
	data = _tmp2_;
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = feedbin_api_post_request (self, path, data, &_inner_error_);
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp4_;
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (data);
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (gen);
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1637 "feedbinAPI.c"
		} else {
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (data);
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (gen);
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1651 "feedbinAPI.c"
		}
	}
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = _tmp3_;
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = NULL;
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp5_;
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp3_);
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (data);
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (gen);
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1670 "feedbinAPI.c"
}


gboolean
feedbin_api_login (FeedbinAPI* self,
                   GError** error)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 169 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1682 "feedbinAPI.c"
	{
		SoupMessage* res = NULL;
		SoupMessage* _tmp0_;
		guint _tmp1_;
		guint _tmp2_;
#line 173 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = feedbin_api_get_request (self, "authentication.json", &_inner_error_);
#line 173 "../plugins/backend/feedbin/feedbinAPI.vala"
		res = _tmp0_;
#line 173 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 173 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_AUTHORIZED)) {
#line 1696 "feedbinAPI.c"
				goto __catch1_feedbin_error_not_authorized;
			}
			goto __finally1;
		}
#line 174 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_object_get (res, "status-code", &_tmp1_, NULL);
#line 174 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp2_ = _tmp1_;
#line 174 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = _tmp2_ == ((guint) SOUP_STATUS_OK);
#line 174 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_object_unref0 (res);
#line 174 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 1711 "feedbinAPI.c"
	}
	goto __finally1;
	__catch1_feedbin_error_not_authorized:
	{
		GError* e = NULL;
#line 171 "../plugins/backend/feedbin/feedbinAPI.vala"
		e = _inner_error_;
#line 171 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = NULL;
#line 178 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = FALSE;
#line 178 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_error_free0 (e);
#line 178 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 1727 "feedbinAPI.c"
	}
	__finally1:
#line 171 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 1732 "feedbinAPI.c"
		gboolean _tmp3_ = FALSE;
#line 171 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_propagate_error (error, _inner_error_);
#line 171 "../plugins/backend/feedbin/feedbinAPI.vala"
		return _tmp3_;
#line 1738 "feedbinAPI.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 171 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 171 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_clear_error (&_inner_error_);
#line 171 "../plugins/backend/feedbin/feedbinAPI.vala"
		return _tmp4_;
#line 1747 "feedbinAPI.c"
	}
}


void
feedbin_api_get_subscription (FeedbinAPI* self,
                              gint64 subscription_id,
                              FeedbinAPISubscription* result,
                              GError** error)
{
	JsonNode* root = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	JsonNode* _tmp4_;
	JsonNode* _tmp5_;
	FeedbinAPISubscription _tmp6_ = {0};
	JsonNode* _tmp7_;
	JsonObject* _tmp8_;
	FeedbinAPISubscription _tmp9_;
	GError * _inner_error_ = NULL;
#line 201 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, subscription_id);
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _tmp0_;
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = g_strconcat ("subscriptions/", _tmp1_, ".json", NULL);
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp2_;
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = feedbin_api_get_json (self, _tmp3_, &_inner_error_);
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = _tmp4_;
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp3_);
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp1_);
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	root = _tmp5_;
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 1798 "feedbinAPI.c"
		} else {
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 1806 "feedbinAPI.c"
		}
	}
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = root;
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = json_node_get_object (_tmp7_);
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_subscription_init_from_json (&_tmp6_, _tmp8_, &_inner_error_);
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 1825 "feedbinAPI.c"
		} else {
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 1835 "feedbinAPI.c"
		}
	}
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = _tmp6_;
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	memset (&_tmp6_, 0, sizeof (FeedbinAPISubscription));
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	*result = _tmp9_;
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_subscription_destroy (&_tmp6_);
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	return;
#line 1850 "feedbinAPI.c"
}


static gpointer
_json_array_ref0 (gpointer self)
{
#line 212 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self ? json_array_ref (self) : NULL;
#line 1859 "feedbinAPI.c"
}


static gpointer
_json_object_ref0 (gpointer self)
{
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self ? json_object_ref (self) : NULL;
#line 1868 "feedbinAPI.c"
}


GeeList*
feedbin_api_get_subscriptions (FeedbinAPI* self,
                               GError** error)
{
	GeeList* result = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp0_;
	GeeArrayList* subscriptions = NULL;
	GeeArrayList* _tmp1_;
	JsonArray* array = NULL;
	JsonNode* _tmp2_;
	JsonArray* _tmp3_;
	JsonArray* _tmp4_;
	GeeList* _tmp16_;
	GeeList* _tmp17_;
	GError * _inner_error_ = NULL;
#line 207 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 210 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = feedbin_api_get_json (self, "subscriptions.json", &_inner_error_);
#line 210 "../plugins/backend/feedbin/feedbinAPI.vala"
	root = _tmp0_;
#line 210 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 210 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 210 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 210 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1902 "feedbinAPI.c"
		} else {
#line 210 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 210 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 210 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1910 "feedbinAPI.c"
		}
	}
#line 211 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = gee_array_list_new (FEEDBIN_API_TYPE_SUBSCRIPTION, (GBoxedCopyFunc) feedbin_api_subscription_dup, (GDestroyNotify) feedbin_api_subscription_free, NULL, NULL, NULL);
#line 211 "../plugins/backend/feedbin/feedbinAPI.vala"
	subscriptions = _tmp1_;
#line 212 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = root;
#line 212 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = json_node_get_array (_tmp2_);
#line 212 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = _json_array_ref0 (_tmp3_);
#line 212 "../plugins/backend/feedbin/feedbinAPI.vala"
	array = _tmp4_;
#line 1925 "feedbinAPI.c"
	{
		gint i = 0;
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
		i = 0;
#line 1930 "feedbinAPI.c"
		{
			gboolean _tmp5_ = FALSE;
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp5_ = TRUE;
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
			while (TRUE) {
#line 1937 "feedbinAPI.c"
				gint _tmp7_;
				JsonArray* _tmp8_;
				JsonObject* node = NULL;
				JsonArray* _tmp9_;
				gint _tmp10_;
				JsonObject* _tmp11_;
				JsonObject* _tmp12_;
				FeedbinAPISubscription _tmp13_ = {0};
				JsonObject* _tmp14_;
				GeeArrayList* _tmp15_;
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!_tmp5_) {
#line 1950 "feedbinAPI.c"
					gint _tmp6_;
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp6_ = i;
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
					i = _tmp6_ + 1;
#line 1956 "feedbinAPI.c"
				}
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp5_ = FALSE;
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp7_ = i;
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp8_ = array;
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!(((guint) _tmp7_) < json_array_get_length (_tmp8_))) {
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
					break;
#line 1968 "feedbinAPI.c"
				}
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp9_ = array;
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp10_ = i;
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp11_ = json_array_get_object_element (_tmp9_, (guint) _tmp10_);
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp12_ = _json_object_ref0 (_tmp11_);
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
				node = _tmp12_;
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp14_ = node;
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_subscription_init_from_json (&_tmp13_, _tmp14_, &_inner_error_);
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_propagate_error (error, _inner_error_);
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (node);
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_array_unref0 (array);
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_object_unref0 (subscriptions);
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
						__vala_JsonNode_free0 (root);
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
						return NULL;
#line 2000 "feedbinAPI.c"
					} else {
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (node);
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_array_unref0 (array);
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_object_unref0 (subscriptions);
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
						__vala_JsonNode_free0 (root);
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_clear_error (&_inner_error_);
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
						return NULL;
#line 2016 "feedbinAPI.c"
					}
				}
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp15_ = subscriptions;
#line 216 "../plugins/backend/feedbin/feedbinAPI.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, &_tmp13_);
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_subscription_destroy (&_tmp13_);
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
				_json_object_unref0 (node);
#line 2027 "feedbinAPI.c"
			}
		}
	}
#line 218 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = (GeeList*) subscriptions;
#line 218 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_array_unref0 (array);
#line 218 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 218 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp16_ = result;
#line 218 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_warn_if_fail (!gee_collection_contains ((GeeCollection*) _tmp16_, NULL), "!result.contains(null)");
#line 218 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2043 "feedbinAPI.c"
}


void
feedbin_api_delete_subscription (FeedbinAPI* self,
                                 gint64 subscription_id,
                                 GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	SoupMessage* _tmp4_;
	SoupMessage* _tmp5_;
	GError * _inner_error_ = NULL;
#line 221 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, subscription_id);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _tmp0_;
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = g_strconcat ("subscriptions/", _tmp1_, ".json", NULL);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp2_;
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = feedbin_api_delete_request (self, _tmp3_, &_inner_error_);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = _tmp4_;
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp5_);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp3_);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp1_);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2087 "feedbinAPI.c"
		} else {
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2095 "feedbinAPI.c"
		}
	}
}


static gpointer
_feedbin_api_subscription_dup0 (gpointer self)
{
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self ? feedbin_api_subscription_dup (self) : NULL;
#line 2106 "feedbinAPI.c"
}


FeedbinAPISubscription*
feedbin_api_add_subscription (FeedbinAPI* self,
                              const gchar* url,
                              GError** error)
{
	FeedbinAPISubscription* result = NULL;
	JsonObject* object = NULL;
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	GError * _inner_error_ = NULL;
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 228 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_new ();
#line 228 "../plugins/backend/feedbin/feedbinAPI.vala"
	object = _tmp0_;
#line 229 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = object;
#line 229 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_object_set_string_member (_tmp1_, "feed_url", url);
#line 2132 "feedbinAPI.c"
	{
		SoupMessage* response = NULL;
		JsonObject* _tmp2_;
		SoupMessage* _tmp3_;
		SoupMessage* _tmp4_;
		guint _tmp5_;
		guint _tmp6_;
		JsonNode* root = NULL;
		SoupMessage* _tmp8_;
		JsonNode* _tmp9_;
		FeedbinAPISubscription _tmp10_ = {0};
		JsonNode* _tmp11_;
		JsonObject* _tmp12_;
		FeedbinAPISubscription _tmp13_;
		FeedbinAPISubscription _tmp14_;
		FeedbinAPISubscription* _tmp15_;
		FeedbinAPISubscription* _tmp16_;
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp2_ = object;
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp3_ = feedbin_api_post_json_object (self, "subscriptions.json", _tmp2_, &_inner_error_);
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
		response = _tmp3_;
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
#line 2160 "feedbinAPI.c"
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
#line 234 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp4_ = response;
#line 234 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_object_get (_tmp4_, "status-code", &_tmp5_, NULL);
#line 234 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp6_ = _tmp5_;
#line 234 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_tmp6_ == ((guint) 300)) {
#line 2173 "feedbinAPI.c"
			GError* _tmp7_;
#line 235 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp7_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_MULTIPLE_CHOICES, "Site $url has multiple feeds to subscribe to");
#line 235 "../plugins/backend/feedbin/feedbinAPI.vala"
			_inner_error_ = _tmp7_;
#line 235 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (response);
#line 235 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
#line 2183 "feedbinAPI.c"
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
#line 237 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp8_ = response;
#line 237 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp9_ = feedbin_api_parse_json (_tmp8_, &_inner_error_);
#line 237 "../plugins/backend/feedbin/feedbinAPI.vala"
		root = _tmp9_;
#line 237 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 237 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (response);
#line 237 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
#line 2200 "feedbinAPI.c"
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp11_ = root;
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp12_ = json_node_get_object (_tmp11_);
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		feedbin_api_subscription_init_from_json (&_tmp10_, _tmp12_, &_inner_error_);
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (response);
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
#line 2219 "feedbinAPI.c"
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp13_ = _tmp10_;
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		memset (&_tmp10_, 0, sizeof (FeedbinAPISubscription));
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp14_ = _tmp13_;
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp15_ = _feedbin_api_subscription_dup0 (&_tmp14_);
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp16_ = _tmp15_;
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		feedbin_api_subscription_destroy (&_tmp14_);
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = _tmp16_;
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		feedbin_api_subscription_destroy (&_tmp10_);
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		__vala_JsonNode_free0 (root);
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_object_unref0 (response);
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		_json_object_unref0 (object);
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 2248 "feedbinAPI.c"
	}
	goto __finally2;
	__catch2_feedbin_error_not_found:
	{
		GError* e = NULL;
#line 231 "../plugins/backend/feedbin/feedbinAPI.vala"
		e = _inner_error_;
#line 231 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = NULL;
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = NULL;
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_error_free0 (e);
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
		_json_object_unref0 (object);
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 2266 "feedbinAPI.c"
	}
	__finally2:
#line 231 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 231 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_propagate_error (error, _inner_error_);
#line 231 "../plugins/backend/feedbin/feedbinAPI.vala"
		_json_object_unref0 (object);
#line 231 "../plugins/backend/feedbin/feedbinAPI.vala"
		return NULL;
#line 2277 "feedbinAPI.c"
	} else {
#line 231 "../plugins/backend/feedbin/feedbinAPI.vala"
		_json_object_unref0 (object);
#line 231 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 231 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_clear_error (&_inner_error_);
#line 231 "../plugins/backend/feedbin/feedbinAPI.vala"
		return NULL;
#line 2287 "feedbinAPI.c"
	}
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_object_unref0 (object);
#line 2291 "feedbinAPI.c"
}


void
feedbin_api_rename_subscription (FeedbinAPI* self,
                                 gint64 subscription_id,
                                 const gchar* title,
                                 GError** error)
{
	JsonObject* object = NULL;
	JsonObject* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	SoupMessage* _tmp5_;
	SoupMessage* _tmp6_;
	GError * _inner_error_ = NULL;
#line 246 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 246 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (title != NULL);
#line 248 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_new ();
#line 248 "../plugins/backend/feedbin/feedbinAPI.vala"
	object = _tmp0_;
#line 249 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_object_set_string_member (object, "title", title);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup_printf ("%" G_GINT64_FORMAT, subscription_id);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp1_;
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = g_strconcat ("subscriptions/", _tmp2_, "/update.json", NULL);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = _tmp3_;
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = feedbin_api_post_json_object (self, _tmp4_, object, &_inner_error_);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = _tmp5_;
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp6_);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp4_);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp2_);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2348 "feedbinAPI.c"
		} else {
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2358 "feedbinAPI.c"
		}
	}
#line 246 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_object_unref0 (object);
#line 2363 "feedbinAPI.c"
}


void
feedbin_api_add_tagging (FeedbinAPI* self,
                         gint64 feed_id,
                         const gchar* tag_name,
                         GError** error)
{
	JsonObject* object = NULL;
	JsonObject* _tmp0_;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	GError * _inner_error_ = NULL;
#line 267 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 267 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (tag_name != NULL);
#line 269 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_new ();
#line 269 "../plugins/backend/feedbin/feedbinAPI.vala"
	object = _tmp0_;
#line 270 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_object_set_int_member (object, "feed_id", feed_id);
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_object_set_string_member (object, "name", tag_name);
#line 273 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_post_json_object (self, "taggings.json", object, &_inner_error_);
#line 273 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp1_;
#line 273 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp2_);
#line 273 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 273 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 273 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 273 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 273 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2406 "feedbinAPI.c"
		} else {
#line 273 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 273 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 273 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 273 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2416 "feedbinAPI.c"
		}
	}
#line 267 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_object_unref0 (object);
#line 2421 "feedbinAPI.c"
}


void
feedbin_api_delete_tagging (FeedbinAPI* self,
                            gint64 tagging_id,
                            GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	SoupMessage* _tmp4_;
	SoupMessage* _tmp5_;
	GError * _inner_error_ = NULL;
#line 277 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, tagging_id);
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _tmp0_;
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = g_strconcat ("taggings/", _tmp1_, ".json", NULL);
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp2_;
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = feedbin_api_delete_request (self, _tmp3_, &_inner_error_);
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = _tmp4_;
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp5_);
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp3_);
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp1_);
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2465 "feedbinAPI.c"
		} else {
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2473 "feedbinAPI.c"
		}
	}
}


GeeList*
feedbin_api_get_taggings (FeedbinAPI* self,
                          GError** error)
{
	GeeList* result = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp0_;
	GeeArrayList* taggings = NULL;
	GeeArrayList* _tmp1_;
	JsonArray* array = NULL;
	JsonArray* _tmp2_;
	JsonArray* _tmp3_;
	GeeList* _tmp17_;
	GeeList* _tmp18_;
	GError * _inner_error_ = NULL;
#line 282 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = feedbin_api_get_json (self, "taggings.json", &_inner_error_);
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
	root = _tmp0_;
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 2508 "feedbinAPI.c"
		} else {
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 2516 "feedbinAPI.c"
		}
	}
#line 286 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = gee_array_list_new (FEEDBIN_API_TYPE_TAGGING, (GBoxedCopyFunc) feedbin_api_tagging_dup, (GDestroyNotify) feedbin_api_tagging_free, NULL, NULL, NULL);
#line 286 "../plugins/backend/feedbin/feedbinAPI.vala"
	taggings = _tmp1_;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = json_node_get_array (root);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _json_array_ref0 (_tmp2_);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	array = _tmp3_;
#line 2529 "feedbinAPI.c"
	{
		gint i = 0;
#line 288 "../plugins/backend/feedbin/feedbinAPI.vala"
		i = 0;
#line 2534 "feedbinAPI.c"
		{
			gboolean _tmp4_ = FALSE;
#line 288 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp4_ = TRUE;
#line 288 "../plugins/backend/feedbin/feedbinAPI.vala"
			while (TRUE) {
#line 2541 "feedbinAPI.c"
				gint _tmp6_;
				JsonArray* _tmp7_;
				JsonObject* object = NULL;
				JsonArray* _tmp8_;
				gint _tmp9_;
				JsonObject* _tmp10_;
				JsonObject* _tmp11_;
				GeeArrayList* _tmp12_;
				JsonObject* _tmp13_;
				FeedbinAPITagging _tmp14_ = {0};
				FeedbinAPITagging _tmp15_;
				FeedbinAPITagging _tmp16_;
#line 288 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!_tmp4_) {
#line 2556 "feedbinAPI.c"
					gint _tmp5_;
#line 288 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp5_ = i;
#line 288 "../plugins/backend/feedbin/feedbinAPI.vala"
					i = _tmp5_ + 1;
#line 2562 "feedbinAPI.c"
				}
#line 288 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp4_ = FALSE;
#line 288 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp6_ = i;
#line 288 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp7_ = array;
#line 288 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!(((guint) _tmp6_) < json_array_get_length (_tmp7_))) {
#line 288 "../plugins/backend/feedbin/feedbinAPI.vala"
					break;
#line 2574 "feedbinAPI.c"
				}
#line 290 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp8_ = array;
#line 290 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp9_ = i;
#line 290 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp10_ = json_array_get_object_element (_tmp8_, (guint) _tmp9_);
#line 290 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp11_ = _json_object_ref0 (_tmp10_);
#line 290 "../plugins/backend/feedbin/feedbinAPI.vala"
				object = _tmp11_;
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp12_ = taggings;
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp13_ = object;
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_tagging_init_from_json (&_tmp14_, _tmp13_);
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp15_ = _tmp14_;
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp16_ = _tmp15_;
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, &_tmp16_);
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_tagging_destroy (&_tmp15_);
#line 288 "../plugins/backend/feedbin/feedbinAPI.vala"
				_json_object_unref0 (object);
#line 2602 "feedbinAPI.c"
			}
		}
	}
#line 293 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = (GeeList*) taggings;
#line 293 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_array_unref0 (array);
#line 293 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 293 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp17_ = result;
#line 293 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_warn_if_fail (!gee_collection_contains ((GeeCollection*) _tmp17_, NULL), "!result.contains(null)");
#line 293 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2618 "feedbinAPI.c"
}


GeeList*
feedbin_api_get_entries (FeedbinAPI* self,
                         gint page,
                         gboolean only_starred,
                         GDateTime* since,
                         gint64* feed_id,
                         GError** error)
{
	GeeList* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* starred = NULL;
	gchar* _tmp1_;
	gchar* path = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	JsonNode* root = NULL;
	GeeArrayList* entries = NULL;
	GeeArrayList* _tmp27_;
	JsonArray* array = NULL;
	JsonNode* _tmp28_;
	JsonArray* _tmp29_;
	JsonArray* _tmp30_;
	GeeList* _tmp42_;
	GeeList* _tmp43_;
	GError * _inner_error_ = NULL;
#line 322 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 322 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_val_if_fail (page >= 0, "page >= 0", NULL);
#line 326 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (only_starred) {
#line 326 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = "true";
#line 2659 "feedbinAPI.c"
	} else {
#line 326 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = "false";
#line 2663 "feedbinAPI.c"
	}
#line 326 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 326 "../plugins/backend/feedbin/feedbinAPI.vala"
	starred = _tmp1_;
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = g_strdup_printf ("%i", page);
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp2_;
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = starred;
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = string_to_string (_tmp4_);
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = g_strconcat ("entries.json?per_page=100&page=", _tmp3_, "&starred=", _tmp5_, "&include_enclosure=true", NULL);
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = _tmp6_;
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp3_);
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
	path = _tmp7_;
#line 328 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (since != NULL) {
#line 2687 "feedbinAPI.c"
		GTimeVal t = {0};
		GTimeVal _tmp8_ = {0};
		gboolean _tmp9_;
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_get_current_time (&t);
#line 331 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp9_ = g_date_time_to_timeval (since, &_tmp8_);
#line 331 "../plugins/backend/feedbin/feedbinAPI.vala"
		t = _tmp8_;
#line 331 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_tmp9_) {
#line 2699 "feedbinAPI.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 333 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp10_ = path;
#line 333 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp11_ = g_time_val_to_iso8601 (&t);
#line 333 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp12_ = _tmp11_;
#line 333 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp13_ = g_strconcat ("&since=", _tmp12_, NULL);
#line 333 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp14_ = _tmp13_;
#line 333 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp15_ = g_strconcat (_tmp10_, _tmp14_, NULL);
#line 333 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 333 "../plugins/backend/feedbin/feedbinAPI.vala"
			path = _tmp15_;
#line 333 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (_tmp14_);
#line 333 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (_tmp12_);
#line 2726 "feedbinAPI.c"
		}
	}
#line 337 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (feed_id != NULL) {
#line 2731 "feedbinAPI.c"
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 338 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp16_ = g_strdup_printf ("%" G_GINT64_FORMAT, *feed_id);
#line 338 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp17_ = _tmp16_;
#line 338 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp18_ = path;
#line 338 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp19_ = string_to_string (_tmp18_);
#line 338 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp20_ = g_strconcat ("feeds/", _tmp17_, "/", _tmp19_, NULL);
#line 338 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (path);
#line 338 "../plugins/backend/feedbin/feedbinAPI.vala"
		path = _tmp20_;
#line 338 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp17_);
#line 2753 "feedbinAPI.c"
	}
	{
		JsonNode* _tmp21_ = NULL;
		const gchar* _tmp22_;
		JsonNode* _tmp23_;
		JsonNode* _tmp24_;
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp22_ = path;
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp23_ = feedbin_api_get_json (self, _tmp22_, &_inner_error_);
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp21_ = _tmp23_;
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
#line 2770 "feedbinAPI.c"
				goto __catch3_feedbin_error_not_found;
			}
			goto __finally3;
		}
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp24_ = _tmp21_;
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp21_ = NULL;
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
		__vala_JsonNode_free0 (root);
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
		root = _tmp24_;
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
		__vala_JsonNode_free0 (_tmp21_);
#line 2785 "feedbinAPI.c"
	}
	goto __finally3;
	__catch3_feedbin_error_not_found:
	{
		GError* e = NULL;
		GeeList* _tmp25_;
		GeeList* _tmp26_;
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
		e = _inner_error_;
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = NULL;
#line 347 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp25_ = gee_list_empty (FEEDBIN_API_TYPE_ENTRY, (GBoxedCopyFunc) feedbin_api_entry_dup, (GDestroyNotify) feedbin_api_entry_free);
#line 347 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = _tmp25_;
#line 347 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_error_free0 (e);
#line 347 "../plugins/backend/feedbin/feedbinAPI.vala"
		__vala_JsonNode_free0 (root);
#line 347 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (path);
#line 347 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (starred);
#line 347 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp26_ = result;
#line 347 "../plugins/backend/feedbin/feedbinAPI.vala"
		_vala_warn_if_fail (!gee_collection_contains ((GeeCollection*) _tmp26_, NULL), "!result.contains(null)");
#line 347 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 2815 "feedbinAPI.c"
	}
	__finally3:
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (starred);
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 2832 "feedbinAPI.c"
		} else {
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (starred);
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 2846 "feedbinAPI.c"
		}
	}
#line 350 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp27_ = gee_array_list_new (FEEDBIN_API_TYPE_ENTRY, (GBoxedCopyFunc) feedbin_api_entry_dup, (GDestroyNotify) feedbin_api_entry_free, NULL, NULL, NULL);
#line 350 "../plugins/backend/feedbin/feedbinAPI.vala"
	entries = _tmp27_;
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp28_ = root;
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp29_ = json_node_get_array (_tmp28_);
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp30_ = _json_array_ref0 (_tmp29_);
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
	array = _tmp30_;
#line 2861 "feedbinAPI.c"
	{
		gint i = 0;
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
		i = 0;
#line 2866 "feedbinAPI.c"
		{
			gboolean _tmp31_ = FALSE;
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp31_ = TRUE;
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
			while (TRUE) {
#line 2873 "feedbinAPI.c"
				gint _tmp33_;
				JsonArray* _tmp34_;
				JsonObject* object = NULL;
				JsonArray* _tmp35_;
				gint _tmp36_;
				JsonObject* _tmp37_;
				JsonObject* _tmp38_;
				FeedbinAPIEntry _tmp39_ = {0};
				JsonObject* _tmp40_;
				GeeArrayList* _tmp41_;
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!_tmp31_) {
#line 2886 "feedbinAPI.c"
					gint _tmp32_;
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp32_ = i;
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
					i = _tmp32_ + 1;
#line 2892 "feedbinAPI.c"
				}
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp31_ = FALSE;
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp33_ = i;
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp34_ = array;
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!(((guint) _tmp33_) < json_array_get_length (_tmp34_))) {
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
					break;
#line 2904 "feedbinAPI.c"
				}
#line 354 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp35_ = array;
#line 354 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp36_ = i;
#line 354 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp37_ = json_array_get_object_element (_tmp35_, (guint) _tmp36_);
#line 354 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp38_ = _json_object_ref0 (_tmp37_);
#line 354 "../plugins/backend/feedbin/feedbinAPI.vala"
				object = _tmp38_;
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp40_ = object;
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_entry_init_from_json (&_tmp39_, _tmp40_, &_inner_error_);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_propagate_error (error, _inner_error_);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (object);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_array_unref0 (array);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_object_unref0 (entries);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						__vala_JsonNode_free0 (root);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (path);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (starred);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						return NULL;
#line 2940 "feedbinAPI.c"
					} else {
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (object);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_array_unref0 (array);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_object_unref0 (entries);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						__vala_JsonNode_free0 (root);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (path);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (starred);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_clear_error (&_inner_error_);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
						return NULL;
#line 2960 "feedbinAPI.c"
					}
				}
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp41_ = entries;
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp41_, &_tmp39_);
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_entry_destroy (&_tmp39_);
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
				_json_object_unref0 (object);
#line 2971 "feedbinAPI.c"
			}
		}
	}
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = (GeeList*) entries;
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_array_unref0 (array);
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (path);
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (starred);
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp42_ = result;
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_warn_if_fail (!gee_collection_contains ((GeeCollection*) _tmp42_, NULL), "!result.contains(null)");
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2991 "feedbinAPI.c"
}


static guint
__lambda4_ (FeedbinAPI* self,
            gint64* n)
{
	guint result = 0U;
	GHashFunc _tmp0_;
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_int64_hash;
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp0_ (n);
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3007 "feedbinAPI.c"
}


static guint
___lambda4__gee_hash_data_func (gconstpointer v,
                                gpointer self)
{
	guint result;
	result = __lambda4_ ((FeedbinAPI*) self, (gint64*) v);
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3019 "feedbinAPI.c"
}


static gboolean
__lambda5_ (FeedbinAPI* self,
            gint64* a,
            gint64* b)
{
	gboolean result = FALSE;
	GEqualFunc _tmp0_;
#line 368 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_int64_equal;
#line 368 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp0_ (a, b);
#line 368 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3036 "feedbinAPI.c"
}


static gboolean
___lambda5__gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = __lambda5_ ((FeedbinAPI*) self, (gint64*) a, (gint64*) b);
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3049 "feedbinAPI.c"
}


static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
	dup = g_new0 (gint64, 1);
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
	memcpy (dup, self, sizeof (gint64));
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
	return dup;
#line 3063 "feedbinAPI.c"
}


static GeeSet*
feedbin_api_get_x_entries (FeedbinAPI* self,
                           const gchar* path,
                           GError** error)
{
	GeeSet* result = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp0_;
	JsonArray* array = NULL;
	JsonArray* _tmp1_;
	JsonArray* _tmp2_;
	GeeHashSet* ids = NULL;
	GeeHashSet* _tmp3_;
	GError * _inner_error_ = NULL;
#line 360 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 360 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 362 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = feedbin_api_get_json (self, path, &_inner_error_);
#line 362 "../plugins/backend/feedbin/feedbinAPI.vala"
	root = _tmp0_;
#line 362 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 362 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 362 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 362 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3097 "feedbinAPI.c"
		} else {
#line 362 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 362 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 362 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3105 "feedbinAPI.c"
		}
	}
#line 363 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = json_node_get_array (root);
#line 363 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _json_array_ref0 (_tmp1_);
#line 363 "../plugins/backend/feedbin/feedbinAPI.vala"
	array = _tmp2_;
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = gee_hash_set_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, ___lambda4__gee_hash_data_func, g_object_ref (self), g_object_unref, ___lambda5__gee_equal_data_func, g_object_ref (self), g_object_unref);
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
	ids = _tmp3_;
#line 3118 "feedbinAPI.c"
	{
		gint i = 0;
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
		i = 0;
#line 3123 "feedbinAPI.c"
		{
			gboolean _tmp4_ = FALSE;
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp4_ = TRUE;
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
			while (TRUE) {
#line 3130 "feedbinAPI.c"
				gint _tmp6_;
				JsonArray* _tmp7_;
				GeeHashSet* _tmp8_;
				JsonArray* _tmp9_;
				gint _tmp10_;
				gint64 _tmp11_;
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!_tmp4_) {
#line 3139 "feedbinAPI.c"
					gint _tmp5_;
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp5_ = i;
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
					i = _tmp5_ + 1;
#line 3145 "feedbinAPI.c"
				}
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp4_ = FALSE;
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp6_ = i;
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp7_ = array;
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!(((guint) _tmp6_) < json_array_get_length (_tmp7_))) {
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
					break;
#line 3157 "feedbinAPI.c"
				}
#line 371 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp8_ = ids;
#line 371 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp9_ = array;
#line 371 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp10_ = i;
#line 371 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp11_ = json_array_get_int_element (_tmp9_, (guint) _tmp10_);
#line 371 "../plugins/backend/feedbin/feedbinAPI.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, &_tmp11_);
#line 3169 "feedbinAPI.c"
			}
		}
	}
#line 373 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = (GeeSet*) ids;
#line 373 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_array_unref0 (array);
#line 373 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 373 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3181 "feedbinAPI.c"
}


GeeSet*
feedbin_api_get_unread_entries (FeedbinAPI* self,
                                GError** error)
{
	GeeSet* result = NULL;
	GeeSet* _tmp0_ = NULL;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GError * _inner_error_ = NULL;
#line 376 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_get_x_entries (self, "unread_entries.json", &_inner_error_);
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3208 "feedbinAPI.c"
		} else {
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3216 "feedbinAPI.c"
		}
	}
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp2_;
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp0_);
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3229 "feedbinAPI.c"
}


GeeSet*
feedbin_api_get_starred_entries (FeedbinAPI* self,
                                 GError** error)
{
	GeeSet* result = NULL;
	GeeSet* _tmp0_ = NULL;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GError * _inner_error_ = NULL;
#line 381 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_get_x_entries (self, "starred_entries.json", &_inner_error_);
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3256 "feedbinAPI.c"
		} else {
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3264 "feedbinAPI.c"
		}
	}
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp2_;
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp0_);
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3277 "feedbinAPI.c"
}


static void
feedbin_api_set_entries_status (FeedbinAPI* self,
                                const gchar* type,
                                GeeCollection* entry_ids,
                                gboolean create,
                                GError** error)
{
	JsonArray* array = NULL;
	JsonArray* _tmp0_;
	JsonObject* object = NULL;
	JsonObject* _tmp7_;
	JsonObject* _tmp8_;
	JsonArray* _tmp9_;
	JsonArray* _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* path = NULL;
	gchar* _tmp16_;
	JsonObject* _tmp17_;
	SoupMessage* _tmp18_;
	SoupMessage* _tmp19_;
	GError * _inner_error_ = NULL;
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (type != NULL);
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (entry_ids != NULL);
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_if_fail (!gee_collection_contains (entry_ids, NULL), "!entry_ids.contains(null)");
#line 389 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_array_new ();
#line 389 "../plugins/backend/feedbin/feedbinAPI.vala"
	array = _tmp0_;
#line 3314 "feedbinAPI.c"
	{
		GeeIterator* _id_it = NULL;
		GeeIterator* _tmp1_;
#line 390 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) entry_ids);
#line 390 "../plugins/backend/feedbin/feedbinAPI.vala"
		_id_it = _tmp1_;
#line 390 "../plugins/backend/feedbin/feedbinAPI.vala"
		while (TRUE) {
#line 3324 "feedbinAPI.c"
			GeeIterator* _tmp2_;
			gint64* id = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			JsonArray* _tmp5_;
			gint64* _tmp6_;
#line 390 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp2_ = _id_it;
#line 390 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 390 "../plugins/backend/feedbin/feedbinAPI.vala"
				break;
#line 3337 "feedbinAPI.c"
			}
#line 390 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp3_ = _id_it;
#line 390 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 390 "../plugins/backend/feedbin/feedbinAPI.vala"
			id = (gint64*) _tmp4_;
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp5_ = array;
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp6_ = id;
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
			json_array_add_int_element (_tmp5_, *_tmp6_);
#line 390 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (id);
#line 3353 "feedbinAPI.c"
		}
#line 390 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_object_unref0 (_id_it);
#line 3357 "feedbinAPI.c"
	}
#line 395 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = json_object_new ();
#line 395 "../plugins/backend/feedbin/feedbinAPI.vala"
	object = _tmp7_;
#line 396 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = object;
#line 396 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = array;
#line 396 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp10_ = _json_array_ref0 (_tmp9_);
#line 396 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_object_set_array_member (_tmp8_, type, _tmp10_);
#line 398 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (create) {
#line 3373 "feedbinAPI.c"
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 398 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp12_ = string_to_string (type);
#line 398 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp13_ = g_strconcat (_tmp12_, ".json", NULL);
#line 398 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp11_);
#line 398 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp11_ = _tmp13_;
#line 3384 "feedbinAPI.c"
	} else {
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 398 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp14_ = string_to_string (type);
#line 398 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp15_ = g_strconcat (_tmp14_, "/delete.json", NULL);
#line 398 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp11_);
#line 398 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp11_ = _tmp15_;
#line 3396 "feedbinAPI.c"
	}
#line 398 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp16_ = g_strdup (_tmp11_);
#line 398 "../plugins/backend/feedbin/feedbinAPI.vala"
	path = _tmp16_;
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp17_ = object;
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp18_ = feedbin_api_post_json_object (self, path, _tmp17_, &_inner_error_);
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp19_ = _tmp18_;
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp19_);
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (_tmp11_);
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_array_unref0 (array);
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3426 "feedbinAPI.c"
		} else {
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (_tmp11_);
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_array_unref0 (array);
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 399 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3442 "feedbinAPI.c"
		}
	}
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (path);
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp11_);
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_object_unref0 (object);
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_array_unref0 (array);
#line 3453 "feedbinAPI.c"
}


void
feedbin_api_set_entries_read (FeedbinAPI* self,
                              GeeCollection* entry_ids,
                              gboolean read,
                              GError** error)
{
	GError * _inner_error_ = NULL;
#line 402 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 402 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (entry_ids != NULL);
#line 402 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_if_fail (!gee_collection_contains (entry_ids, NULL), "!entry_ids.contains(null)");
#line 405 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_set_entries_status (self, "unread_entries", entry_ids, !read, &_inner_error_);
#line 405 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 405 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 405 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 405 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3480 "feedbinAPI.c"
		} else {
#line 405 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 405 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 405 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3488 "feedbinAPI.c"
		}
	}
}


void
feedbin_api_set_entries_starred (FeedbinAPI* self,
                                 GeeCollection* entry_ids,
                                 gboolean starred,
                                 GError** error)
{
	GError * _inner_error_ = NULL;
#line 408 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 408 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (entry_ids != NULL);
#line 408 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_if_fail (!gee_collection_contains (entry_ids, NULL), "!entry_ids.contains(null)");
#line 411 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_set_entries_status (self, "starred_entries", entry_ids, starred, &_inner_error_);
#line 411 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 411 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 411 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 411 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3517 "feedbinAPI.c"
		} else {
#line 411 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 411 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 411 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3525 "feedbinAPI.c"
		}
	}
}


GeeMap*
feedbin_api_get_favicons (FeedbinAPI* self,
                          GError** error)
{
	GeeMap* result = NULL;
	GError * _inner_error_ = NULL;
#line 414 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3539 "feedbinAPI.c"
	{
		JsonNode* root = NULL;
		JsonNode* _tmp0_;
		JsonNode* _tmp1_;
		JsonArray* array = NULL;
		JsonNode* _tmp3_;
		JsonArray* _tmp4_;
		JsonArray* _tmp5_;
		JsonArray* _tmp6_;
		GeeHashMap* favicons = NULL;
		GeeHashMap* _tmp8_;
#line 420 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = feedbin_api_get_json (self, "favicons.json", &_inner_error_);
#line 420 "../plugins/backend/feedbin/feedbinAPI.vala"
		root = _tmp0_;
#line 420 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3557 "feedbinAPI.c"
			goto __catch4_g_error;
		}
#line 421 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp1_ = root;
#line 421 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_tmp1_ == NULL) {
#line 3564 "feedbinAPI.c"
			GeeMap* _tmp2_;
#line 422 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp2_ = gee_map_empty (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref);
#line 422 "../plugins/backend/feedbin/feedbinAPI.vala"
			result = _tmp2_;
#line 422 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 422 "../plugins/backend/feedbin/feedbinAPI.vala"
			return result;
#line 3574 "feedbinAPI.c"
		}
#line 424 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp3_ = root;
#line 424 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp4_ = json_node_get_array (_tmp3_);
#line 424 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp5_ = _json_array_ref0 (_tmp4_);
#line 424 "../plugins/backend/feedbin/feedbinAPI.vala"
		array = _tmp5_;
#line 425 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp6_ = array;
#line 425 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_tmp6_ == NULL) {
#line 3588 "feedbinAPI.c"
			GeeMap* _tmp7_;
#line 426 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp7_ = gee_map_empty (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref);
#line 426 "../plugins/backend/feedbin/feedbinAPI.vala"
			result = _tmp7_;
#line 426 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_array_unref0 (array);
#line 426 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 426 "../plugins/backend/feedbin/feedbinAPI.vala"
			return result;
#line 3600 "feedbinAPI.c"
		}
#line 428 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp8_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 428 "../plugins/backend/feedbin/feedbinAPI.vala"
		favicons = _tmp8_;
#line 3606 "feedbinAPI.c"
		{
			gint i = 0;
#line 429 "../plugins/backend/feedbin/feedbinAPI.vala"
			i = 0;
#line 3611 "feedbinAPI.c"
			{
				gboolean _tmp9_ = FALSE;
#line 429 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp9_ = TRUE;
#line 429 "../plugins/backend/feedbin/feedbinAPI.vala"
				while (TRUE) {
#line 3618 "feedbinAPI.c"
					gint _tmp11_;
					JsonArray* _tmp12_;
					JsonObject* obj = NULL;
					JsonArray* _tmp13_;
					gint _tmp14_;
					JsonObject* _tmp15_;
					JsonObject* _tmp16_;
					gchar* host = NULL;
					JsonObject* _tmp17_;
					const gchar* _tmp18_;
					gchar* _tmp19_;
					const gchar* _tmp20_;
					gchar* favicon_encoded = NULL;
					JsonObject* _tmp21_;
					const gchar* _tmp22_;
					gchar* _tmp23_;
					const gchar* _tmp24_;
					GBytes* favicon = NULL;
					const gchar* _tmp25_;
					size_t _tmp26_ = 0;
					guchar* _tmp27_;
					GBytes* _tmp28_;
					GeeHashMap* _tmp29_;
					const gchar* _tmp30_;
					GBytes* _tmp31_;
#line 429 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (!_tmp9_) {
#line 3646 "feedbinAPI.c"
						gint _tmp10_;
#line 429 "../plugins/backend/feedbin/feedbinAPI.vala"
						_tmp10_ = i;
#line 429 "../plugins/backend/feedbin/feedbinAPI.vala"
						i = _tmp10_ + 1;
#line 3652 "feedbinAPI.c"
					}
#line 429 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp9_ = FALSE;
#line 429 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp11_ = i;
#line 429 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp12_ = array;
#line 429 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (!(((guint) _tmp11_) < json_array_get_length (_tmp12_))) {
#line 429 "../plugins/backend/feedbin/feedbinAPI.vala"
						break;
#line 3664 "feedbinAPI.c"
					}
#line 431 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp13_ = array;
#line 431 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp14_ = i;
#line 431 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp15_ = json_array_get_object_element (_tmp13_, (guint) _tmp14_);
#line 431 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp16_ = _json_object_ref0 (_tmp15_);
#line 431 "../plugins/backend/feedbin/feedbinAPI.vala"
					obj = _tmp16_;
#line 432 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp17_ = obj;
#line 432 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp18_ = json_object_get_string_member (_tmp17_, "host");
#line 432 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp19_ = g_strdup (_tmp18_);
#line 432 "../plugins/backend/feedbin/feedbinAPI.vala"
					host = _tmp19_;
#line 433 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp20_ = host;
#line 433 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (_tmp20_ == NULL) {
#line 434 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (host);
#line 434 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (obj);
#line 434 "../plugins/backend/feedbin/feedbinAPI.vala"
						continue;
#line 3694 "feedbinAPI.c"
					}
#line 435 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp21_ = obj;
#line 435 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp22_ = json_object_get_string_member (_tmp21_, "favicon");
#line 435 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp23_ = g_strdup (_tmp22_);
#line 435 "../plugins/backend/feedbin/feedbinAPI.vala"
					favicon_encoded = _tmp23_;
#line 436 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp24_ = favicon_encoded;
#line 436 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (_tmp24_ == NULL) {
#line 437 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (favicon_encoded);
#line 437 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (host);
#line 437 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (obj);
#line 437 "../plugins/backend/feedbin/feedbinAPI.vala"
						continue;
#line 3716 "feedbinAPI.c"
					}
#line 438 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp25_ = favicon_encoded;
#line 438 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp27_ = g_base64_decode (_tmp25_, &_tmp26_);
#line 438 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp28_ = g_bytes_new_take (_tmp27_, _tmp26_);
#line 438 "../plugins/backend/feedbin/feedbinAPI.vala"
					favicon = _tmp28_;
#line 439 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp29_ = favicons;
#line 439 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp30_ = host;
#line 439 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp31_ = favicon;
#line 439 "../plugins/backend/feedbin/feedbinAPI.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp29_, _tmp30_, _tmp31_);
#line 429 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_bytes_unref0 (favicon);
#line 429 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (favicon_encoded);
#line 429 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (host);
#line 429 "../plugins/backend/feedbin/feedbinAPI.vala"
					_json_object_unref0 (obj);
#line 3742 "feedbinAPI.c"
				}
			}
		}
#line 441 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = (GeeMap*) favicons;
#line 441 "../plugins/backend/feedbin/feedbinAPI.vala"
		_json_array_unref0 (array);
#line 441 "../plugins/backend/feedbin/feedbinAPI.vala"
		__vala_JsonNode_free0 (root);
#line 441 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 3754 "feedbinAPI.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GeeMap* _tmp32_;
#line 418 "../plugins/backend/feedbin/feedbinAPI.vala"
		e = _inner_error_;
#line 418 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = NULL;
#line 445 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp32_ = gee_map_empty (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref);
#line 445 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = _tmp32_;
#line 445 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_error_free0 (e);
#line 445 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 3773 "feedbinAPI.c"
	}
	__finally4:
#line 418 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 418 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_propagate_error (error, _inner_error_);
#line 418 "../plugins/backend/feedbin/feedbinAPI.vala"
		return NULL;
#line 3782 "feedbinAPI.c"
	} else {
#line 418 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 418 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_clear_error (&_inner_error_);
#line 418 "../plugins/backend/feedbin/feedbinAPI.vala"
		return NULL;
#line 3790 "feedbinAPI.c"
	}
}


const gchar*
feedbin_api_get_username (FeedbinAPI* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = self->priv->_username;
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp0_;
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3808 "feedbinAPI.c"
}


void
feedbin_api_set_username (FeedbinAPI* self,
                          const gchar* value)
{
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (g_strcmp0 (value, feedbin_api_get_username (self)) != 0) {
#line 3820 "feedbinAPI.c"
		gchar* _tmp0_;
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (self->priv->_username);
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
		self->priv->_username = _tmp0_;
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_object_notify_by_pspec ((GObject *) self, feedbin_api_properties[FEEDBIN_API_USERNAME_PROPERTY]);
#line 3830 "feedbinAPI.c"
	}
}


const gchar*
feedbin_api_get_password (FeedbinAPI* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = self->priv->_password;
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp0_;
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3848 "feedbinAPI.c"
}


void
feedbin_api_set_password (FeedbinAPI* self,
                          const gchar* value)
{
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (g_strcmp0 (value, feedbin_api_get_password (self)) != 0) {
#line 3860 "feedbinAPI.c"
		gchar* _tmp0_;
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (self->priv->_password);
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
		self->priv->_password = _tmp0_;
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_object_notify_by_pspec ((GObject *) self, feedbin_api_properties[FEEDBIN_API_PASSWORD_PROPERTY]);
#line 3870 "feedbinAPI.c"
	}
}


void
feedbin_api_subscription_init_from_json (FeedbinAPISubscription *self,
                                         JsonObject* object,
                                         GError** error)
{
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	GError * _inner_error_ = NULL;
#line 190 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (object != NULL);
#line 190 "../plugins/backend/feedbin/feedbinAPI.vala"
	memset (self, 0, sizeof (FeedbinAPISubscription));
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).id = json_object_get_int_member (object, "id");
#line 193 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_get_datetime_member (object, "created_at", &_inner_error_);
#line 193 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 193 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 193 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 193 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 193 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3908 "feedbinAPI.c"
		} else {
#line 193 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 193 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 193 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3916 "feedbinAPI.c"
		}
	}
#line 193 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 193 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 193 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).created_at);
#line 193 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).created_at = _tmp2_;
#line 194 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).feed_id = json_object_get_int_member (object, "feed_id");
#line 195 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = json_object_get_string_member (object, "title");
#line 195 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 195 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).title);
#line 195 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).title = _tmp4_;
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = json_object_get_string_member (object, "feed_url");
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).feed_url);
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).feed_url = _tmp6_;
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = json_object_get_string_member (object, "site_url");
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).site_url);
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).site_url = _tmp8_;
#line 190 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 (_tmp0_);
#line 3955 "feedbinAPI.c"
}


static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 3964 "feedbinAPI.c"
}


void
feedbin_api_subscription_copy (const FeedbinAPISubscription* self,
                               FeedbinAPISubscription* dest)
{
	gint64 _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gint64 _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = (*self).id;
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).id = _tmp0_;
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = (*self).created_at;
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _g_date_time_ref0 (_tmp1_);
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*dest).created_at);
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).created_at = _tmp2_;
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = (*self).feed_id;
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).feed_id = _tmp3_;
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = (*self).title;
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).title);
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).title = _tmp5_;
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = (*self).feed_url;
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).feed_url);
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).feed_url = _tmp7_;
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = (*self).site_url;
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).site_url);
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).site_url = _tmp9_;
#line 4022 "feedbinAPI.c"
}


void
feedbin_api_subscription_destroy (FeedbinAPISubscription* self)
{
#line 184 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).created_at);
#line 186 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).title);
#line 187 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).feed_url);
#line 188 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).site_url);
#line 4037 "feedbinAPI.c"
}


FeedbinAPISubscription*
feedbin_api_subscription_dup (const FeedbinAPISubscription* self)
{
	FeedbinAPISubscription* dup;
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	dup = g_new0 (FeedbinAPISubscription, 1);
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_subscription_copy (self, dup);
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	return dup;
#line 4051 "feedbinAPI.c"
}


void
feedbin_api_subscription_free (FeedbinAPISubscription* self)
{
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_subscription_destroy (self);
#line 182 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_free (self);
#line 4062 "feedbinAPI.c"
}


GType
feedbin_api_subscription_get_type (void)
{
	static volatile gsize feedbin_api_subscription_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_subscription_type_id__volatile)) {
		GType feedbin_api_subscription_type_id;
		feedbin_api_subscription_type_id = g_boxed_type_register_static ("FeedbinAPISubscription", (GBoxedCopyFunc) feedbin_api_subscription_dup, (GBoxedFreeFunc) feedbin_api_subscription_free);
		g_once_init_leave (&feedbin_api_subscription_type_id__volatile, feedbin_api_subscription_type_id);
	}
	return feedbin_api_subscription_type_id__volatile;
}


void
feedbin_api_tagging_init_from_json (FeedbinAPITagging *self,
                                    JsonObject* object)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 259 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (object != NULL);
#line 259 "../plugins/backend/feedbin/feedbinAPI.vala"
	memset (self, 0, sizeof (FeedbinAPITagging));
#line 261 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).id = json_object_get_int_member (object, "id");
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).feed_id = json_object_get_int_member (object, "feed_id");
#line 263 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_get_string_member (object, "name");
#line 263 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 263 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).name);
#line 263 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).name = _tmp1_;
#line 4101 "feedbinAPI.c"
}


void
feedbin_api_tagging_copy (const FeedbinAPITagging* self,
                          FeedbinAPITagging* dest)
{
	gint64 _tmp0_;
	gint64 _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 253 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = (*self).id;
#line 253 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).id = _tmp0_;
#line 253 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = (*self).feed_id;
#line 253 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).feed_id = _tmp1_;
#line 253 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = (*self).name;
#line 253 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 253 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).name);
#line 253 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).name = _tmp3_;
#line 4129 "feedbinAPI.c"
}


void
feedbin_api_tagging_destroy (FeedbinAPITagging* self)
{
#line 257 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).name);
#line 4138 "feedbinAPI.c"
}


FeedbinAPITagging*
feedbin_api_tagging_dup (const FeedbinAPITagging* self)
{
	FeedbinAPITagging* dup;
#line 253 "../plugins/backend/feedbin/feedbinAPI.vala"
	dup = g_new0 (FeedbinAPITagging, 1);
#line 253 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_tagging_copy (self, dup);
#line 253 "../plugins/backend/feedbin/feedbinAPI.vala"
	return dup;
#line 4152 "feedbinAPI.c"
}


void
feedbin_api_tagging_free (FeedbinAPITagging* self)
{
#line 253 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_tagging_destroy (self);
#line 253 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_free (self);
#line 4163 "feedbinAPI.c"
}


GType
feedbin_api_tagging_get_type (void)
{
	static volatile gsize feedbin_api_tagging_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_tagging_type_id__volatile)) {
		GType feedbin_api_tagging_type_id;
		feedbin_api_tagging_type_id = g_boxed_type_register_static ("FeedbinAPITagging", (GBoxedCopyFunc) feedbin_api_tagging_dup, (GBoxedFreeFunc) feedbin_api_tagging_free);
		g_once_init_leave (&feedbin_api_tagging_type_id__volatile, feedbin_api_tagging_type_id);
	}
	return feedbin_api_tagging_type_id__volatile;
}


void
feedbin_api_entry_init_from_json (FeedbinAPIEntry *self,
                                  JsonObject* object,
                                  GError** error)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GDateTime* _tmp10_ = NULL;
	GDateTime* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* _tmp13_ = NULL;
	GDateTime* _tmp14_;
	GDateTime* _tmp15_;
	GError * _inner_error_ = NULL;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (object != NULL);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	memset (self, 0, sizeof (FeedbinAPIEntry));
#line 310 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).id = json_object_get_int_member (object, "id");
#line 311 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).feed_id = json_object_get_int_member (object, "feed_id");
#line 312 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_get_string_member (object, "title");
#line 312 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 312 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).title);
#line 312 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).title = _tmp1_;
#line 313 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = json_object_get_string_member (object, "url");
#line 313 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 313 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).url);
#line 313 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).url = _tmp3_;
#line 314 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = json_object_get_string_member (object, "author");
#line 314 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 314 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).author);
#line 314 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).author = _tmp5_;
#line 315 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = json_object_get_string_member (object, "content");
#line 315 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 315 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).content);
#line 315 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).content = _tmp7_;
#line 316 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = json_object_get_string_member (object, "summary");
#line 316 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 316 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).summary);
#line 316 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).summary = _tmp9_;
#line 317 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp11_ = feedbin_api_get_datetime_member (object, "published", &_inner_error_);
#line 317 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp10_ = _tmp11_;
#line 317 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 317 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 317 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 317 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 4262 "feedbinAPI.c"
		} else {
#line 317 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 317 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 317 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 4270 "feedbinAPI.c"
		}
	}
#line 317 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp12_ = _tmp10_;
#line 317 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp10_ = NULL;
#line 317 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).published);
#line 317 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).published = _tmp12_;
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp14_ = feedbin_api_get_datetime_member (object, "created_at", &_inner_error_);
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp13_ = _tmp14_;
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_date_time_unref0 (_tmp10_);
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 4295 "feedbinAPI.c"
		} else {
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_date_time_unref0 (_tmp10_);
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 4305 "feedbinAPI.c"
		}
	}
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp15_ = _tmp13_;
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp13_ = NULL;
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).created_at);
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).created_at = _tmp15_;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 (_tmp13_);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 (_tmp10_);
#line 4320 "feedbinAPI.c"
}


void
feedbin_api_entry_copy (const FeedbinAPIEntry* self,
                        FeedbinAPIEntry* dest)
{
	gint64 _tmp0_;
	gint64 _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* _tmp13_;
	GDateTime* _tmp14_;
	GDateTime* _tmp15_;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = (*self).id;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).id = _tmp0_;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = (*self).feed_id;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).feed_id = _tmp1_;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = (*self).title;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).title);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).title = _tmp3_;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = (*self).url;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).url);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).url = _tmp5_;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = (*self).author;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).author);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).author = _tmp7_;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = (*self).content;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).content);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).content = _tmp9_;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp10_ = (*self).summary;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).summary);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).summary = _tmp11_;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp12_ = (*self).published;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp13_ = _g_date_time_ref0 (_tmp12_);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*dest).published);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).published = _tmp13_;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp14_ = (*self).created_at;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp15_ = _g_date_time_ref0 (_tmp14_);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*dest).created_at);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).created_at = _tmp15_;
#line 4408 "feedbinAPI.c"
}


void
feedbin_api_entry_destroy (FeedbinAPIEntry* self)
{
#line 300 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).title);
#line 301 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).url);
#line 302 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).author);
#line 303 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).content);
#line 304 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).summary);
#line 305 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).published);
#line 306 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).created_at);
#line 4429 "feedbinAPI.c"
}


FeedbinAPIEntry*
feedbin_api_entry_dup (const FeedbinAPIEntry* self)
{
	FeedbinAPIEntry* dup;
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	dup = g_new0 (FeedbinAPIEntry, 1);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_entry_copy (self, dup);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	return dup;
#line 4443 "feedbinAPI.c"
}


void
feedbin_api_entry_free (FeedbinAPIEntry* self)
{
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_entry_destroy (self);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_free (self);
#line 4454 "feedbinAPI.c"
}


GType
feedbin_api_entry_get_type (void)
{
	static volatile gsize feedbin_api_entry_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_entry_type_id__volatile)) {
		GType feedbin_api_entry_type_id;
		feedbin_api_entry_type_id = g_boxed_type_register_static ("FeedbinAPIEntry", (GBoxedCopyFunc) feedbin_api_entry_dup, (GBoxedFreeFunc) feedbin_api_entry_free);
		g_once_init_leave (&feedbin_api_entry_type_id__volatile, feedbin_api_entry_type_id);
	}
	return feedbin_api_entry_type_id__volatile;
}


static void
feedbin_api_class_init (FeedbinAPIClass * klass)
{
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_parent_class = g_type_class_peek_parent (klass);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_type_class_adjust_private_offset (klass, &FeedbinAPI_private_offset);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_feedbin_api_get_property;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_feedbin_api_set_property;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	G_OBJECT_CLASS (klass)->finalize = feedbin_api_finalize;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FEEDBIN_API_USERNAME_PROPERTY, feedbin_api_properties[FEEDBIN_API_USERNAME_PROPERTY] = g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FEEDBIN_API_PASSWORD_PROPERTY, feedbin_api_properties[FEEDBIN_API_PASSWORD_PROPERTY] = g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4488 "feedbinAPI.c"
}


static void
feedbin_api_instance_init (FeedbinAPI * self)
{
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	self->priv = feedbin_api_get_instance_private (self);
#line 4497 "feedbinAPI.c"
}


static void
feedbin_api_finalize (GObject * obj)
{
	FeedbinAPI * self;
	SoupSession* _tmp0_;
	guint _tmp1_;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FEEDBIN_API, FeedbinAPI);
#line 49 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = self->priv->m_session;
#line 49 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_signal_parse_name ("authenticate", soup_session_get_type (), &_tmp1_, NULL, FALSE);
#line 49 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _feedbin_api_authenticate_soup_session_authenticate, self);
#line 29 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (self->priv->m_session);
#line 30 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (self->priv->m_base_uri);
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (self->priv->_username);
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (self->priv->_password);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	G_OBJECT_CLASS (feedbin_api_parent_class)->finalize (obj);
#line 4525 "feedbinAPI.c"
}


GType
feedbin_api_get_type (void)
{
	static volatile gsize feedbin_api_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FeedbinAPIClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) feedbin_api_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FeedbinAPI), 0, (GInstanceInitFunc) feedbin_api_instance_init, NULL };
		GType feedbin_api_type_id;
		feedbin_api_type_id = g_type_register_static (G_TYPE_OBJECT, "FeedbinAPI", &g_define_type_info, 0);
		FeedbinAPI_private_offset = g_type_add_instance_private (feedbin_api_type_id, sizeof (FeedbinAPIPrivate));
		g_once_init_leave (&feedbin_api_type_id__volatile, feedbin_api_type_id);
	}
	return feedbin_api_type_id__volatile;
}


static void
_vala_feedbin_api_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	FeedbinAPI * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FEEDBIN_API, FeedbinAPI);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	switch (property_id) {
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		case FEEDBIN_API_USERNAME_PROPERTY:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_value_set_string (value, feedbin_api_get_username (self));
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		case FEEDBIN_API_PASSWORD_PROPERTY:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_value_set_string (value, feedbin_api_get_password (self));
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 4566 "feedbinAPI.c"
		default:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 4572 "feedbinAPI.c"
	}
}


static void
_vala_feedbin_api_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	FeedbinAPI * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FEEDBIN_API, FeedbinAPI);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	switch (property_id) {
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		case FEEDBIN_API_USERNAME_PROPERTY:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		feedbin_api_set_username (self, g_value_get_string (value));
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		case FEEDBIN_API_PASSWORD_PROPERTY:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		feedbin_api_set_password (self, g_value_get_string (value));
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 4599 "feedbinAPI.c"
		default:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 4605 "feedbinAPI.c"
	}
}



